1.16.x Changelog
36.2
====
 - 36.2.34 Add Gzip support to version checker (partial backport of #8148 from 1.17) (#8567)
 - 36.2.33 Readd patch (#7125)
 - 36.2.32 Account for `/forge setdimension` command arguments (#7971)
           Use the `/forge setdimension` command 'targets' argument and provide a default for the 'pos' argument as it's optional
 - 36.2.31 Clear local variable table on RuntimeEnumExtender transformation (#8340)
 - 36.2.30 Prevent setting window icon on OSX (#8468)
 - 36.2.29 [1.16] Fix entity type in conversion event to Drowned (#8480)
 - 36.2.28 Fix climbable hook to set lastClimbablePos field. Fixes #8370 (#8373)
 - 36.2.27 Merge values of defaulted optional tags (#8304)
           This fixes an error when a defaulted optional tag is defined in multiple places, eventually causing duplicate values in a map collector which then throws an exception.
 - 36.2.26 Bump ModLauncher to 8.1.3 (#8423)
 - 36.2.25 fix to use legacy keystore as java 8 doesn't support newer keystores generated by java 16 by default
 - 36.2.24 Implement teamcity project building on 1.16.z branch (#8440)
 - 36.2.23 ALso create parent directories when creating empty config files, 1.16 redux (#8366)
 - 36.2.22 (1.16) Fixed KeyMappings only checking if they conflict with themselves. (#8257)
 - 36.2.21 Backport #8254 to 1.16.5: Add RenderArmEvent to make overriding just the arm rendering not require copying nearly as much vanilla code (#8299)
 - 36.2.20 [CVE-2021-44228]: Update Log4J to fix the security issue inside it (#8270)
 - 36.2.19 Fix potential issue with BackgroundScanHandler for users with slow disc IO (#8211)
 - 36.2.18 Backport #8207 to 1.16 (#8209)
 - 36.2.17 [1.16.x] Add ForgeSpawnEggItem to lazily handle EntityTypes (#8150)
           * Add ForgeSpawnEggItem to lazily handle EntityTypes
           * Remove OnlyIn
           * Surround EntityType#spawn() call with try/catch
 - 36.2.16 change the AdvancementProvider to make it possabible for mods to hook into it (#7488)
           * back Port changes from #8120
 - 36.2.15 Implements Lazy ItemStack Capabilities (#7879)
 - 36.2.14 Pass IModelData through IForgeBakedModel#getModelData() before asking the IBakedModel for the particle texture (#8107)
 - 36.2.13 [1.16.x] Fix blocks with flammable material catching fire from lava when they are marked as non-flammable (#8161)
 - 36.2.12 [1.16] Add accessor to an unmodifiable view of the fullPots map in FlowerPotBlock (#8109)
           * Add accessor to an unmodifiable view of the fullPots map in FlowerPotBlock
           * Fix non-empty pot check
           * Remove exception from getter and add test mod
 - 36.2.11 Ensure that all render targets in a PostChain use the same format (#8138)
           Fixes #6995
 - 36.2.10 Make Broken Blocks Display Associated FluidState (#8129)
           Fixes #7253 for 1.16.x
 - 36.2.9  Implement GUI Stacking feature. (#6927)
           * Implement GUI Stacking feature.
           You can now use `mc.pushGuiLayer` and `mc.popGuiLayer` to manage the layers.
           mc.displayGuiScreen behaves such that if called with a non-null screen it replaces the entire stack, and if called with null it closes the entire stack.
           * Apply review comment fixes from 1.17 counterpart.
           * Revert unintended changes.
           * Missed these reverts.
 - 36.2.8  Add workaround for pairs of `'` being stripped (#8074)
           Backport of #8050
 - 36.2.7  Fix typo in FluidBlockWrapper (#7880)
 - 36.2.6  Backport MC-209819 (#7923)
           Backport fix for mc bug https://bugs.mojang.com/browse/MC-209819
 - 36.2.5  [1.16.5] Bump Mixin to 0.8.4 (#8098)
 - 36.2.4  [1.16.5] Backport OnDatapackSyncEvent from 1.17.1 (#7985)
 - 36.2.3  [1.16.x] Fix all layers of ItemLayerModel being fullbright (#8040)
           * Fix all layers of ItemLayerModel being fullbright
           Backport of #8039
           * Remove duplicate test resources
           These resources have corresponding equivalents in the generated tests
           resources folder.
 - 36.2.2  Fix rounding related errors with small entity pathfinding. Closes #7730
 - 36.2.1  Pass the 'includeName' flag to the ItemTossEvent (#7758)
 - 36.2.0  New 1.16.5 RB.

36.1
====
 - 36.1.66 ForgeGradle 5.1 and Gradle 7, which allows development on J16. Runtime still targets J8. (#7877)
 - 36.1.65 Work around javac scoping issue.
 - 36.1.64 Fix LAN worlds where registry entries have been removed.
 - 36.1.63 Fix FakePlayers having null `connection` and add FakePlayer test mod (#7733)
 - 36.1.62 Use '{assets_root}' rather than task output path for userdev config (#7873)
 - 36.1.61 Fix missing userdev config for datagen runs (#7871)
 - 36.1.60 Adds a damage float in Lightning Entity and patches Entity to use it. (#7849)
 - 36.1.59 Patch several mob classes to let them use modded versions of their ranged weapons (#7845)
 - 36.1.58 Add Fishing bobber projectile impact event (#7842)
 - 36.1.57 Removes misapplied patch in Entity (#7841)
 - 36.1.56 Removes misleading Nullable annotation from canCreatureSpawn (#7840)
 - 36.1.55 Corrects the assigning of mob kills, Fixes MC-121048 (#7836)
 - 36.1.54 Updates MouseHelper to allow for Horizontal Scroll to be recognized as Vertical Scroll (#7834)
 - 36.1.53 Fix entities losing their scoreboard data when they are unloaded (#7826)
 - 36.1.52 [1.16] Allow blocks other than beds or respawn anchors to act as respawn points  (#7824)
 - 36.1.51 Regen patches
 - 36.1.50 Add AT entries for DimensionSettings to make them easier for mods to work with (#7817)
 - 36.1.49 New hook to allow Trapdoors be climbable for custom ladders (#7816)
 - 36.1.48 Convenience change for potion enumeration - does not change patch size in any meaningful way! (#7811)
 - 36.1.47 Adds knockback attribute to players and updated knockback calculation to PlayerEntity#attack (#7806)
 - 36.1.46 Fix mod menu URL click bounds (#7804)
 - 36.1.45 Fix vanilla rotation/mirroring issues (#7803)
           Patch minecraft to fix MC-227255 and MC-134110, which are block
           rotation and mirroring issues.  I noticed this from problems with
           Structurize, but this probably affects any other mods that allow
           rotating or mirroring structures (as well as vanilla structure blocks).
 - 36.1.44 Synchronize `ResourcePackList#addPackFinder` (#7799)
 - 36.1.43 Fixes tryFluidTransfer_Internal to respect the FluidStack drainable when draining fluidSource. (#7782)
 - 36.1.42 Add IRecipeType parameter to burn time hooks (#7771)
 - 36.1.41 Use MobGriefingEvent for PiglinEntity when determining whether Piglins want to pick up items. (#7762)
 - 36.1.40 [1.16.x] Remove redundant mobgriefing check in SmallFireaballEntity. (#7761)
 - 36.1.39 Changed AbstractFurnaceTileEntity's canBurn and burn functions to use IRecipe's 'assemble' instead of 'getResultItem' (#7756)
 - 36.1.38 Bypass chunk future chain when processing loads and getChunk called. (#7697)
 - 36.1.37 Removed sidedness from PacketBuffer methods. (#7236)
           Affected methods:
           * readLongArray (x2)
           * readSectionPos
           * readString (no-arg variant)
 - 36.1.36 Add data generators for sounds.json (#6982)
 - 36.1.35 Add custom TextureAtlasSprite loaders (#7822)
           Adds a system for mods to specify custom texture loaders which can be requested by the resource pack through a metadata section in the .mcmeta file. Due to technical reasons, png file is still required for MC to identify a texture as existing, even if the loader doesn't use it.
 - 36.1.34 Fix PlayerGameModeEventTest and ForgeWorldTypeTest so they don't crash the dedicated server when running forge_test_server in forgedev (#7869)
 - 36.1.33 Add userdev to run config.
 - 36.1.32 Add truncation to FMLStatusPing to work around protocol limits (#7818)
 - 36.1.31 Remove ModelResourceLocation patch for SAS entry (#7813)
 - 36.1.30 Fix jar file path detection if the path contains a "!" (#7790)
 - 36.1.29 Add method to get the number of elements in a model builder (#7792)
 - 36.1.28 Fix vanilla packet splitter remote detection and add advancement packet splitting (#7802)
 - 36.1.27 Add option for linear filtering of text texture (#7645)
 - 36.1.26 Use empty model instead of missing model for non-existant layers in multilayer models (#7750)
           Fixes issues when using multi-layer models as part of composite models
 - 36.1.25 Add debug logging to packet compression encoder.
           Should make figuring out who is sending large packets easier.
           Disable with -Pforge.disablePacketCompressionDebug=true
 - 36.1.24 Removed signature line from mod list screen. #7500
 - 36.1.23 Reinstate the MinecartCollisionHandler field to AbstractMinecartEntity (#7748) Closes #7506.
 - 36.1.22 Fix PlayerEvent.BreakSpeed's pos being nullable. (#7747) Closes #7615.
 - 36.1.21 Fix OBJ Loader data gen string (#7746) Closes #7616
 - 36.1.20 Add an event similar to PlayerEvent.NameFormat but for the name shown in the tab list. (#7740)
 - 36.1.19 Fix filling buckets with fluids without bucket items consuming the fluid (#7745) Closes #7670
 - 36.1.18 Work around crash while loading flatworld with modded structures. (#7764)
           * Work around crash while loading flatworld with modded structures.
           * Maybe fix issue with gradle daemon leaking memory and slowing down CI builds.
 - 36.1.17 Update Forge to Gradle 6.9
 - 36.1.16 Add barrels and barrels/wooden block and item tag (#7676)
 - 36.1.15 Fix shears not properly breaking tripwire (MC-129055) (#7718)
 - 36.1.14 Fix Line endings in tooltips not handled properly in multiplayer screen Closes #7738 (#7739)
 - 36.1.13 Fix cats, phantoms and pillagers saying they're at BlockPos.ZERO during LivingSpawnEvent.CheckSpawn (#7722)
 - 36.1.12 [1.16] Add missing Multipart Blockstate Builder feature: Nested condition groups (#7677)
 - 36.1.11 Pass BlockPos to BlockParticleData used for "fall impact" particle (#7705)
 - 36.1.10 Check version ranges of optional dependencies when present (#7710)
           If an optional dependency is present, but it does not conform to the version range,
           it will now error out in the same fashion as missing required dependencies, instead
           of a more cryptic error down the line due to a missing method/class/field/etc.
           Implements and closes #7696
 - 36.1.9  Fix ClientVisualization crashing on systems without monitors (#7719)
 - 36.1.8  Fix Furnace Minecarts going faster then vanilla (#7725)
 - 36.1.7  Update for Forge's new maven (#7723)
 - 36.1.6  A bloody quote FFS
 - 36.1.5  Update for new maven
 - 36.1.4  Fix broken java9hacks for j16 handling..
 - 36.1.3  Add generic EntityTeleportEvent (#7694)
 - 36.1.2  Restore SS version, fixes findFieldInstanceChecks
 - 36.1.1  Fix sign textures being stitched onto every texture atlas (#7690)
 - 36.1.0  Fix AT order, missed exec line and bump for RB.

36.0
====
 - 36.0.61 Fix wrong eye height when entity size changes (esp. baby animals) (#7628)
 - 36.0.60 Allow ITeleporter to override the vanilla teleport sound (#7682)
 - 36.0.59 Fix datapack exception related to EnumArgument with siblings (#7686)
           Invalid enum constants are now properly thrown as a CommandSyntaxException
 - 36.0.58 Add support for custom WoodTypes (#7623)
 - 36.0.57 Use JGit instead of GrGit now that jcenter is going away.
           Update missed mapped name in MDK.
 - 36.0.56 Bump nashorn wrapper version.
 - 36.0.55 Fix yet another copypasta.
 - 36.0.54 Fix incorrectly replaced SRG names
 - 36.0.53 Fix potential Deadlock when using custom Item entities. (#7532)
           Be careful when adding Entities during Chunk Load (#7519)
 - 36.0.52 Fix copypasta.
 - 36.0.51 Automatically fix some issues with configurations deemed invalid for simple reasons (#7671)
 - 36.0.50 Add coremod that injects bouncer methods to work around name conflicts with official names.
           Fixes a binary break.
 - 36.0.49 Bump SpecialSource
 - 36.0.48 Bulk update license year, and use replacement variable so that the current year is always used.
 - 36.0.47 Introduce a new feature that lets mods know if optional mods and optional network channels are present in the remote.
           Allow connections from forge versions that don't have the vanilla splitter.
 - 36.0.46 Regenerate patches with relative headers. This should lower conflicts in future PRs.
           Convert Forge to use Official mappings.
           Mojang released their obfuscation mappings but we have not used them up until now due to wanting to get their license to be more explicitly permissive.
           It is clear that their intent is to allow us to use their names for developing mods like this.
           See the full wording, and our interpretation here: https://github.com/MinecraftForge/MCPConfig/blob/master/Mojang.md
 - 36.0.45 Update to FG4, and Gradle 6.8.
 - 36.0.44 Support splitting vanilla packets that are too large on forge<->forge connections (#7485)
           Currently only for SUpdateRecipesPacket and STagsListPacket that blow up with huge datapacks
 - 36.0.43 Fix a few places where the vanilla method was being called instead of the forge one (#7535)
           Cleanup javadocs references slightly, fix a couple spots not using the proper forge hooks, and remove a couple unneeded patches
           Update deprecation comment on isAir
 - 36.0.42 Add Opacity to ForgeHooksClient#renderMainMenu (#7660)
 - 36.0.41 Add support for caching of configuration values. (#7608)
 - 36.0.40 Added entity attribute setup and creation events
 - 36.0.39 Fix updateItemStackNBT not properly being called (#7646)
           Re-added ItemStack delegate redirect transformer
 - 36.0.38 Fix a few FluidUtil issues that were causing DispenseFluidContainer to not function properly (#7422)
 - 36.0.37 Add a way to specify a custom background texture with namespaces in the Creative GUI. (#7404)
 - 36.0.36 Fixed Configs not correcting when hot-loaded from changes on disk (#7427)
 - 36.0.35 Reduce default logging markers in the MDK. Modders can re-enable these for better debugging.  (#7432)
           Modders PLEASE read your damn log, and fix the errors we point out. Spamming modpacks with stack traces is just lazy programming.
 - 36.0.34 Deprecate Forge's setdimension command, vanilla execute command can do this now. (#7459)
 - 36.0.33 Fix ItemTextureQuadConverter.convertTexture generating wrong quads, fixes #7620 (#7650)
 - 36.0.32 Added MultipartBakedModel.getModelData(). (#7595)
           This allows custom IBakedModel implementations to use the IModelData provided by their IBakedModel.getModelData() when used in the context of a multipart model.
 - 36.0.31 fix global cache not being a block render type (#7648)
 - 36.0.30 Allow mods to use additional custom LootParameter when querying existing loot tables (#7515)
 - 36.0.29 Add ForgeHooks.canEntitySpawn to Cat, Phantom, and Patrol spawners. (#7569)
 - 36.0.28 Fix/Replace player visibility event (#7573)
 - 36.0.27 Fix: Clear the last error from glfwInit to prevent vanilla from throwing an exception later in the chain when glfw errors. (#7587)
 - 36.0.26 Fix MC-181464 persisting for modded shields (#7602)
 - 36.0.25 FIx race condition in LazyOptional (#7611)
 - 36.0.24 [1.16.5] Fix shaders breaking almost every overlay that uses textures, fixes #7575 (#7624)
 - 36.0.23 Disable syncing of Feature and Biome registries  (#7639)
 - 36.0.22 Add IExtensibleEnum to GrassColorModifier (#7641)
 - 36.0.21 Log stacktraces in NettyPacketEncoder. (#7654)
 - 36.0.20 Lower logging level for datafixer warning to debug (#7636)
 - 36.0.19 Reintroduce forge's chunk manager to allow mods to force chunks with either a block position or entity (UUID) "owner" and have them properly persist between restarts (#7642)
 - 36.0.18 Fix two places where querying an object for the new "valid" capability from a capability invalidation listener could cause the object to return the old invalid capability. (#7643)
 - 36.0.17 Fix config spec in cases of enum class discrepancies (#7635)
 - 36.0.16 Fix onBlockAdded being called twice for ItemEntity placing non-TE blocks (#7607)
 - 36.0.15 Prevent NullPointerException when adding new loot pool. (#7605)
 - 36.0.14 Added generic multi part entity API (#7554)
 - 36.0.13 Fix IAngerable entities crashing when reading nbt on client (#7618)
 - 36.0.12 [1.16.x] Add loot table ID in Global Loot Modifiers (#7428)
 - 36.0.11 Add a block tag to allow mods to blacklist blocks endermen should not be able to place blocks on top of, similar to how vanilla hardcodes against them being able to place things on bedrock (#7548)
 - 36.0.10 Fix translucent model parts of MultiLayerModels rendering as missing models due to differing rendertypes when rendering block model (#7579)
 - 36.0.9  Fix existing file tag provider support looking in the wrong folder for custom tag types (#7576)
 - 36.0.8  Propery re-encode registries (#7629)
 - 36.0.7  Properly encode registries. (#7626)
 - 36.0.6  Inject vanilla dimensions inside worlds missing them (#7599)
 - 36.0.5  Introduce a new field_to_instanceof transformer to reduce some simple patches.
 - 36.0.4  Fix broken build.
 - 36.0.3  Add modded biomes to overworld biome list (#7360)
 - 36.0.2  Fix dynamic registries not getting ids assigned correctly from old worlds in specific unordered value insertions. Closes #7586
 - 36.0.1  Optionally add a milk fluid to the vanilla bucket (#7294)
           Fixes the previous broken code that was supposed to make mod registered milk returned by the vanilla bucket by allowing mods to enable a milk fluid.
 - 36.0.0  1.16.5 Initial Update.

35.1
====
 - 35.1.39 Update Coremods, ASM, and include standalone Nashorn to load on J15.
 - 35.1.38 Introduce a new field_to_instanceof transformer to reduce some simple patches.
 - 35.1.37 Update Coremods, ASM, and include standalone Nashorn to load on J15.
 - 35.1.36 Added IWeatherParticleRenderHandler to allow a mod to take control over weather particles and sounds. (#7522)
 - 35.1.35 Allow Chunk loading Tickets to opt-into forcing chunk ticks. (#7525)
 - 35.1.34 Fix crash when mods add goals to skeleton horses (MC-206338) (#7509)
 - 35.1.33 Set WM_CLASS and WM_INSTANCE_NAME for early progress window (#7534)
 - 35.1.32 Make UnboundedMapCodec more lenient in decoding dimensions. Fixes MC-197860 (#7527)
 - 35.1.31 Fix FML's Config Sync packet not allowing same length filenames in encoder and decoder. Closes #7584
 - 35.1.30 Prevent NPE and deprecated MissingMappings.getMappings function. Closes #6252
 - 35.1.29 Fix entities not correctly being able to be ridden under water.
 - 35.1.28 Fix crash when beehive is broken by fake player (#7566)
 - 35.1.27 Add supplier variant to `AbstractBlock.Properties#lootFrom` (#7563)
 - 35.1.26 Fix ModFileResourcePack.getAllResourceLocations ignoring resourceNamespace. (#7562)
           Fixes #7405
 - 35.1.25 Fix missing serializers when deserializing global loot modifiers (#7561)
 - 35.1.24 Fix VanillaConnectionNetworkFilter sending out invalid entity properties packets without an entity ID (#7560)
 - 35.1.23 Make shear interactions extend to subclasses (#7544)
 - 35.1.22 Add a SoundType subclass that uses suppliers (#7538)
 - 35.1.21 Fix compound ingredient in shapeless recipes (#7537) Fixes #7530
 - 35.1.20 Fix potential NPE in ForgeHooks.onItemPlaceIntoWorld when passing in null player. (#7505)
 - 35.1.19 Fix modded PointOfInterestType's not populating blockstate map when registered (#7503)
 - 35.1.18 Add new LivingConversionEvent to control mobs turning into other mobs. (#7386)
 - 35.1.17 Add ItemAttributeModifierEvent (#7484)
 - 35.1.16 Fix RightClickBlock ALLOW not being implemented (#7426)
 - 35.1.15 Quiet down errors related to modders not changing their update urls from the default.
 - 35.1.14 Make mod data packs able to be disabled. It'll break things, but that's on you. Closes #6776
 - 35.1.13 Add generated resource tracking to ExistingFileHelper
 - 35.1.12 Fix BlockStateProvider item models not knowing about block models
           Add tests for this case
 - 35.1.11 Override invalidateCaps instead of remove for vanilla TE capability invalidation (#7536)
           Properly invalidate patched in vanilla TE caps in invalidateCaps instead of remove so that they get invalidated on chunk unload
 - 35.1.10 Make TEs invalidate capabilities when the chunk they are in unloads (#7529)
           Fixed LazyOptional potentially notifying invalidation listeners multiple times.
 - 35.1.9  Fixed entity navigation to stop entities spinning - MC-94054 (#7520)
 - 35.1.8  Fix wrong function call in BlockStateProvider::horizontalFaceBlock (#7514)
 - 35.1.7  Fix datagen order of multipart conditions being unstable
 - 35.1.6  Fix forge config option for default world type not applying unless you change the default world type (#7521)
 - 35.1.5  Implement feature for mods to define new world types (#7448)
           * Mods can now register world types via a new forge registry, and optionally register a settings screen to tweak them.
             * The default world type for dedicated servers and singleplayer world creation is configurable via forge's common config.
 - 35.1.4  Fix dimType not encode to registries (#7513)
 - 35.1.3  Add support for referencing forge's resources and specifying existing mods to data generators (#7456)
 - 35.1.2  Fix #6692
           Thanks @AterAnimAvis for help and suggestions
 - 35.1.1  Fix translucent blocks not rendering properly when moved by pistons on fabulous (#7441)
 - 35.1.0  Bump version for RB.

35.0
====
 - 35.0.22 Fix food bar not rendering when non-living entities are mounted (#7446)
 - 35.0.21 Fix MC-194811 - Removing structures causes chunk save errors.
 - 35.0.20 Fix concurrency issue in StartupMessageManager (#7483)
 - 35.0.19 Fix forge registry types that have private constructors (BlockStateProviderType, BlockPlacerType, FoliagePlacerType, TreeDecoratorType) (#7482)
 - 35.0.18 Fix problem where the absence of forge and MC in later loading triggered a weird crash.
 - 35.0.17 Fix NPE problem when modid is mismatched.
 - 35.0.16 Return the processed modlist data to the upstream system, not the raw unprocessed data. Should resolve the problem
           that mixin complains about missing info when it's in a "crashed" situation.
 - 35.0.15 Fix dims on servers not loading the first run (#7445)
 - 35.0.14 Allow for custom argument types by filtering them on vanilla connections (#7463)
 - 35.0.13 Add Player context to AnvilUpdateEvent (#7442)
 - 35.0.12 Don't overwrite PlayerAdvancement's player with a fake one (#7454)
           If a FakePlayer is constructed with the same UUID/GameProfile as a
           currently active player, the player object within PlayerAdvancement is
           set to the fake player.
           As fake players cannot receive advancements (see grantCriterion), this
           prevents the actual player from receiving any advancements until they
           change dimension/relog.
 - 35.0.11 Add BannerBlock.forColor to SAS to fix banner.toItem() on servers.
 - 35.0.10 Call Harvest check event even if the block doesn't require any tool (#7414)
 - 35.0.9  Use linked collections to stabilize order when adding new registry entries.
 - 35.0.8  Render local player when the renderViewEntity is not the local player (#7216)
 - 35.0.7  Some help in ExtensionPoint regarding DISPLAYTEST. Let's improve those tick rates!
 - 35.0.6  Handle erroring during early mod construction phases, and actually report that into the error UI
           by doing armslength exception handling and propagation.
 - 35.0.5  Support backwards loading 1.16.3 mods in 1.16.4, because we are able to do that. Tweak loading a bit to be smarter about dependency errors of various kinds.
 - 35.0.4  Add FluidStack codec, and a test mod that verifies its behaviour matches the existing write/read logic.
           Add missing license headers.
 - 35.0.3  Update event bus version (should be 3.0.5)
           Tweak MDK to automatically populate recommended values for things like forge version, loader version and minecraft version.
 - 35.0.2  Workaround for modded attributes on vanilla entities logging warnings on vanilla clients
           Switch to a handler-based approach per packet class, simplify patch, add some docs
           Add license header and docs
           Switch to a network handler based approach
           Switch to a network handler based approach
           revert build gradle change
           Simplify Packet patch
           Add license header to IForgePacket
           Revert ForgeHooks changes
           Less hacky and more generic way to filter packets for vanilla connections
           _Actually_ Order SAS.
           It's early
           Order SAS
           simplify vanilla connection check
           Remove unneeded import change
 - 35.0.1  Fix early sorting bug that meant the file deduping was causing an error, to, well, not cause it, so we can get to an error screen.
 - 35.0.0  1.16.4 Initial Update

34.1
====
 - 34.1.42 Fix Biomes not properly copying over ids loaded from the save to the new Dynamic Registry.
 - 34.1.41 Introduce custom loader additions to the model data generators. (#7450)
           Currently implemented loaders:
           * OBJ
           * Composite
           * Multi-layer
           * Item layers (vanilla item/generated but with fullbright texture support)
           * Bucket
           * Separate Perspective
 - 34.1.40 actually rollback on error in registry events.
 - 34.1.39 Fix config parse failure causing crash in building exception message. fixes #7438
 - 34.1.38 Auto-detect ansi support for log4j2
           move to fml.loading subpackage
           Add license header
 - 34.1.37 Return client resources even if no data pack found on server. Closes #6225 (Pull request)
 - 34.1.36 Update modlauncher. fixes #7452
 - 34.1.35 Fix (NonNull)Lazy.Concurrent using a global lock (#7403)
           * Fix Lazy.Concurrent using a global lock, thus preventing multiple threads from resolving independent Lazy's at the same time
           * Use Lazy with an added null check to implement NonNullLazy
 - 34.1.34 Update forge mappings to 20201028-1.16.3 (#7435)
 - 34.1.33 Fix breaking changes from the Biome rename PR #7434 (#7439)
 - 34.1.32 Reimplement nametag distance attribute, fix attribute translation keys (#7387)
 - 34.1.31 Fix data pack biomes failing to load in SingleBiomeProvider (#7434)
 - 34.1.30 Add in proper handling of equals and hashcode for modjar urls. Fixes very slow loading on windows.
 - 34.1.29 Force 8.0.5 ML
 - 34.1.28 Restore FingerprintViolationEvent with appropriate THIS IS F*CKING DEAD DELET WARNINGS.
           Also, notify in UI if using legacy JDK without capability to read out security data from mod jars.
 - 34.1.27 Add signature reporting for mods, using new signature capture from ModLauncher. Need to figure out
           how to reflect Minecraft's JAR signatures into here.
 - 34.1.26 Rollback registries to vanilla state if something happens during loading, so subsequent activities can still run and not generate false reports..
 - 34.1.25 Fix mcp_snapshot mapping issue causing unneeded patches. Closes #7424
 - 34.1.24 Fix resource leak in the OBJ loader.
 - 34.1.23 Fix issue with ITeleporter allowing easier use of vanilla logic. (#7317)
 - 34.1.22 Adds tag support for Enchantments, Potions, and TileEntityTypes (#7379)
 - 34.1.21 Resuscitate BiomeDictionary using RegistryKeys instead of biome references.
 - 34.1.20 Add event for player changing game mode (#7355)
 - 34.1.19 Fix RCON multipacket responses not actually understanding UTF8.
 - 34.1.18 Fix RCON not sending newlines in output for multiline. Fixes https://bugs.mojang.com/browse/MC-7569, a very old bug that is really annoying if you use RCON.
 - 34.1.17 Fix Texture Presence String (#7408)
 - 34.1.16 Fix typo causing potential error in vine growth. Closes #7406
           Sort missing registry dumps by name, making it easier to read.
 - 34.1.15 Fixed conditional advancement loading when using the "advancements" array.
           Added automatic generation of conditional advancements from the criteria in the conditional recipe entries.
           Added advancement name calculation from the recipe ID.
 - 34.1.14 Additions to the mdk build.gradle to accommodate datagens. (#7398)
 - 34.1.13 Added Basic Class-Level SAS Capability to checkSAS, added Vector4f to SAS (#7385)
 - 34.1.12 Add hooks to allow modification of structures spawn lists (#7344)
 - 34.1.11 Add back patches to Screen allowing for item tooltips to be auto wrapped again (#7378)
           Only deals with the methods receiving an ItemStack or ITextComponent(s), the methods that take IReorderingProcessor(s) are left alone.
 - 34.1.10 Bump mixin version to 0.8.2
 - 34.1.9  Add in extra debug logging
 - 34.1.8  Remove redundant call to CrashReport generator - Vanilla is doing a crashreport for itself at startup now.
           Add a UUID into crashreport that is also logged in all channels at crash report generation time. This will allow to associate crash reports and the logs.
 - 34.1.7  Fix doc README and answer lex's question
 - 34.1.6  Modify how ModLoadingStage handles dispatch to Registry Events. Stops the objectholder spam and generally improves performance on larger packs.
 - 34.1.5  Added "Bukkit Plugin" to InvalidModIdentifier (#7384)
 - 34.1.4  Fix vanilla Campfire smoke bug. MC-201374 (#7381)
 - 34.1.3  Fix toggleable keybindings still being active while in GUI Fixes #7370 (#7373)
 - 34.1.2  Fix modded EntityClassifications not being useable in the codec. (#7337)
 - 34.1.1  Support effective materials of vanilla AxeItem (#7351)
 - 34.1.0  Prep new RB.

34.0
====
 - 34.0.21 Fix grass disappearing when alwaysSetupTerrainOffThread is true (#7291)
 - 34.0.20 Accessors for inspecting and removal of biome generation settings. Fixed carvers still being immutable. (#7339)
 - 34.0.19 Revive BiomeManager and BiomeLayer hooks.
 - 34.0.18 Fix a few minor issues with custom tag types and fix OptionalNamedTags (#7316)
 - 34.0.17 Fix ToggleableKeyBinding differences to vanilla. (#7338)
 - 34.0.16 Fix forge light pipeline applying block offsets twice (#7323)
 - 34.0.15 Updated build badge versions to 1.16.3 in readme (#7325)
 - 34.0.14 Add a better license error screen (#7350)
 - 34.0.13 Fixed container item being consumed in brewing stand. #7307 (#7314)
 - 34.0.12 Fix parse results of CommandEvent being disregarded (#7303)
 - 34.0.11 [1.16] Fix possible crash when using rendering regionCache (#7207)
 - 34.0.10 [1.16] Reimplement ICloudRenderHandler, ISkyRenderHandler and IWeatherRenderHandler (#6994)
 - 34.0.9  Make Biome.Climate and BiomeAmbiance fields accessible (#7336)
 - 34.0.8  Use mixin 0.8.1. Should fix problems with mixin not working properly with latest modlauncher.
 - 34.0.7  Sets the empty/fill sounds for vanilla fluids.
           Use Fluid's fillSound rather than emptySound when filling buckets.
 - 34.0.6  Add MatrixStack-aware alternatives to the methods in GuiUtils (#7127)
 - 34.0.5  Fix json biomes not setting registry name correctly for the BiomeLoadingEvent. (#7329)
 - 34.0.4  Fix inconsistencies in how the values from the model are passed into the baked model.
           This puts them in line with vanilla, as intended.
 - 34.0.3  Reimplemented drawHoveringText (#7268)
 - 34.0.2  New BiomeLoadingEvent that allows modders to edit biomes as they are being deserialized.
 - 34.0.1  Bump MCP version for lambda issue.
 - 34.0.0  1.16.3 Update
           Also included a bunch of warning cleanups.

33.0
====
 - 33.0.59 Fix tile entities being replaced when not needed. (#7318)
 - 33.0.58 Fix exception when getting rendering box for tile entities with no collision boxes. (#7301)
 - 33.0.57 More crash reporting tweaks. Don't crash when trying to show warnings. Also, put the exception name in the error screen on the second line!
 - 33.0.56 Fix Minecart speed cap on rail being initialized to 0 (#7315)
 - 33.0.55 Add support for custom tag types (#7289)
 - 33.0.54 More crash report tweaks. Put a button to open the generated crash report on the error screen, tweak formatting of crash report, and add the enhanced stack trace data (transformers et al)
 - 33.0.53 New hook for better custom scaffolding movement (#7261)
 - 33.0.52 Fixed crash with zip paths (#7300)
 - 33.0.51 Fix custom teleporters NPE (#7296)
 - 33.0.50 Prevent duplicate wrapper tags from crashing (#7283)
 - 33.0.49 Add partialTicks to RenderNameplateEvent (#7277)
 - 33.0.48 Fixing logic in getCurrentRailPosition to correctly identify the rail… (#7276)
 - 33.0.47 [1.16.x] Fixes for Bamboo, Enchantments and Conduits, small adjustments to bring some patches closer to the vanilla code. (#7239)
 - 33.0.46 Bump resource pack version to 6 (#7299)
 - 33.0.45 Remove dead ForgeHooks.canToolHarvestBlock function. (#7262)
 - 33.0.44 Re-implement DrawHighlightEvent$HighlightEntity Firing (#7233)
 - 33.0.43 Reimplement FarmlandWaterManager (#7213)
 - 33.0.42 Add dataprovider for Global Loot Modifiers (#6960)
 - 33.0.41 Fix crash when dumping crash report for an exception that has a null cause (#7308)
 - 33.0.40 Tweak crash report dump to visit all the causes up to the top.
 - 33.0.39 Fix ExplodedDirectoryLocator visiting non-existent paths. Closes #7203
           Also, bump modlauncher to 7.0.1 to fix resources.
 - 33.0.38 Fix some potential issues in crash dumping during mod loading
 - 33.0.37 Park the polling thread for a bit, if we're not the one driving the task list forwards. This allows for the actual driver to work on low cpu count machines.
 - 33.0.36 Use new enumeration mechanism in ModLauncher, to allow getResources to work. This enables serviceloader-in-mods, and other stuff that might need to visit multiple mod jars. Also, tweaked the visitor code slightly, may result in a trivial performance change. Closing #7302 as it's not really relevant any more.
 - 33.0.35 Fix compiler issue in eclipse properly
 - 33.0.34 Fix crash caused by previous commit (#7298)
 - 33.0.33 Dirty casting hacks to fix eclipse compiler inference issue. I'm sorry cpw.
 - 33.0.32 Fix broken ExistingFileHelper import
           Add licenses to some new files
 - 33.0.31 Add validation via resources for tag providers (#7271)
           BREAKING CHANGE: Moved ExistingFileHelper to common package
           Remove various workarounds from forge tag providers
 - 33.0.30 Move the "modloading" thread activity onto _our_ worker pool. It turns out that the vanilla worker pool can deadlock during stitching if it's insufficiently large, if modloader "waitForTransition" is also a worker member of that pool.
           Closes #7293 (to reproduce issue easily, modify Util.func_240979_a_ and change the values in the MathHelper.clamp call). I've verified that 3 and below for "max" cause the problem. (I didn't test a whole range of values, just sufficient to reproduce problem and verify fix). Note that setting it to zero (and using the "direct executor" that's inaccessible in normal operation) works as well with this fix.
 - 33.0.29 Fix missed debugging code. Read the config from the config.
 - 33.0.28 Fix up slight registry change and other 1.16.2 stuffs.
 - 33.0.27 Merge branch '1.16.1' into 1.16.x
           # Conflicts:
           #	patches/minecraft/net/minecraft/client/Minecraft.java.patch
           #	patches/minecraft/net/minecraft/item/crafting/Ingredient.java.patch
           #	src/main/java/net/minecraftforge/fml/client/ClientModLoader.java
           #	src/main/java/net/minecraftforge/registries/GameData.java
 - 33.0.26 Fix up all the things. Removed SidedProvider because it served no real purpose anymore.
 - 33.0.25 Merge branch '1.16.x' into 1.16.1
           # Conflicts:
           #	src/main/java/net/minecraftforge/fml/ModList.java
           #	src/main/java/net/minecraftforge/fml/client/ClientModLoader.java
 - 33.0.24 Redo event dispatch, removes a bunch of nonsense, and tries to integrate with the vanilla CF system where possible
 - 33.0.23 Add particle culling (#6981)
 - 33.0.22 Wrap vanilla's 'default' biome registry in ForgeRegistry.
           This should allow registering mod dimensions like in 1.16.1, while the data driven system is fleshed out.
 - 33.0.21 Clarify in the LazyOptional which methods carry the lazyness over to the returned value and which don't. (#6750)
           For consistency, this meant making a few changes:
           - Renamed the existing lazy mapping method to lazyMap, to indicate that it doesn't run the mapping immediately.
           - Added a new implementation of map(), which returns Optional<T>, and resolves the value in the process.
           - Changed filter() to return Optional, since there's no way to filter lazily.
           - Added a new method resolve(), which helps convert the custom LazyOptional class into a standard Optional, for use
           with library methods that expect Optional<T>.
           * Update License headers.
 - 33.0.20 Add user-friendly exceptions when config loading fails (#7214)
 - 33.0.19 Replace EntityHeight event with EntitySize event (#6858)
 - 33.0.18 [1.16] ForgeEventFactory#canCreateFluidSource reintroduced (#7181)
 - 33.0.17 Cleanup and expand Forge tags (#7004)
 - 33.0.16 Fix modproperties property in mods.toml causing exception (#7192)
 - 33.0.15 Log info about server list warning (#7209)
           Make it easier to figure out what mods are missing or have to be marked as client/server side only.
 - 33.0.14 Fix ItemStack#isDamageable is not calling Item#isDamagable (#7221)
 - 33.0.13 Improve performance and cleanup code for DelegatingResourcePack (#7228)
 - 33.0.12 Fix small logging issues with loading pack.png for mods (#7265)
 - 33.0.11 Fix config iteration order (#7230)
 - 33.0.10 Cleanup Forge's build script, fix some unneeded patches.
           Add checkExcscheckAll tasks.
 - 33.0.9  Readding DifficultyChangeEvent hooks (#7240)
 - 33.0.8  Improve startup time by caching the manifest data for mod jars (#7256)
 - 33.0.7  Removed HarvestDropsEvent (#7193)
 - 33.0.6  Remove forge optional tags in favor of Vanilla's new system. (#7246)
 - 33.0.5  New method for creating modded tag references, fix connecting to vanilla servers.
 - 33.0.4  Fix creating nether portals.
 - 33.0.3  Print mod file name on InvalidModFileException (#7241)
 - 33.0.2  Updated MDK and README for 1.16.2 (#7243)
 - 33.0.1  Fix server connection, misapplied patch (#7245)
 - 33.0.0  Initial 1.16.2 Update

32.0
====
 - 32.0.110 Fix ModelRegistryEvent firing every time resources reload instead of just once.
 - 32.0.109 Move ModelRegistryEvent invocation to when the model loading is about to start.
            Freeze the ModelLoaderRegistry right after this event happens, just before model loading actually begins.
            This means ModelRegistryEvent is now the correct place to register loaders, as it was intended.
            This is a slight breaking change, but any mod that used FMLClientSetupEvent before will need to be updated regardless due to the existing race condition.
 - 32.0.108 Fix wrong BlockState param passed into canSustainPlant from FarmlandBlock (#7212)
 - 32.0.107 Add harvest levels for hoes and new 1.16 blocks for pickaxes Fixes #7187 (#7189)
 - 32.0.106 Fix debug world not generating modded blocks (#6926)
 - 32.0.105 New IForgeBlock#getToolModifiedState hook allow better control over tools interacting with blocks. (#7176)
 - 32.0.104 Added new hook to allow Biomes to control their Edge biomes (#7000)
 - 32.0.103 Add support for custom elytra (#7202)
 - 32.0.102 Re-introduce "outdated" notification on Mods button in main menu (#7123)
 - 32.0.101 Fix RenderTickEvent using wrong partial ticks value when game is paused. Fixes #6991 (#7208)
 - 32.0.100 Implement forge IBakedModel methods in vanilla wrapper models
 - 32.0.99  Fix another case of swallowed errors not shutting down mods.
 - 32.0.98  Revert "Properly shutdown FMLModContainer's event bus when an error in a lifecycle event is detected."
            This reverts commit 30bad1e2
 - 32.0.97  Revert "Shut down all other mod handlers if the loading cycle errors. This prevents other mods from throwing errors and being blamed for initial cause. This is a temporary hack until cpw re-writes the mod event dispatcher."
            This reverts commit 7592bbe8
 - 32.0.96  Shut down all other mod handlers if the loading cycle errors.
            This prevents other mods from throwing errors and being blamed for initial cause.
            This is a temporary hack until cpw re-writes the mod event dispatcher.
 - 32.0.95  Properly shutdown FMLModContainer's event bus when an error in a lifecycle event is detected.
 - 32.0.94  Enable EventBus type check during ForgeDev, and add IModBusEvent marker to ModelRegistryEvent.
 - 32.0.93  Make license toml entry optional during 1.16.1
            There are to many existing mods to make this required.
            Yes, we are technically before a RB and can do breaking changes. However this is too large.
 - 32.0.92  Missed one event. NewRegistry needs the marker.
 - 32.0.91  Update MDK license to default to All rights reserved, and offer a link to chooseyourlicense.com as a place to research appropriate licenses.
            Note: the license field _is_ backwards compatible and will simply be ignored on older forge versions.
 - 32.0.90  Update coremods and spi, include mandatory license field in metadata. Added at top level of mods.toml file.
 - 32.0.89  Update modlauncher, eventbus, accesstransformers and more to use a newer mechanism for generating ASM.
            Introduced IModBusEvent as a marker interface for events on the ModBus. Expect exceptions if you use
            the modbus for events not listened there.
 - 32.0.88  Fix rail 180 rotations (#7177)
 - 32.0.87  Fire AnimalTameEvent for cats (#7172) Closes #7171
 - 32.0.86  Fix Biome generation error.
 - 32.0.85  Fix SleepingTimeCheckEvent not being fired in initial sleep test. (#7005)
 - 32.0.84  Fix ClimberPathNavigator spinning when width is small. Closes #6993 (#6997)
 - 32.0.83  Re-added PlayerEvent.NameFormat (#6992)
 - 32.0.82  Fixed modded overworld biomes not spawning [1.16.x] (#6990)
 - 32.0.81  Added EntityLeaveWorldEvent (#6984)
 - 32.0.80  Re-implement moddable flammabilities (#6983)
 - 32.0.79  Updated versions in README and removed flocker.tv mentions (#6978)
 - 32.0.78  Re-add patch for PlayerSetSpawnEvent (#6977)
 - 32.0.77  Fix ChunkDataEvents using different data tags (#6961) Fixes #6957
 - 32.0.76  Post SoundLoadEvent on mod bus instead of forge bus (#6955)
 - 32.0.75  Remove startupquery. Currently wasn't functional, and 1.16 has out of band state loading in all cases, so the complex functionality there is no longer needed. Going to research using the Lifecycle indicator from DFU as a proxy/replacement. Probably with some codec FUN.
 - 32.0.74  Run Forge's data generators to sync 1.16 vanilla changes.
 - 32.0.73  Don't show the early launcher GUI when running data. It's not needed and prevents use on automated builds.
            Need to investigate why a bunch of tags seem to be being blown away by rerunning on forge.
 - 32.0.72  Add mixin
 - 32.0.71  Load Modded Datapacks in DatapackScreen, before world creation (#6913)
 - 32.0.70  Fix inconsistencies with model/blockstate datagen
 - 32.0.69  Filter duplicate mod files from mod file scan data (#6855)
 - 32.0.68  Fixed Forge commands. Closes #6973 Closes #6974 Closes #6976
 - 32.0.67  Added an event for registering commands. closes #6968 (#6969)
 - 32.0.66  Make all functions in Style common. (#6931)
 - 32.0.65  Mark Raid.WaveMembers as an extensible enum. (#6878)
 - 32.0.64  Fix checkPatches task. Closes #6956
            Fix patched in method using srg name. Closes #6965
            Fix capabilities not being collected for ClientWorld. Closes #6966
            Fix TagEmptyCondition using client side copy of tags instead of server. Closes #6949
            Fix ExtendedButton using narrator text. Closes #6958, Closes #6959
            Fix misaligned patch in RepairContainer. Closes #6950, Closes #6953
            Fix LivingJumpEvent not being fired for players jumping horses. Closes #6929
            Remove extra getToughness method in ArmorItem. Closes #6970
            Remove GetCollisionBoxesEvent. Closes #6921
 - 32.0.63  Fix race condition with DeferredRegister for custom registries (#6951)
 - 32.0.62  Remove hooks into beacon base/payments. Vanilla uses tags now for extensibility. (#6948)
 - 32.0.61  Expose the DataPackRegistries instance to the AddReloadListenerEvent (#6933)
 - 32.0.60  Fix canRepair not being set true as default (#6936)
            Closes #6934 and #6935
 - 32.0.59  Fix misaligned patch causing LivingEquipmentChangeEvent to never be posted.
 - 32.0.58  Fix particles sometimes "losing" the lightmap and drawing fullbright.
 - 32.0.57  Add simple patch checker and cleanup patches (#6851)
            * Add simple patch checker and cleanup patches
            * Address comments
             * move task implementation
             * genPatches is now finalized by checkPatches
             * the S2S artifacts are automatically removed
             * added class and method access checking
 - 32.0.56  Fix the modifier combined name for keybinds displaying two pluses outside of forgedev #6901 (#6902)
 - 32.0.55  Fix harvest level and tool type not actually getting set #6906 (#6922)
 - 32.0.54  Reimplement ITeleporter Patches (#6886)
 - 32.0.53  Add function to add items with the same behavior as the pumpkin for enderman (#6890)
 - 32.0.52  Custom Item integration with Piglins (#6914)
 - 32.0.51  Some dead code cleanup, and re-implement some bed hooks. (#6903)
 - 32.0.50  Fix missing null checks in ForgeIngameGui (#6907)
 - 32.0.49  Fix swap offhand keybind not working in GUIs (#6920)
 - 32.0.48  New AddReloadListenerEvent that gathers server side data reload handlers. (#6849)
 - 32.0.47  Attempt to use a more compatible method to initialize stencil support.
            In case the separate attachments don't work for everyone, there's a new setting to choose the combined attachment.
 - 32.0.46  Fix multi-layer item rendering.
 - 32.0.45  Update copyright year to 2020.
 - 32.0.44  Model system improvements:
            - Port some things I did in 1.14 which I couldn't do in 1.15 due to breaking changes.
            - Fix multi-layer block models not working (1.16 RenderType doesn't override toString the same way anymore)
            - Implement multi-layer item rendering.
            - Improve CompositeModel submodel data passing.
 - 32.0.43  Pass matrixstack in tooltip render events (#6885)
 - 32.0.42  Include model data in getQuads call (#6884)
            The model data wasn't included when getting quads from specific sides, but was when getting quads for side = null.
 - 32.0.41  Fix improper handling of baked lighting in forge light pipeline
            Closes #6812
 - 32.0.40  Fix FMLServerAboutToStartEvent being fired too late on the integrated server https://github.com/MinecraftForge/MinecraftForge/issues/6859
 - 32.0.39  Fix miss-aligned patch ItemEntity (#6895)
 - 32.0.38  Add hoe tool type (#6872)
 - 32.0.37  Fix loading screen color and text (#6824)
 - 32.0.36  Allow any armor to have custom knockback resistance (#6877)
 - 32.0.35  Add senderUUID to ClientChatReceivedEvent (#6881)
 - 32.0.34  Re-write checkATs function and automate making Items/Blocks public.
 - 32.0.33  Reorganize modloading on the dediserver. This removes the DedicatedServer parameter from the FMLDedicatedServerSetupEvent.
            Code for customizing the server instance should be moved to the ServerAboutToStartEvent or similar, where the server instance
            is available.
            This reorganization means that mods will load fully before the server is even constructed, or the server properties loaded. We also move the EULA right to the front so we don't have to wait for bootstrap.
            This should fix the problems with mods which customize world data and other things.
 - 32.0.32  Fix datagen resolving tags and exploding. (#6865)
 - 32.0.31  Fix Language.javaLocale parsing (#6862)
 - 32.0.30  Fix IItemHandler wrappers for chests not updating both chests (#6875)
 - 32.0.29  Fix missed patch in PlayerList and EntitySelectioonContext. Closes #6846 Closes #6850
 - 32.0.28  Make Type classes safe to use in concurrent loading (#6825)
 - 32.0.27  Fix access levels being hardcoded to private via patch overriding AT entry (#6848)
 - 32.0.26  Fix tag related issues when connecting to a vanilla server.
 - 32.0.25  Fix Forge's internal handler being registered in wrong place.
            Fix double call to loader end.
 - 32.0.24  Add a model loader that lets mods specify different models for different perspectives.
            Allow custom models to reference vanilla item models as child models.
 - 32.0.23  Fix swim speed being incorrect. Closes #6845
            Fix BreakSpeedEvent having null position. Closes #6844
            Add MatrixStack to BackgroundDrawnEvent. Closes #6843
            Fix some patches that should of been ATs. Closes #6839
            Add getter to ServerPlayer to access client's language calue if sent. Closes #6829
            Some patch cleanup.
 - 32.0.22  Fix blocks being harvested with incorrect tools.
 - 32.0.21  fix misapplied patch
            also sneak in an import patch removal
 - 32.0.20  Make installer use MCPConfig version to identify MC assets.
 - 32.0.19  Tweak the server startup a bit, make sure methods that can't work because they run before a server exists explode saying so.
            Also fix other launch profiles.
 - 32.0.18  Fix dedicated server loading by constructing mods before data packs are created.
 - 32.0.17  Fix create method.
            Fix test mods not loading correctly.
 - 32.0.16  Reintroduce missed patch in EntityClassification.
 - 32.0.15  Include a getter for the matrix stack in OverlayEvent (#6834)
 - 32.0.14  Fix block render types not being properly applied to item entities (#6832)
 - 32.0.13  [1.16.x] Allow GlobalEntityTypeAttributes' EntityType -> AttributeModifierMap to be added to (#6822)
            * Make GlobalEntityTypeAttributes map able to be added to
            * Split get patch into two lines
            * Favor Forge's map over vanilla
 - 32.0.12  Fixed creative screen arrows (#6827)
 - 32.0.11  Added call to method for tooltip with FontRenderer (#6831)
 - 32.0.10  Retarget Block.Properties patch to the new AbstractBlock, reintroduce harvestLevel and harvestTool fields (#6819)
            * Retarget Block.Properties patch to the new AbstractBlock, reintroduces the harvestLevel and harvestTool fields.
            * Slight adjustment to fix the lootTableSupplier.
 - 32.0.9   Fixed sneaking while swimming (#6817)
 - 32.0.8   Fixed tooltip rendering issues (#6815)
 - 32.0.7   Fixed villager trades having non-applicable enchants
            Also added an AT at lex's request
 - 32.0.6   Updated MDK mods.toml versions (#6808)
 - 32.0.5   Add missing patch to ScreenShotHelper (#6809)
            Adds the missed patch back
 - 32.0.4   Fix block drops (#6810)
 - 32.0.3   Fix locate command (#6811)
 - 32.0.2   Rework BlockSnapshot and fix client notifications. Closes #6807
 - 32.0.1   Bump MCPConfig version.
 - 32.0.0   Update to 1.16.1 and fix a couple more patch problems

31.2
====
 - 31.2.33 Fix some patching derps from 1.15 merge
 - 31.2.32 Clean up legacy cruft
 - 31.2.31 Final patching
 - 31.2.30 Compiling fixes - IN GAME!
 - 31.2.29 Patching and updates
 - 31.2.28 Setup and import of 1.16 YEET
 - 31.2.27 Allow RayTraceContext to be constructed with a null entity. (#6708)
 - 31.2.26 Replace explicit shears reference in vanilla loot tables with tag for modded shears. (#6765)
 - 31.2.25 Fix cache file sorting issue on linux (#6793)
 - 31.2.24 Fire jump event for horses when ridden (#6802)
 - 31.2.23 Modify how modfiles load slightly, for better decoupling.
 - 31.2.22 Throw an exception from DeferredRegister when trying to register entries after registry event has fired (#6789)
 - 31.2.21 Potential userProperties Fix (#6740)
 - 31.2.20 Add system for dimensions to be marked for deletion (#6515)
 - 31.2.19 Fix dedicated server issue in some implementations of Block.getPickBlock. Closes #6566
 - 31.2.18 Fire SpecialSpawn event for mobs spawners. Closes #6700
 - 31.2.17 Remove the yellow coloring on hover in ExtendedButton to match vanilla behavior. Closes #6714 Closes #6713
 - 31.2.16 Fix entity pathing not matching vanilla. Closes #6755
 - 31.2.15 Fixed --server argument crashing the client (#6754)
           Closes #6753
           Moving the fadeOutStart setter above the callback invocation prevents re-entry into the block (which would result in an infinite loop and a StackOverflowException) if the callback causes a render tick (which creating a new ConnectionScreen does).
 - 31.2.14 Fixed ItemStack comparison ignoring capabilities when stack nbt is null. (#6764)
 - 31.2.13 Supply matrixstack to IRenderHandler where possible. Closes #6439 (#6537)
 - 31.2.12 Fix StartupQuery not working more than once on the client (#6699)
 - 31.2.11 Added ProjectileImpactEvent.FireworkRocket (#6758)
 - 31.2.10 Add custom registry type support to DeferredRegister. (#6742)
           It's still a hard dependency because it requires a class reference.
           But there is not a sane way to test registry types without a class reference.
 - 31.2.9  Fix "overlayMessage" rendering in ForgeIngameGui being different than vanilla (#6748)
 - 31.2.8  Implement loader for ItemLayerModel.
           Add support for specifying which layers are fullbright.
           Fix improper generation of model edge. - Thanks to iChun and KnightMiner for the fix suggestions.
 - 31.2.7  Remove dead test classes.
 - 31.2.6  Add --flat argument to data generators to not create data in mod specific directores.
           Useful For Forge's test mods mainly.
           Standardized data gen cache file's folder separators.
           Added ItemModelProvider to BlockStateProvider for cleaner datagen code.
           Added .gitattributes to fix datagen json's line endings correct on windows.
 - 31.2.5  Improve the DistExecutor API and introduce some "almost completely" safe mechanisms to handle sided lambdas.
           In general, use sided lambdas safely by embedding them in a separately loaded class. There's a whole twitch stream
           dedicated to investigating this problem. See link in DistExecutor if you're interested.
 - 31.2.4  Fix typo in new registry fields' names
           Note: this is technically a breaking change. If you for some reason added code referencing these two fields in the last few hours, sorry.
 - 31.2.3  Fix server startup query info not including new text
 - 31.2.2  Improve look of notification GUI, improve StartupQuery API
 - 31.2.1  Add forge registries for applicable new registry types
           Expose constructors for all forge registry entries
           Also, remove deprecation on ItemCameraTransforms/TransformType
 - 31.2.0  Bump version for new RB.

31.1
====
 - 31.1.99 Update MCP Mappings.
 - 31.1.98 fix test mod and add warning comment to framebuffer (#6698)
 - 31.1.97 Fix FireBlock using flammability instead of spread speed when looking for places to spread. Closes #6646
 - 31.1.96 Fix incorrect argument passed in RenderPipeline potentially causing crash. #6677
 - 31.1.95 Re-added patch to enable stencil buffer in net.minecraft.client.shader.Framebuffer
           Add test for the stencil buffer feature. Only tests that it doesn't crash when enabling, for now. - giga
 - 31.1.94 Allow Music Discs to be created with SoundEvent delegates. (#6523)
 - 31.1.93 Use IProperty#getName when generating blockstate jsons (#6582)
           Close #6520
 - 31.1.92 Model system fixes:
           - Add "origin" key to determine what origin to use. This will default to the existing (broken) behaviour to avoid breaking changes.
           - Fix interaction of transforms with variant transforms (transformation ordering).
           - Fix OBJ loader ignoring "diffuseLighting" attribute from the json.
             This attribute will continue not being used if "ambientToFullbright" is on (default) to avoid breaking changes.
 - 31.1.91 Fixed typo in registry alias writing causing infinite loop. Closes #6689
 - 31.1.90 Fixed Partivle.onGround not updating correctly due to decompile error. Closes #6595
 - 31.1.89 Remove duplicate post of ChunkEvent.Load. (#6697)
 - 31.1.88 Fix LevelChange event not firing after enchanting (#6693)
 - 31.1.87 Fix server config directory remaining locked when integrated server is shut down. (#6644)
 - 31.1.86 Fix exclusion of coremods not filtering correctly when the mods directory is a symbolic link. (#6600)
 - 31.1.85 Allow Bees to use custom hives. (#6656)
 - 31.1.84 Fixed tile entities persisting when switching between states that don't have TEs without changing the block. (#6674)
 - 31.1.83 Fixed CropGrowEvents not firing for Bamboo (#6680)
 - 31.1.82 Fix vanilla screens escape key not matching done button behavior (#6682)
 - 31.1.81 Fixed FluidTank.drain calling onContentsChanged when simulating (#6684)
 - 31.1.80 Fix infinite loading screen when resources error. Closes #6592 & #6593
 - 31.1.79 Fix IForgeBlock.removedByPlayer not firing on the client. (#6638)
 - 31.1.78 Update to newer eventbus, with typetools compatibility with jvms up to j14. No guarantees on actual game compatibility however.
 - 31.1.77 Fixed informational /forge commands being repeated to all ops when logging is enabled. Closes #6330
 - 31.1.76 Fix ModListScreen escape key not matching done button behavior. Closes #6672
 - 31.1.75 Patch the bucket logic to not hardcode some checks to WATER. Fixes not being able to place custom fluids into modded fluid-loggable blocks that accept fluids other than water.
 - 31.1.74 Avoid discarding the bottom 4 bits of the lightmap coords. It turns out vanilla relies on those bits. Fixes some blocks being darker than they should be in certain circumstances.
 - 31.1.73 Fix issue with providing a null ItemStack to onPlayerDestroyItem (#6633)
 - 31.1.72 Allow overriding of tool level requirements when harvesting a block, via the HarvestCheck event.  (#6632)
 - 31.1.71 Fixed Hoppers not inserting fully into custom contains with slots that can hold more then max stack (#6631)
 - 31.1.70 Fixed ChunkDataEvent.Save being fired with a null world if chunk isn't fully generated when unloaded. (#6628)
 - 31.1.69 Fix vanilla loot table resource leak. (#6622)
 - 31.1.68 Change recipe condition log level to debug. (#6621)
 - 31.1.67 Fix milk buckets removing potion effects without filters. (#6609)
 - 31.1.66 Added missing localization for swim speed, and reach distance attributes (#6585)
 - 31.1.65 Allow colors of tooltip to be specified in GuiUtils.drawHoveringText tooltip methods (#6579)
 - 31.1.64 Fix config comments referencing disallowed enum values. (#6542)
 - 31.1.63 Remove redundant call to modifyLoot. Closes #6657
 - 31.1.62 Fix various issues with the loading screen and datagen
           Fix NPE on datagen startup
           Fix early loading GUI hanging and never terminating after datagen
           Add loading GUI messages for datagen
 - 31.1.61 Fix BackgroundScanHandler crashing on servers (#6660)
 - 31.1.60 Remove silly icon override. Squirrels are fun y'all..
 - 31.1.59 Rename window icon image to avoid conflict, fix not using vanilla icon
 - 31.1.58 Fix VariantList calling deprecated bake method
 - 31.1.57 Fix resource packs not being sorted properly. Closes #6287
 - 31.1.56 Fix Automatic Event Subscriber not detecting mod id defaults, and fix test mods.
 - 31.1.55 Use forge logo as short term window Icon, fix Buffer cast problems for new JDK stupid.
 - 31.1.54 Handle message display a bit better, try to make the UI tick a bit better.. Still a problem with
           a modelbake right at the end, happening on the window flip.
 - 31.1.53 Move ClientVisualization to secondary thread
 - 31.1.52 move handOffWindow down near start()
 - 31.1.51 merge early startup into main window if used. It seems to work well.. Also ticks window on main thread, so mac compatible now.
 - 31.1.50 Update jenkinsfile and gradle for new versions of things..
 - 31.1.49 Fix potential NPEs in RegistryObject.orElseThrow/isPresent/ifPresent Closes #6647
 - 31.1.48 Add tickRate setter to the ForgeFlowingFluid Properties builder.
 - 31.1.47 Fix recursion mess in PlayerAdvancement loading, by using an alternative based on a toposorted list of all advancements.
           It seems to be fully equivalent in testing, but there may be corner cases, so there is a config to disable, though disabling
           may break servers, especially those chunkloading fake players.
 - 31.1.46 Revert defualt jvm args.
 - 31.1.45 Fixed dev time compilation using J9+ producing incorrect bytecode.
 - 31.1.44 Add "type" field to global loot modifier jsons. (#6554)
           * Add "type" field to global loot modifier jsons and fix tests.
           To avoid binary breaking, "type" defaults to be the same as the filename.
           * Fix license headers.
 - 31.1.43 Fix child annotations not inheriting member name, cleanup
 - 31.1.42 Fix element type of scanned child annotations
 - 31.1.41 Fixed PlantType not extending IExtensibleEnum, Closes #6286
 - 31.1.40 Added hook to allow modded Hill Biomes (#6571)
 - 31.1.39 Improve performance of VertexBufferConsumer by inlining element locs
 - 31.1.38 Revive forge lighting pipeline, disabled by default for now
           Remove a lot of light value convolution by using 0..1 for nearly everything
           Fix a lot of TODOs that are needed for the lighting pipeline to function
           Potential fix for #6425
 - 31.1.37 Fix Tag serializing empty optionals, improve RegistryObject error msg
 - 31.1.36 Remove SideOnly from WoodType methods
 - 31.1.35 Cleanup IForgeTagBuilder code style.
 - 31.1.34 Move global loot test data files out of generated folder
 - 31.1.33 Add support for optional tag values to Tag.Builder
           Add optional tag values to data gen test
           Fix data gen test not running by correcting gui_light value
 - 31.1.32 Fix a few issues with BufferBuilder
           Fix vanilla bug that caused the byte order of the buffer from getNextBuffer to be incorrect
           Fix missing modification to nextElementBytes in putBulkData
 - 31.1.31 Deprecate ModelBuilder#gui3d, add ModelBuilder#guiLight
 - 31.1.30 Add renderer to RenderNameplateEvent (#6562)
 - 31.1.29 Defer writing the server.properties file until after mods have loaded to prevent config loss (#6545)
 - 31.1.28 Fix ownership leak in ItemStackHandler (#6580)
           - Triggered by invoking ItemStackHandler#extractItem with `simulate=true`
 - 31.1.27 Fix cycle happening in noteblock even though we're setting the new value as well..
 - 31.1.26 Add a progress message for atlas textures. Fills a big time gap on bigger packs.
 - 31.1.25 Remove ArrowEntity patch, vanilla fixed MC-107941
 - 31.1.24 Fix Forge's tps and gen commands.
 - 31.1.23 Update gradle wrapper
           Update MCPConfig to version that bypasses javac compiler bugs
           Fix Global loot test compile errors.
 - 31.1.22 Fix loading text not rendering after mojang logo appears
 - 31.1.21 Fix loading GUI corrupting matrix state
 - 31.1.20 Somewhat restore the loading screen overlay. It seems that once the mojang logo and progress bar
           start running, I can no longer write to the window, even though I am obviously trying to..
 - 31.1.19 Add projection matrix to RenderWorldLastEvent (#6536)
 - 31.1.18 Global Loot Functions (#6401)
 - 31.1.17 Updated ForgeDev MCP Mapping Version (#6532)
 - 31.1.16 Fix up alarming security crisis with network handling that allowed for wrong code execution on the server, resulting in CRASHED SERVERS. AWFUL stuff.
           Also fixed a silly log message from the login handler.
           This change introduces a mechanism to direct certain packets to only process on one side or another. Invalid sidedness will result in the connection being terminated.
 - 31.1.15 Make TransformationHelper.slerp for quaternions public (#6528)
 - 31.1.14 Fixed Conduit and Beacon Activation on Vanilla Servers (#6438)
 - 31.1.13 Fix ITeleporter being ignored when teleporting from the end to the overworld (#6505)
           * Fix custom teleporters triggering end credits when returning from the end
           * Fix setdimension command ignoring position
 - 31.1.12 Fix missing call to itemstack TER (#6445)
 - 31.1.11 Fix missed modeldata passing in BlockModelRenderer (#6442)
 - 31.1.10 Fix NPE when players rejoin the server in a dimension that was deleted (#6511)
 - 31.1.9  Fix a wrong RenderState name MC-167447 (#6501)
 - 31.1.8  Fix client not informing server when it attempts to interact with things, and is canceled by a client side handler.
 - 31.1.7  Fix wrong arguments passed to ForgeHooksClient.renderSpecificFirstPersonHand() (#6496)
 - 31.1.6  Fixed ChunkWatchEvent.(Un)Watch not firing correctly (#6453)
 - 31.1.5  Update version and support data on README. (#6429)
 - 31.1.4  Fixed Food not using effect suppliers, to better support delayed initialization and registry replacements. (#6411)
 - 31.1.3  Fixed displaying item names when only more sensitive version changes (#6402)
 - 31.1.2  Fix gui_light for forge's item parent models.
 - 31.1.1  Allows custom blocks to define if they should use the fluid overlay instead of the flowing texture when in a fluid (#6493)
 - 31.1.0  Fix a small patch misalignment.

31.0
====
 - 31.0.19 Add FluidStack support to the Forge packet buffer. (#6353) (#6485)
 - 31.0.18 Make Minecarts work with modded powered/activator rails. (#6486)
           Re-adds functionality for rails to have different maximum speeds.
 - 31.0.17 Revert game data to frozen on disconnect from a remote server or when terminating a local server. Closes #6487 (#6497)
 - 31.0.16 Remove unintended changes.
 - 31.0.15 Implement fluid overlay texture rendering for custom fluids.
 - 31.0.14 Fixed Attacks/Punches not Registering (#6481)
           Replaced incorrect magic number with constant
 - 31.0.13 Clean up a bunch of render events (#6444)
           * Delete RenderHandEvent as RenderSpecificHandEvent can do everything it does and more. Rename RenderSpecificHandEvent to RenderHandEvent as it's now the only hand rendering event.
           * Pass MatrixStack and IRenderTypeBuffer into the event whenever they are available. If they're available, that means we're in a batching environment and the modder should not be using the tessellator or other buffers on their own, or they risk "Already building" crashes.
 - 31.0.12 Fix NullPointerException on java 8u242 in dev environment. (#6473)
           Java 8u242 no longer re-initializes internal sys_paths and usr_paths fields in loadLibrary when they are null, so the value can't be set to null.
 - 31.0.11 Fix incorrectly ported patch for restoreBlurMipmap (#6450)
 - 31.0.10 Fix RightClickBlock code differences between client and server implementation (#6451)
 - 31.0.9  Defer material getting for ChestTileEntityRenderer into seperate function (#6465)
 - 31.0.8  Small Forge config fixes (#6466)
 - 31.0.7  Fix ChunkDataEvent.Load not firing, it now fires in the aync thread. Be careful. Closes #6471
 - 31.0.6  Fix incorrect keybinding modifiers patch. Closes #6478
 - 31.0.5  Fix PlayerChangedDimensionEvent using incorrect from dimension argument in ServerPlayerEntity.teleport. Closes #6457
 - 31.0.4  Fix default mod resources loosing it's sort order.
 - 31.0.3  Fix WakeupEvent patch misalign. Closes #6474
 - 31.0.2  [1.15] Reimplemented the ITeleporter interface (#6404)
 - 31.0.1  Hook "gui_light" value from the model into the IBakedModel implementations.
           Apply some of the suggestions from the 1.14 models PR.
 - 31.0.0  1.15.2 Initial Update

30.0
====
 - 30.0.51 Cleanup fml packages removing old deprecated classes related to GUIs/Configs and fix HoverChecker (#6437)
           Fixed ModListWidget name to avoid confusion and collision.
           Delete CheckBox, as vanilla has it's own CheckBox now which looks much better
           Rename ModConfigEvent.ConfigReloading to ModConfigEvent.Reloading
 - 30.0.50 Fixed parameter name issue in ISTER rename. #6461 (#6468)
 - 30.0.49 Fix default widget foreground color.
 - 30.0.48 Updated method names referencing ItemStackTileEntityRenderer (#6461)
 - 30.0.47 Fix Widget Foreground Color not allowing pure black (#6460)
 - 30.0.46 Fixed rounding issue with entity navigation fix (#6455) (#6456)
 - 30.0.45 Fixed RenderTypeLookup loosing mappings for registry replacements. (#6452)
 - 30.0.44 Use extended version of getLightValue in all places (#6433)
 - 30.0.43 [1.15.x] Added entity nameplate rendering event hook (#6416)
 - 30.0.42 Remove emissive items hook, add small utility for bakedquad lighting
 - 30.0.41 Fix breaking overlay weirdness. applyBakedNormals was not transforming the baked normals when applying them. Fixes #6432
 - 30.0.40 [1.15] Add new InputEvent.ClickInputEvent, addresses #5802 (#6047)
 - 30.0.39 Fix dark spots in fullbright quad rendering.
           Fix multi-layer model not declaring dependency on the particle texture.
           Fix mistake in 2c054fca which I didn't intend to push when I did.
 - 30.0.38 Fix multi-layer model loader to actually work in a sane way. No more "base" model involved, and now transforms and overrides work as expected.
 - 30.0.37 Attempt to fix fullbright lighting.
           Fix lightmap value calculation.
 - 30.0.36 Add constructor for FishBucketItem that accepts suppliers
 - 30.0.35 Fix QuadTransformer normal processing.
 - 30.0.34 Fix validation in RotationBuilder#angle (fixes #6323) (#6408)
 - 30.0.33 Add support for custom nether portal frame blocks (#6389)
 - 30.0.32 InputEvent.RawMouseEvent fix (#6395)
 - 30.0.31 Fixed Big Mushrooms not generating (#6390)
           Removed vanilla negation from Forge logic that negated the vanilla logic it was replacing
           also ran datagen to update the dirt tag to reflect changes that were previously made in the datagen code
 - 30.0.30 Fix dyes tag containing dye items instead of tags
           Update generated data
 - 30.0.29 [1.15.x] Remove unused parameter from ElementBuilder#rotation (fixes #6321) (#6407)
 - 30.0.28 Refactor BlockStateProvider to encapsulate a BlockModelProvider
           Make most protected methods of data generators public
 - 30.0.27 Fix crash when building BakedQuadBuilder
           Add javadocs and move sprite to constructor where possible
 - 30.0.26 Fix incorrect check for missing texture in DynamicBucketModel
 - 30.0.25 Remove custom vertex format from BakedQuad
 - 30.0.24 A few more binary-breaking changes, before it's too late:
           - Move CompositeModel out of its package.
           - Move a few inner classes from the OBJ loader.
           - Rename the bucket model and fluid model classes to match the naming convention.
           - Remove BiomeEvent.* and WorldTypeEvent.InitBiomeGens as they are not currently implemented and they haven't been in the previous version either.
 - 30.0.23 Cherry-pick ca819e09 from the 1.14.x branch. Removes a patch from NativeImage which was invalid.
 - 30.0.22 Fix the particle renderer not setting GL state between each type. MC-168672
 - 30.0.21 Fix CompositeModel not respecting "display" transforms.
           Remove leftovers from discarded feature.
 - 30.0.20 Allow model jsons to override the material library used by OBJ models.
           Fix model loader test mod resources.
           Update licenses.
 - 30.0.19 Apply baked-in lightmap data to rendering
           - Fix ForgeHooksClient.fillNormal injecting data to lightmap
           - Fix OBJModel not filling lightmap data
           - Fix NewModelLoaderTest blockitem not linking with block
 - 30.0.18 Fix LightUtil.unpack to set the 4th component to 1 when expanding an xyz position into a 4-component vector.
           Add TRSRTransformer test mod.
           Fix signature of the bindTileEntityRenderer method, to account for covariance.
 - 30.0.17 More model/rendering fixes:
           - Breaking change: Change ClientRegistry.bindTileEntityRenderer to a factory, so mods don't have to manually specify the dispatcher.
           - Breaking change: Delete obsolete SimpleModelState (the class was duplicated by mistake, see SimpleModelTransform) and ICustomModelState (part of the old loader API).
           - Breaking change: Rename getTextureDependencies to getTextures, for consistency.
           - Reinstate the getRenderLayer method, fixed appropriately to return the new RenderType value.
           - Fix OBJ loader applying the model transform in the wrong reference frame.
           - Fix vanilla bug in TransformationMatrix#func_227986_a_
           - Fix QuadTransformer logic.
           - Added new method to IModelConfiguration to retrieve the owner IUnbakedModel, needed in order to construct ItemOverrideLists when baking custom models.
           - Reintroduce multi-layer model through the new model loader system.
 - 30.0.16 New batch of Model/rendering fixes:
           - PerspectiveMapWrapper did not pass IModelData through to the wrapped model.
           - CompositeModel did not store the returned textures from getTextureDependencies.
           - VertexFormat used COLOR instead of UV to detect UV presence.
           - QuadTransformer would crash due to index out of bounds.
           - Small cleanup of TransformationHelper
 - 30.0.15 Fix obj models having all faces in the same mesh, breaking material assignments and visibility in the process.
           Reintroduce lost patch from the model loader, which would cause the custom values to be missing from generated models.
 - 30.0.14 Fix diffuse lighting being baked into models, fixes dark items
 - 30.0.13 Fix item quads not using the existing vertex color when applying tint colors.
 - 30.0.12 Fix bucket model. Some mask textures were not added to the repository, and the bucket override generation was broken.
           Fix OBJ loading crash due to a float value being parsed as int.
           Fixes 6377
 - 30.0.11 Fix game crashing when modded entities are present (#6364)
 - 30.0.10 Fix warning screen about missing minecraft registry entries (#6363)
 - 30.0.9  Fix capabilities becoming inaccessible on returning from end (#6368)
 - 30.0.8  Some code cleanup for 1.15 (#6362)
 - 30.0.7  Fix MainMenuScreen patch
 - 30.0.6  Mod list GUI detail pass
           - Make padding consistent on all elements
           - Properly horizontally center the "Search" text
           - Update and resize forge/mcp logos
           - Enable linear filtering on logo rendering by default
             - Can be disabled with the "logoBlur" mods.toml property
 - 30.0.5  Fix mod list screen (#6367)
 - 30.0.4  Fix items in ground being too small, we were applying perspectives twice.
           Restore forge patch and fix a tiny mistake in it.
 - 30.0.3  Fix keybinds not loading/saving correctly
 - 30.0.2  Remove uvlock hook, fixes broken stair/fence/etc models
 - 30.0.1  Update fallback spec version
 - 30.0.0  Update to 1.15.1

29.0
====
 - 29.0.4 Finish converting the code from javax.vecmath to the vanilla vector classes. Forge is now vecmath-free!
 - 29.0.3 Remove deprecations
 - 29.0.2 Fix incorrect item lighting
 - 29.0.1 Revert fluid change to use Material, fixes server crash
 - 29.0.0 Update to 1.15
          Due to the massive rendering changes, certain features, such as emissive item rendering and the forge block rendering/lighting pipeline are currently disabled.
          Co-authored-by: David Quintana <gigaherz@gmail.com>
          Co-authored-by: tterrag <tterrag1098@gmail.com>
          Co-authored-by: Unnoen <theunnoen@gmail.com>

28.1
====
 - 28.1.107 Added a couple of raytraceresult.getType() != MISS checks in places where they were absent. This corrects a couple of vanilla oversights and also greatly reduces Forge bus event spam for arrows and llama spit. (#6355)
 - 28.1.106 Restored canRiderInteract boolean in IForgeEntity (#6347)
 - 28.1.105 Split DrawBlockHighlightEvent into subevents to make usage clearer, addresses #2190 (#6269)
 - 28.1.104 Allow classpath locator to discover jars via FMLModType attribute
 - 28.1.103 Tidy up some output and also add libraries from the modfile detection into the transforming classloader.
 - 28.1.102 Fix swapped yaw/pitch in camera setup event
 - 28.1.101 Restore camera setup render event (#6335)
 - 28.1.100 Fixed invocation of Vanilla spawn logic (#6334)
            Forge's replacement of the Vanilla logic gets inverted, so the Vanilla logic inside that replacement must be inverted to correct for this.
            (Fixes #6332)
 - 28.1.99  Add item tag 'beacon_payment' for items that can activate a beacon (#6328)
 - 28.1.98  Added FENCES_WOODEN and FENCE_GATES_WOODEN tags as fuels in AbstractFurnaceTileEntity (#6327)
 - 28.1.97  New SleepFinishedTimeEvent allowing control of world time when waking up. (#6043)
 - 28.1.96  Fix EntityLootTables not calling addTables
 - 28.1.95  Make EntityLootTables reusable for modders
 - 28.1.94  Fix emissive items not working
 - 28.1.93  Fix the hang on startup problem when windows' broken device enumeration
            causes a huge glfwInit slowdown. Log a message too when this is detected.
            See https://github.com/glfw/glfw/issues/1284, https://stackoverflow.com/questions/10967795/directinput8-enumdevices-sometimes-painfully-slow,
            https://discourse.libsdl.org/t/win-10-initing-joystick-causes-45s-hang-in-sdl-dinput-joystickdetect/23293
 - 28.1.92  Add hooks to make it easier to add custom TNT blocks (#6290)
 - 28.1.91  Add tags supports_beacon and supports_conduit and modify Beacon and Conduit to use these tags (#6266)
 - 28.1.90  Fix RawMouseEvent not being cancelable (#6310)
 - 28.1.89  Fix DyeColor referencing incorrect Tag path. Fixes #6301 (#6303)
 - 28.1.88  Modify StonecutterContainer to allow shift-click insertion of any block with a valid recipe rather than limiting to blocks in an Immutable List (#6268)
 - 28.1.87  Fix #6305 lighting optimization using the wrong method
 - 28.1.86  Add support for modded warm ocean biomes in bonemeal code
 - 28.1.85  Optimize SectionLightStorage#cancelSectionUpdates loop
 - 28.1.84  Add LeftClickEvent trigger to onPlayerDamageBlock (#6046)
 - 28.1.83  Fixed an NPE caused by missing registries. (#6292)
            Missing registries in this case being registries renamed without proper remapping or created by mods that were removed.
 - 28.1.82  Made the slash optional in fml confirm/cancel. (#6282)
 - 28.1.81  Fix registry snapshots not reading aliases correctly. Closes #6298
 - 28.1.80  A few tweaks to things. Make the mods command a bit better, make the
            IndexedMessageCodec actually log which network channel it got back packets
            on. Also, improve the custom directorymodlocator with actual custom names,
            finally, allow up to 99 log rollovers, up from 7 default (this means a
            repeatedly crashing server is less likely to roll out the log of the first
            crash).
 - 28.1.79  Fix BlockStateProvider#horizontalBlock emitting rotations >=360
 - 28.1.78  Added some more biome types to BiomeDictionary (#6250)
 - 28.1.77  Replaced getTypes invocation in ensureHasTypes with a direct reference to types, preventing infinite recursion (#6284)
            The direct reference is checked via ternary and reports if the set is empty, this is likely to result in log spam if modders don't assign types to their biomes
 - 28.1.76  Fix lang generator escaping newlines, add lang generator test
 - 28.1.75  Escape control chars and unicode when writing out lang datagen
 - 28.1.74  Allow LanguageProvider helpers to accept suppliers of subtypes
 - 28.1.73  Expose private helper methods in BlockLootTables to subclasses
 - 28.1.72  Fixed vanilla bug in entity navigation to stop entities spinning (MC-94054) (#6091)
 - 28.1.71  Reimplement usage of Item#doesSneakBypassUse() (#6114)
 - 28.1.70  Handle logging during shutdown better on the server, by not
            closing the logfile before the server itself has shutdown.
 - 28.1.69  Fix NPE in modlauncher when there is no mods dir yet.
 - 28.1.68  Fixed NPEs caused by uninitialized lists in ModDirTransformerDiscoverer (#6277)
 - 28.1.67  Make Loot Table data generators more reusable for modders.
 - 28.1.66  Add Blockstate and Model data providers (#6241)
 - 28.1.65  Allow pack locators to load from the mods folder.
            Regular mods are now automatically de-duped based on the version number -
            the highest version file of a "root mod id" is now selected automatically.
 - 28.1.64  Exclude Cobblestone slabs and wall recipes (#6230)
 - 28.1.63  Fixed forge rendering pipeline and shape based light occulsion. (#6178)
 - 28.1.62  Fix shouldCauseReequipAnimation not affecting anything (#6256)
 - 28.1.61  Expose the registrationchange event to simple channel (not that anyone should care, but who knows?)
            Also, Context.getNetworkManager should have been public. Derp.
 - 28.1.60  Fix clientside chunk load event spam. Was an offset patch.. Also fire unload on the client side too.
 - 28.1.59  Add in an event to expose the standard MC channel stuff to network
            event channels that care about such things. Mods using simplechannel
            don't need to care.
            Also, put a sync wrapper around crashreportextender, so it doesn't
            die sometimes randomly during startup.
 - 28.1.58  Fix #6244 RightClickBlock#getUseBlock and #getUseItem being ignored (#6246)
 - 28.1.57  Fix vanilla models with parents not loading properly from forge blockstates.
 - 28.1.56  Include a profile icon for the launcher json (#6222)
 - 28.1.55  Fixed loading error/warning screen not showing (#6218)
 - 28.1.54  Fixed MC-162953 bounds checks in `NativeImage` (#6216)
 - 28.1.53  Allow mods actually to have their own usable config gui (#6208)
 - 28.1.52  Fix error logging in FMLUserdevLaunchProvider.setup (#6206)
 - 28.1.51  Fix shear sound not playing (#6202)
 - 28.1.50  Fix some config checks still using the old fields (#6193)
 - 28.1.49  Add onCropsGrow event to KelpTopBlock (#6171)
 - 28.1.48  Fix mod info panel rendering incorrectly on some systems with HiDPI displays (pesky macs) (#6170)
 - 28.1.47  Re-add PlayerGiveXpEvent & PlayerChangeLevelEvent (#6165)
 - 28.1.46  Skip background for hidden effect instances (#6197)
 - 28.1.45  Bump modlauncher version to 4.1
 - 28.1.44  Fixed IModelData not being cleared when tile entity is removed (#6115)
 - 28.1.43  Allow modded IParticleRenderTypes to be rendered (#6221)
 - 28.1.42  Better sanity checks in ModelDataManager
 - 28.1.41  Make customClientFactory optional again (#6191)
 - 28.1.40  Fix forge blockstates and custom model loading (#6154)
            * Reimplement forge blockstates variant through the use of a pseudo-model that handles the model loading, retexturing, custom data, etc. on behalf of the blockstates loader. This model gets injected into the model registry with an autogenerated unique name, to not collide with other model locations.
            * Fix model loaders not being properly initialized by calling the reload method from the loader register function. In 1.12, registering a reload listener caused the listener to be called right away from the register method. This is not true anymore.
 - 28.1.39  Add a super early GUI for showing pre-game launch messages from FML. NOTE: this cannot show on MAC because MAC can't handle
            off-thread GUIs in any way shape or form, and we need the main thread to do real work.
            Fix forge fading in wrongly.
 - 28.1.38  New round of fluid system fixes: (#6175)
            - Fix race condition lazy-initializing flowing fluid block data.
            - Fix typo in ItemTextureQuadConverter that prevents certain animated textures from being used in the fluid bucket.
            - Fix calls to onContentsChanged in FluidTank.
            - Fix FluidUtil.tryEmptyContainer logic when simulating.
            - Fix EmptyFluidHandler.fill returning the wrong number.
 - 28.1.37  Combine all hidden mod resource packs into a single sortable pack
            Fix mod datapacks sorting under vanilla
 - 28.1.36  Split server and client side pack locators apart and move them to their
            respective behavioural components. This should facilitate fixing the
            server pack data pack ordering, as well as other new features of mod
            resource packs.
 - 28.1.35  Fix dimension types being incorrect when connecting to a non-Forge server. Closes #6203
 - 28.1.34  Fix the stupid derp that broke singleplayer dims. Don't send the dim packet
            to the local client - it is not needed because obviously not. Seems to have
            fixed the problem. Probably infinity new bugs by this.
 - 28.1.33  Move OnlyIn patches on DyeColor to SAS file
            Also fix broken cobblestone stairs recipe
 - 28.1.32  Expose DyeColor#colorValue, remove OnlyIn from all DyeColor methods
 - 28.1.31  Properly propagate the DimensionType information from server to client
            at client connection time. This means the client now knows about the
            dimensiontype properly and can access the ModDimension information on
            the client.
 - 28.1.30  Fix FluidTank with empty contents throwing error if drained (#6196)
 - 28.1.29  Move opening initial screen to after startup and events are enabled (#6139)
            This allows events to be fired for the initial opening of the main menu
            Also fixes MC-145102
 - 28.1.28  Changed all calls of `BlockState#getSoundType` to use the sensitive version.  (#6120)
 - 28.1.27  Patch Sweet Berry Bush to have Crop Growth Event Hook (#6094)
 - 28.1.26  Allow structure processors to process entities
 - 28.1.25  Remove forced ANSI terminal - it breaks the Eclipse terminal output.
            As a result, we can now support coloured log output again, by default.
            Regen run configs to get the change (you should do this every update, you
            know :D)
 - 28.1.24  Make patched-in StairsBlock constructor public
            Also fix supplier generic being too narrow in DeferredRegister#register
 - 28.1.23  Integrate modlauncher changes for mixin.
 - 28.1.22  Fix new flower pot ctor not being usable with deferred register
 - 28.1.21  Usability improvements to RegistryObject/DeferredRegister
 - 28.1.20  Add constructor to StairsBlock that accepts a state supplier
 - 28.1.19  Fix server jar manifest path.
 - 28.1.18  Fix sea level not being available on client, move hook to Dimension
 - 28.1.17  Add template arg to StructureProcessor#process
 - 28.1.16  Fix timezone issue with the installer.
 - 28.1.15  Bump binpatcher and jarsplitter versions to address Java differences on older JDKs.
 - 28.1.14  Allow modded dimensions to customise World#getSeaLevel
 - 28.1.13  Fix jigsaw blocks not mirroring properly
 - 28.1.12  Fix type bound on GameRegistry.findRegistry being too narrow
 - 28.1.11  Add IExtensibleEnum#init, extend FillerBlockType/PlacementBehaviour
 - 28.1.10  Tag the deprecation of DeferredWorkQueue. I think this is causing confusion
            as to scope. Its functionality will be tied to the events in future -
            so mods can request the deferred work through methods on the Mod Lifecycle
            events directly. The API will be coming soon.
 - 28.1.9   Fixed the problem where an error would cause the main thread to continue
            even though there were still parallel threads running. Also, handle exceptions
            in the AutomaticEventSubscriber rather than leaking them to the Parallel processor.
            Actually closes #6148
 - 28.1.8   Make FlowerPotBlock extensible and reusable for mods
            - Change static lookup map to an instance variable
            - Add an instance variable for the "empty pot" for the current block
            - Keep one instance of the lookup map between the empty pot and all its full versions
            - Convert everything to use delegates
 - 28.1.7   Post tag event directly from reloader thread (#6164)
 - 28.1.6   Some tweaks around the code base. A functional consumer for networking - return a bool from your consumer function, rather than setPacketHandled.
            Tweak the server modloading behaviour to try and be a bit clearer that a mod errored.
 - 28.1.5   Update furnace fuels to not recreate it's list every query, and update when tags are reloaded. Add Tag update events. (#6140)
 - 28.1.4   Maintain default behavior for Item#canPlayerBreakBlockWhileHolding() (#6128)
 - 28.1.3   Update README badges to fix wrong version. (#6141)
 - 28.1.2   Reimplemented "MouseEvent" as RawMouseEvent for 1.14.X (#6144)
 - 28.1.1   Fix patch for vanilla spawning in WorldEntitySpawner (#6130)
 - 28.1.0   Fix Entity.getPersistentData function name. Closes #6131
            Bump spec version for first 1.14.4 RB.

28.0
====
 - 28.0.106 Fix ParticleFactoryRegisterEvent not firing (#6126)
 - 28.0.105 Minor fixes to the fluids (#6150)
            * Fixed vanilla rendering of fluids to take into account the alpha bits of the color, and fix usages accordingly.
            * Fixed missing texture derp.
 - 28.0.104 Some (sadly breaking) improvements to the Fluid API (#6110)
            * Some (sadly breaking) improvements to the API, after feedback and concerns provided by users:
              - Moved calculation of the translation key to the FluidAttributes constructor, so that builders can be shared between still & flowing sub-fluids.
              - Moved biome-based coloring to a dedicated FluidAttributes.Water variant, which is not used by default.
              - Added logic to automatically gather fluid textures into the list of textures to bake.
              - Patched BucketItem and FlowingFluidBlock to avoid eager access to the fluid objects.
              - Added a ForgeFlowingFluid class, as a more user-friendly way to construct a new FlowingFluid.
 - 28.0.103 Add new DeferredRegistry helper, and change RegistryObject to update when overrides are registered.
 - 28.0.102 Delay Block loot table name generation until needed, as calling early will result in an empty name as the block is not registered yet.
 - 28.0.101 Fix slimes splitting more times then they should. Closes #6138
 - 28.0.100 Fix a couple places not calling forge getLightValue
 - 28.0.99  Properly fix missing attribute issue, add vanilla bug ID
 - 28.0.98  Fix vanilla typo causing errors when client is missing entity attributes
 - 28.0.97  Remove StructureArgument to work around vanilla issue, clean up custom arguments
 - 28.0.96  Fix SCommandListPacket underflowing buffer when encountering a missing argument type
 - 28.0.95  Fix problem with network connections timing out frequently. Turns out
            there's a race condition - and the extra work forge does causes it to
            happen much more frequently than vanilla (though I'm sure it's a vanilla
            issue). Closes #6124, #5767 and probably lots more.
 - 28.0.94  Make /locate command support modded structures
 - 28.0.93  Make STRUCTURE_FEATURE registry a slave map of the FEATURE registry
            Also convert Feature.STRUCTURES to a slave map
 - 28.0.92  Fix REGISTER packet encode/decode issues.
            Changed ForgeConfig values to return the default value if the config is not loaded, and exposed the value objects as a internal config.
 - 28.0.91  Fix naming conflicts with official names.
 - 28.0.90  Fix item used stat not triggering properly on last item in the stack.
 - 28.0.89  Add a bunch of tags from the omnibus.
            Fix test imports. And update patches for line numbers.
 - 28.0.88  Add spawn reason to spawn events (#6096)
 - 28.0.87  Add collisionExtendsVertically hook to allow modded blocks that extend collision into the block above similar to fences. (#6092)
 - 28.0.86  Fixed PlayerInteractEvent.LeftClickBlock useItem/useBlock (#6045)
 - 28.0.85  Readded IForgeItem#getHighlightTip hook. (#6036)
 - 28.0.84  Added gravity as attribute to Entities (#5630)
 - 28.0.83  Fix CME on chunk unload in FarmlandTicketManager (#5998)
 - 28.0.82  Add a modfolderfactory. Fix up login payload exposure.
 - 28.0.81  Peel IModLocator into the SPI package and extract a small IModFile
            interface as well. This allows building external IModLocator
            implementations.
 - 28.0.80  Add in some client only player connectivity events. Closes #5536
 - 28.0.79  Add in MC REGISTER nonsense. Shut up #5730
            Tweak network a bit to fix initialization order stupidity. (Constants don't
            load classes!)
 - 28.0.78  move default log level for debug file to debug instead of trace, and remove millis from console and GUI. Also remove unused config xmls
 - 28.0.77  Added getters for FMLPlayMessages.SpawnEntity
 - 28.0.76  Move indexFor and biConsumer into FMLHandshakeHandler and expose them publicly, so mods can add additional
            login messages. Closes #6087
 - 28.0.75  Hookup BlockEvent.FluidPlaceBlockEvent (#6103)
 - 28.0.74  Update libs to 1.0 versions, bump grgit, and fix tag search behaviour that resulted.
 - 28.0.73  Fluid rework derp fixes. (#6098)
            * Fix nulls returning from non-null methods, and null-check of non-nullable values.
            * Fix missed computation of the isEmpty flag in FluidStack
            * Cleanup getAmount/isEmpty calls.
            * Remove redundant suppliers. That info is readily available from the vanilla Fluid / FluidState.
 - 28.0.72  Minor model system cleanup/documentation (#6089)
 - 28.0.71  Fix Digging particle sometimes using the wrong block pos to get additional model data (#6077)
 - 28.0.70  Change fml.modloading.brokenfile.optifine to not imply that Forge is responsible for Forge-Optifine compatibility. (#6080)
 - 28.0.69  Add a config comment that lists the available constants of enums (#6079)
 - 28.0.68  Restore PotionShiftEvent (#6042)
 - 28.0.67  Added new InputEvent.MouseScrollEvent, fixes #5811 (#6037)
 - 28.0.66  Add Villager Trading Events (#6016)
 - 28.0.65  Strip side annotations from CropsBlock.getSeedsItem (#6013)
 - 28.0.64  Updated constants to 1.14 (#6012)
 - 28.0.63  Added hook to allow biomes to specify custom river variants. (#5969)
 - 28.0.62  Add particle factory registration event (#6018)
 - 28.0.61  Make FluidStacks non-nullable, and implement some TODOs.
 - 28.0.60  Fix license headers so `gradlew build` is happy.
 - 28.0.59  Fluid API rework (#5983)
            - Moved forge fluids into FluidAttributes companion object to the vanilla Fluid. By gigaherz
            - Redesigned the Fluid API to be closer to the Items API. By King Lemming
            Co-authored-by: King Lemming <kinglemming@gmail.com>
 - 28.0.58  Recipe system cleanup. (#6014)
 - 28.0.57  Fix regular arrows giving off particles after a world reload (MC-107941) (#6061)
 - 28.0.56  Fix coremod not redirecting to the correct method (#6078)
 - 28.0.55  Fix blocks being placed in adventure mode. Closes #6085
            Add early error for setting invalid world directory. Closes #6084
            Fix PlayerTickEvent not firing when dead, even if player isn't removed from world yet. Closes #6074
            Fix PlayerDestroyItemEvent not firing for some cases. Closes #6067
 - 28.0.54  Fix Javac generics breakage.
 - 28.0.53  Prevent worlds from unloading while players are in out-of-world states by tracking all worlds references by every player in the server's player list.
 - 28.0.52  Add Argument serializer for ModIdArgument. EnumArgument can't as vanilla doesn't support extra data.
 - 28.0.51  Sort server.properties while writing.
 - 28.0.50  Fix chunk load failure when entering End portal Closes #6068
 - 28.0.49  Fix Configs not generating correctly on first load Closes #6069
 - 28.0.48  Add hook to load custom mrls/rls not attached to a block or item.  (#6010)
 - 28.0.47  Cover more cases for RightClickBlock event and restore onItemUseFirst (#6009)
 - 28.0.46  Make DimensionManager.SavedEntry save sky light consistently (#6019)
 - 28.0.45  Fix extract inheritance not using proper classpath and update buildscript for FG asm changes.
 - 28.0.44  Grrr. Stupid error. Sorry lex: I fixed it.
 - 28.0.43  Actually reload config when it changes on disk. Closes #5541 and #5959
 - 28.0.42  Move fml's PlayerEvent and TickEvent to forge. Update
            `import net.minecraftforge.fml.common.gameevent.PlayerEvent;`
            to
            `import net.minecraftforge.event.entity.player.PlayerEvent;`
            and
            `import net.minecraftforge.fml.common.gameevent.TickEvent;`
            to
            `import net.minecraftforge.event.TickEvent;`
 - 28.0.41  Bump modlauncher to 3.2.x. Add a sender modid and document IMC. Closes #5746
 - 28.0.40  Turned minecraft into a proper Mod, with a "dummy" language provider.
            Also fixed the "translations" not being available early if an exception occurs
            by force loading the forge and MC ones. Closes #5984
 - 28.0.39  Fix a crash I caused by misunderstanding formatToString (#6007)
 - 28.0.38  Fix userdev setup by moving SAS concept to FG.
 - 28.0.37  Add piston events (#5798)
 - 28.0.36  Fix AT for EntitySpawnPlacementRegistry.register
 - 28.0.35  Make ParticleManager.IParticleMetaFactory public (#5926)
 - 28.0.34  Add button to open mods folder (#5986)
 - 28.0.33  Change ModLoadingException to display ModID instead of ModInfo instance identifier. (#5999)
 - 28.0.32  Fixed PlayerInteractEvents not working (#5976)
 - 28.0.31  Fixed Buttons in the error screen are incorrectly rendered if they are extremely long Closes #5687 (#5924)
 - 28.0.30  Fix LazyOptional throwing NPE to consumers when owners null. (#5772)
 - 28.0.29  Make Villager profession unlocalized name use modids when not 'minecraft' Closes #5977
            Fixed trees able to be generated through water. Closes #6000
            Change Block#toString to use getRegistryName instead of getNameForObject Closes #5937
            Allow Cooking Recipes to deserialize results with stack sizes. Closes #5960
 - 28.0.28  Fixed DimensionType.getRegistryName() returning null Closes #5992
            Fixed RegisterDimensionEvent not firing for new worlds. Closes #5987
 - 28.0.27  Introduce new Side Annotation Stripper system to semi-automate the shipment of Sided methods and cleanup patches.
            New forge:checkSAS task to validate this config file. Closes #5995
 - 28.0.26  Move world unload patch to tick function to prevent duplicate unloading, fix log message in dim manager, fix javadoc for unload method (#5964)
 - 28.0.25  fix melon and pumpkin seeds being peaceable on more than just farmland (#5980)
 - 28.0.24  Fixed possible ClassCastException with dye-able armor. (#5985)
 - 28.0.23  Fix naming for dev launch providers - they're in MCP..
 - 28.0.22  Register a config command. Currently one subcommand: showfile, which
            when passed a modid and a type (CLIENT, COMMON or SERVER) will display
            a link in the caller's chat to open that file in the OS file viewer of choice.
 - 28.0.21  Load default configs from the defaultconfig directory by default. (Can
            be overridden in the fml.toml config file if desired).
            Will load any type of config tracked file from there - client, common, server
            or custom tracked file. This means you can ship defaults for your pack
            in a defaultconfig directory. I am thinking about ways to force a specific
            config override for an existing config.
 - 28.0.20  Fix vanilla bug that hardcore death doesn't clean up properly, leaving
            a running server and a broken GUI. Vanilla bug MC-148865
 - 28.0.19  Fixed network ticking player entity while it is dead. And explicitly prevent overworld from unloading. Closes #5978
 - 28.0.18  Crash report extended to show ModLauncher FML and Forge data.
 - 28.0.17  Fix potion transformer to look up the right name depending on context.
 - 28.0.16  Added a coremod, shush, don't tell Lex.
            Seriously, this is how to do targeted changes to specific classes.
            In this case, adding a fieldtomethod redirect for EffectInstance.potion
            to allow substitution.
 - 28.0.15  Fix Slimes not splitting on death Closes #5973
 - 28.0.14  Fix @ObjectHolderRegistry not properly detecting vanilla class level references. Closes #5958
 - 28.0.13  Fixed missed patch causing blocks to not dropping EXP and BreakEvent to not fire.
 - 28.0.12  Fix & Improve state comparison when checking vanilla block replacements (#5922)
 - 28.0.11  Keep player cap data until they have revived. Closes #5956
 - 28.0.10  Fix objloader registering at wrong time. Closes #5847. Added test
            class as suggested in the issue.
            Note: most tests are commented out at the present time, pending
            rework. Tests that work, work.
 - 28.0.9   Fix datafixer exception catch: Closes #5951
 - 28.0.8   Fix error when ModsDiscoverer visits a non existent mods dir.
            Closes cpw/modlauncher#30
 - 28.0.7   Merge branch 'pull/5948' into 1.14.x
 - 28.0.6   Realms' removal has removed the need for additional jar transformation.
 - 28.0.5   Make I18N format errors less spammy, also remove single apostrophes from
            current translations in en_us.json. Other langs may still have problems.
            Closes #5952
 - 28.0.4   Fix spam during startup (#5957)
 - 28.0.3   Fix forge 1.14.4 startup in obfed enviroment (#5955)
 - 28.0.2   Updated Example Version Range for 1.14.4 (#5950)
            * Updated Example Version Range for 1.14.4
            * Also changed loader version and version range
 - 28.0.1   Fix javac compile issues.
 - 28.0.0   Provisional update to 1.14.4. Missing a lot of playerinteractionmanager patches because everything moved and I'm tired.
            Fix up immediate problems.
            bump to 28.

27.0
====
 - 27.0.61 Update mappings to 20190719 in prep for 1.14.4..
 - 27.0.60 Fix RegistryObject when used with generic registry entry classes
 - 27.0.59 Remove OnlyIn Client Distribution from Effect and EffectType methods. (#5925)
 - 27.0.58 Change default BrewingRecipe to use an Ingredient for the input instead of ItemStack. Closes #5944
           Add AT for GameRules.register Closes #5946
           Fix Forge Blockstate loader model path is inconsistent with vanilla blockstates Closes #5892
           Fix client crashing when opting not to load a world when there's missing blocks Closes #5886
 - 27.0.57 Fix CheckSpawn event logic for natural spawns.
 - 27.0.56 Fixed item breaking particles not capturing current state of the ItemStack. Closes #5934
 - 27.0.55 Fix RenderSpecificHandEvent firing with wrong hand stack (#5927)
 - 27.0.54 [1.14.x] Fix text positioning issues caused by scaling loading screen  (#5932)
 - 27.0.53 Fixed PlayerSleepInBedEvent pos is always null Closes #5936
           Fixed decompile error causing Endless Loop in ModelBackery if model errors exist.
           Fixed NPEs related to teleporting players without portals.
 - 27.0.52 Add simple concurrency protection to Server world list. Closes #5938 and #5739
 - 27.0.51 Update modlauncher to the 3.x series.
 - 27.0.50 Rework GuiModList mod info to use custom scrolling panel impl
 - 27.0.49 Cleanup Forge's Access Transformer, and add ATs for Block.Properties#noDrop, and AxeItem/PickaxeItem. Closes #5866 and Closes #5921
 - 27.0.48 Fix race condition in client mouse handler. Closes #5888
 - 27.0.47 Added LootPool.Builder#bonusRolls setter. Closes #5887
 - 27.0.46 Implemented Item.get/setDamage hooks. Closes #5899
 - 27.0.45 Implement Item.isRepairable in Crafting and Grindstone. Closes #5917
 - 27.0.44 Re-implement state.onBlockExploded() Closes #5914
 - 27.0.43 Add general damage hook for items. Closes #5502 (#5670)
 - 27.0.42 Fix syntax error in IRenderHandler.
 - 27.0.41 Pass tick counter to custom render handlers (#5744)
 - 27.0.40 Fire Loading event (#5795)
 - 27.0.39 Fix logoFile not working properly (#5775)
 - 27.0.38 Adds some explanatory javadocs and check world in ModelDataManager (#5762)
 - 27.0.37 Add InputEvent documentation (#5698)
 - 27.0.36 Add IModelData to getParticleTexture (#5756)
 - 27.0.35 Fixed BakedModelWrapper not delegating new methods (#5761)
 - 27.0.34 Throw exception when a mod returns null from a dispatched capability provider (#5646)
 - 27.0.33 Add isServer and isClient methods to LogicalSide (#5606)
           * Add helper methods to LogicalSide.
           * Fix backwards docs.
 - 27.0.32 Added documentation to ObfuscationReflectionHelper adn deprecated index based functions. (#5893)
 - 27.0.31 Fixed EntityJoinWorldEvent not being fired when player is added to ServerWorld. #5827
           Fixed wrong example path for the access transformer in the MDK build.gradle. #5891
           Added getters for mouse x/y velocity and if the middle-mouse button is being held down. #5776
           Modify issue template for better clarity. #5874
           Fixed grindstone not using ItemStack-sensitive getMaxDamage. #5831
           Added ParticleManager.registerFactory to Forge's AT. #5896
           Fixed NPE in SidedInvWrapper when side was null. #5787
           Moved EndermanEntity.setAttackTarget super call to allow LivingSetAttackTargetEvent the ability to override default behavior. #5778
           Added field to make "Looking at" debug info maximum distance configurable #5714
 - 27.0.30 Disable Config Button when no mods are selected (#5905)
           Closes #5889
 - 27.0.29 Fix MC-258 on mod list screen, enable sorting, minor tweaks. (#5846)
 - 27.0.28 Fixed #5895: Shearing via Displenser drops Shears (#5906)
 - 27.0.27 Fix link applying to whole component in chat if component starts with link (#5909)
 - 27.0.26 Added harvestLevel and harvestTool setter to the Block.Properties. (#5916)
 - 27.0.25 Fix installer realms issue on server.
           Uptake EventBus changes to fix some potential dead locks.
 - 27.0.24 Fix old entity not being removed on dimension change (#5833)
 - 27.0.23 Update TextureStitchEvent.Pre to give access to the list of ResourceLocations that will be loaded as textures. (#5870)
 - 27.0.22 Add installer processor to deobfuscate Mincraft's Realms library.
           This task will processes the current realms library from the json, so the installer must be re-ran every time they update it.
 - 27.0.21 Redirect a method to the recipe book container, to allow modded screens to have a recipe book. (#5873)
 - 27.0.20 Fix WorldEvent.Unload not firing on the client (fixes #5880) (#5884)
 - 27.0.19 Fix TickEvent.PlayerTickEvent firing twice for tick end (fixes #5878) (#5885)
 - 27.0.18 Fix type cast issues in ForgeConfig values. Closes #5894
           Added config value set and save functions.
           By default mod configs are auto-saved, so you do not need to call save unless you create your own Config object.
 - 27.0.17 Remove legacy StartupProgress.
           Implement properly scalable progress thanks to @gigaherz. Closes #5863.
           Implement API for pushing messages to the startup screen from mods.
           Add memory display.
 - 27.0.16 Update coremods to newer version, with support for new targets.
 - 27.0.15 Fix duplicate WorldEvent.Unload call in client key handler.
           Add recipe generator to replace vanilla recipes with Forge tags.
 - 27.0.14 Fix dimension save data invalid cache being to aggressive.
 - 27.0.13 Fix garbled "µs" (#5818)
 - 27.0.12 Fix fmluserdevdata not being a valid launch target.
 - 27.0.11 Split userdev data entry point into it's own provider to fix duplicate mod issue.
 - 27.0.10 Fix configs correcting numeric values when the primitive type differs
           Fix configs with range not clamping the corrected value, and instead
           just replacing with the default
           Closes #5855
 - 27.0.9  Fix item placement losing NBT data in creative mode (#5757)
 - 27.0.8  Add extension to write entry id's to PacketBuffer's (#5812)
 - 27.0.7  Add isItemValid check for ItemStackHandler (#5850)
 - 27.0.6  Fix leather armor dye recipe (#5836)
 - 27.0.5  [1.14.x] Replace dye items in Forge tags. (#5843)
 - 27.0.4  Update readme and issue template. (#5773)
 - 27.0.3  implement Ingredient.getSerializer for custom ingredients (#5813)
 - 27.0.2  Fix vines and scaffolding not being climbable.
           Fix powered rails not spreading power correctly. Closes: #5854
 - 27.0.1  Fix misaligned ServerWorld initCapabilities patch.
 - 27.0.0  Initial 1.14.3 update.

26.0
====
 - 26.0.63 Fix too many registries being sent from server to client
 - 26.0.62 Remove OnlyIn on TagCollection#getOwningTags
           Fixes Block#getTags crashing on servers
 - 26.0.61 Reorganize sided event dispatch slightly. Dispatch model and entityrenderer
           functions at more appropriate times.
 - 26.0.60 Tweak for lowercase handling.
 - 26.0.59 Merge branch 'pull/5793' into 1.14.x
 - 26.0.58 Fix crash when crashing during modloading. Fix GuiModList being weird.
 - 26.0.57 Process the main modloading work on the async thread, but still
           do deferred work on the main thread by passing in the executor.
 - 26.0.56 Clean up config comments, make comment array nonnull
 - 26.0.55 Fix forge event bus never starting up
 - 26.0.54 Automatically add range to config comments
 - 26.0.53 First pass of adding text to the loading progress UI. It deliberately uses the very primitive STB
           generated font, so can only render basic ASCII text, and also only renders pre-defined strings,
           as translations aren't available either.
 - 26.0.52 Add mod failure identification
 - 26.0.51 Moved some events to the Mod's event bus. You'll need to update which bus
           you're listening to for these. (The Mod event bus is the only one actively
           dispatching events during model loading).
           ModelRegistryEvent, ModelBakeEvent, TextureStitchEvent.Pre, TextureStitchEvent.Post, ColourHandlerEvent.Block, ColourHandlerEvent.Item
 - 26.0.50 Fix StartupQuery, and put tests back.
 - 26.0.49 Fix stupid bug introduced with the refactor..
 - 26.0.48 Tidy up mod loading a bit more, and also crash if the [[mods]] list isn't
           a list.
 - 26.0.47 Merge remote-tracking branch 'origin/1.14.x' into 1.14.x
 - 26.0.46 Fix server side loading, tweak mods command.
 - 26.0.45 Fix ModelDataTest
 - 26.0.44 Merge remote-tracking branch 'origin/1.14.x' into 1.14.x
 - 26.0.43 Update mappings, move mod initialization to the async loader.
 - 26.0.42 Fix #5612 add entity to ISelectionContext
 - 26.0.41 Fix #5768 add access to MainWindow object in RenderGameOverlayEvent
 - 26.0.40 Fix #5810 incorrect cullface on some models
 - 26.0.39 Fix #5686 ArmorLayer still calls deprecated getArmorResource
 - 26.0.38 Fix bad patch breaking armor dyeing
 - 26.0.37 Make sure test mods load, fix BlockstateRetextureTest
 - 26.0.36 Fix #5805 ModelBakeEvent does not fire
 - 26.0.35 Fix lighting not being sent to client when large amounts of blocks change at once. Closes #5839
           Remove RecipeType/VanillaRecipeTypes, as 1.14 has a vanilla system for this.
 - 26.0.34 Fix some compile errors in test classes.
 - 26.0.33 Fix Vanilla resources loading from classpath, instead of the extra jar. Causing issues in dev time, and Forge replacements. Closes #5824
 - 26.0.32 Add temporary hard crash when mods error until we can load our error screen.
 - 26.0.31 Make ReverseTagWrapper unmodifiable, fix error in log when mods folder doesn't exist initial scan.
 - 26.0.30 Skip running the datagenerator on unrequested mods.
           Add a run config for the data task for modders to use
 - 26.0.29 Remove paulscode hack. It is not needed in 1.14, since paulscode is
           no longer used.
 - 26.0.28 Modify lex's data handler to use proper mod lifecycle event mechanisms
           instead. New Lifecycle Event for requesting data harvesting. Mods will
           be constructed, the registry will fire, and then a new Data event will
           fire. Submit new data tag files to the data gatherer if you wish.
           The game will shutdown after this. No other mod elements will happen.
 - 26.0.27 Add params for the exception message
           tweak logging
 - 26.0.26 Expose the data entry point and generate Forge's Tags using it.
 - 26.0.25 Add reverse tag cache, to make looking up tags for items/blocks/etc.. less costly.
 - 26.0.24 Update Example Mod (#5781)
 - 26.0.23 Fix AT for EntitySpawnPlacementRegistry.register (#5799)
 - 26.0.22 Implement getValue in ClearableRegistry fixing DimensionArgument. (#5809)
           Fix DimensionArgument
 - 26.0.21 Fix RenderSpecificHandEvent firing with wrong hand (#5789)
 - 26.0.20 Use dragon_immune block tag instead of manually checking blocks (#5792)
 - 26.0.19 Fix #5806 sheep drop shears instead of wool
           lol
 - 26.0.18 Fix incorrect method used in ShrubFeature patch
 - 26.0.17 Rework AbstractTreeFeature patches to reduce impact and avoid name conflicts
 - 26.0.16 Add IContainerFactory for reading custom container data on the client
 - 26.0.15 Fix Fishing and Mineshaft Minecarts loot tables erroring. #5785
           Fix Client block breaking speed not matching the server. #5790
           Fix Village Siege event location, and MC-154328 preventing Sieges starting. #5800
           Fix EntityJoinWorldEvent not firing on client, or some server code paths. #5786
 - 26.0.14 Adjust NetworkEvent#enqueueWork to match vanilla logic
           In singleplayer our packet work could get delayed until the next tick,
           breaking the expectation of packet read order. Fixes that using
           NetworkHooks.openGui would result in missing inventory data on the client
 - 26.0.13 Fix gameDir argument error on dedicated server.
 - 26.0.12 Add forge registries for most vanilla registries
           Made all registry names consistent with their vanilla counterparts
           Also added a system for legacy registry names, so no data will be lost
           Cleaned up formatting in GameData and ForgeRegistries
 - 26.0.11 Add registry flag for syncing
 - 26.0.10 Fix issues preventing test mods loading
 - 26.0.9  Add forge registry for container types, expose ScreenManager.registerFactory
 - 26.0.8  Don't NPE during construction of ModLoadingException..
 - 26.0.7  Fix misobfed methods due to mapping conflict.
 - 26.0.6  Update mappings
 - 26.0.5  Fix block activation not occurring serverside
           Missing block of code from the old patch caused it to be skipped
 - 26.0.4  Rework model patches/classes for new bake signature
 - 26.0.3  Fix NamespacedWrapper not delegating a new getter. Fixing data loading spam at world start.
           Update red/yellow/green tags with new vanilla item names.
           Reenabled test source directory in project and made ModelDataTest compile.
 - 26.0.2  and userdev
 - 26.0.1  Fix realms class name
 - 26.0.0  Fix travis build

25.0
====
 - 25.0.220 Update to 1.14.2
 - 25.0.219 Include new library in installer json.
            Change order of versions on main menu, to prevent overlap with default window size.
            Fix Forge update not displaying version info.
 - 25.0.218 Fix vanilla structures loosing valid flags, And fix error placement for unsaveable structures.
 - 25.0.217 Fix tall grass not dropping seeds. Closes #5675
 - 25.0.216 Enhance crash reports and logging to capture transformers on stack trace elements.
            Moved log4j2.xml file to the launcher source set, so it loads first in the client.
 - 25.0.215 Remove cache eviction for model data, optimize
 - 25.0.214 dimesnion -> dimension typos (#5684)
 - 25.0.213 FENCES_NETHER_BRRICK => FENCES_NETHER_BRICK (#5681)
 - 25.0.212 GEMS_QUARRTZ -> GEMS_QUARTZ (#5635)
 - 25.0.211 Small comment typo fixes for ObfuscationReflectionHelper (#5583)
 - 25.0.210 Fix MC-146650 GuiContainer#keyPressed to return the correct key handled boolean (#5367)
 - 25.0.209 Fix build script producing duplicated eclipse source folders.
            Fix not including userdev source in sources jar.
            Update license header of files that need it.
            Delete patches_old folders. Most are unneeded in 1.13+ as the systems they effected were changed significantly. Any that need to be readdressed can be done as PRs.
 - 25.0.208 Fix caps not being visible on old player during clone event (#5728)
 - 25.0.207 Fix vanilla bug in writing structure templates with multiple palettes.
 - 25.0.206 Add support for vanilla recipes having nbt on result (#5710) Fix #5663
 - 25.0.205 Fix modded TEs not being removed on block change
 - 25.0.204 Fix #5735 by pushing new build. Shutdown Forge eventbus when errors occur. Closes #5711
            Also, improve logging so warnings, errors and fatals are always shown, regardless of marker.
 - 25.0.203 Update 'build.gradle' to fix run configs for launching forge
 - 25.0.202 Remove patch causing TEs to be removed on state change
 - 25.0.201 Fix default IUnbakedModel bake method using wrong format
 - 25.0.200 Add ModelDataTest to test mods.toml
 - 25.0.199 Updated a couple of libraries. Fixed bug where modid could be in toml but
            not found during loading, yet game continued to load.
 - 25.0.198 Add test mods run configs
 - 25.0.197 Better handle errors from eclipse compiled (non-compiling) bytecode
 - 25.0.196 Finish model loader debug mod
 - 25.0.195 Comment out test Mod/EventBusSubscriber annotations, fix up ModelLoaderRegistryTest
 - 25.0.194 Fix BakedQuadRetextured calling old BakedQuad ctor
 - 25.0.193 Add new system for model data, replacing extended states (#5564)
 - 25.0.192 Bump ForgeSPI version, and add support for DistCleaner stripping interfaces from classes.
            Add more detail to VersionChecker log info.
 - 25.0.191 Add explicit return type checks for extensible enums, fix exc
 - 25.0.190 Fix EnumRarity, make sure extensible enums have at least one factory candidate
 - 25.0.189 Make EnumRarity extensible
 - 25.0.188 Allow loading json constants outside of _constants
 - 25.0.187 Update skipped_commits.md
 - 25.0.186 Fix some vertex format changes not being handled correctly (#5368)
 - 25.0.185 Transform vertex normals as well as positions when generating quads (#5242)
 - 25.0.184 Fix for SidedInvWrapper isItemValid using wrong slot (#5642)
 - 25.0.183 Add comment to vanilla bugfix, update skipped_commits.md
 - 25.0.182 Change default username to 'Dev', add ability to replace '#' with randomized numbers
 - 25.0.181 Fix MC-128441: cross-dimensional teleporting does not work
 - 25.0.180 Add Forge dimension-changing hooks to spectator handling code (#5212)
 - 25.0.179 Minor performace improvement when building chunks and rendering blocks (#5286)
 - 25.0.178 Catch json parsing errors from constants/factories files (#5258)
 - 25.0.177 Allow custom DataSerializers to be registered safely (#5245)
 - 25.0.176 Further clean up Constants, and add two new BlockFlags
 - 25.0.175 Remove unnecessary patch
 - 25.0.174 Update skipped_commits.md
 - 25.0.173 Fail fast when null is used with setTag instead of crashing in writeEntry (#5257)
 - 25.0.172 Update Constants for 1.13
 - 25.0.171 Added more Constants (#5323)
 - 25.0.170 Add a few events pertaining to villages (#5302)
 - 25.0.169 Sync up canPlaceTorchOnTop logic with BlockTorch#isValidPosition
 - 25.0.168 Update skipped_commits.md
 - 25.0.167 Fix special spawn event not firing in many cases. (#5389)
            Co-authored-by: tterrag <tterrag1098@gmail.com>
 - 25.0.166 Only prompt for missing registries on local worlds (#5348)
 - 25.0.165 Reimplement ForgeHooks#onPlaceItemIntoWorld and remove old place events
 - 25.0.164 Add EntityPlaceEvent (#5057)
            Co-authored-by: tterrag <tterrag1098@gmail.com>
 - 25.0.163 Fix small logic error in ItemTextureQuadConverter (#5463)
 - 25.0.162 Better support for custom bows (#5209)
 - 25.0.161 Fix up torch placement logic to handle more vanilla special-casing (#5426)
 - 25.0.160 Update skipped_commits.md
 - 25.0.159 Written size does not include int bytes.
 - 25.0.158 Extend Region files to support >1MB per chunk.
            If the 'sector count' is 255, ask the compressed data header for the proper length.
 - 25.0.157 Simplify custom item rendering by removing GL emissivity hacks
 - 25.0.156 Support diffuse lighting flag in item rendering
 - 25.0.155 Add a hook to allow continuously using items through stack changes (#4834)
 - 25.0.154 Update skipped_commits.md
 - 25.0.153 Add redirects to PotionEffect to respect registry replacement (#5213)
 - 25.0.152 Add FieldRedirectTransformer updated to new modlauncher API
 - 25.0.151 Fix small logic error in emissive item rendering code (#5320)
 - 25.0.150 Ensure slave maps are cleaned up when handling registry overrides (#5250)
 - 25.0.149 Remove hack to force enum configs to strings
 - 25.0.148 Fix #5688 config values are unordered, update Night-Config
 - 25.0.147 Cleanup/Implement some todos (#5660)
 - 25.0.146 Readd redirecting of stdout and stderr (#5678)
 - 25.0.145 Fix some typos in spawn dimension patches (#5669)
 - 25.0.144 Remove Vanilla Logging Config (#5618)
            This will re-enable Forge's logging configuration in "production"
 - 25.0.143 Add GuiContainerEvent.DrawBackground event. (#5595)
 - 25.0.142 [1.13.x] Fire InputEvents (#5533)
 - 25.0.141 Fix compile error in FakePlayer from cherry pick
 - 25.0.140 Update skipped_commits.md
 - 25.0.139 Fix potential issues with the Minecraft FakePlayer lingering around after world unloads.
 - 25.0.138 Fix potion remove event not always firing, add expiry event
 - 25.0.137 added PotionHooks, closes #3867, #4375 (#4614)
 - 25.0.136 Fix EntityDataManager logging level
 - 25.0.135 Fix some typos in cherry-picked commits
 - 25.0.134 Update skipped_commits.md
 - 25.0.133 Add a hook for farmland watering (#4891)
 - 25.0.132 Add logging for data manager key registration errors (#5129)
 - 25.0.131 Fix #5659 setdimension command entity filtering, avoid inverting logic
 - 25.0.130 Improve support for custom block path types (#5203)
            Co-authored-by: tterrag <tterrag1098@gmail.com>
 - 25.0.129 Allow items to control the rate of repair from mending (#5102)
 - 25.0.128 Update skipped_commits.md
 - 25.0.127 Improve exception handling from server starting events (#5226)
 - 25.0.126 Improve context provided by potion icon rendering hooks (#5111)
 - 25.0.125 Fix an ObjectHolderRef internal error message (#5214)
 - 25.0.124 Implement rendering for item models with emissive quads (#5047)
 - 25.0.123 Fix inaccurate main thread name shown in client log (#5078)
 - 25.0.122 Fix Baked Item models with transformations (#5241)
 - 25.0.121 Update skipped_commits.md
 - 25.0.120 Stop firing LivingSetAttackTargetEvent for setRevengeTarget (#5217)
 - 25.0.119 Fix missing string parameters in some log messages (#5210)
 - 25.0.118 Re-add some missing villager profession patches (#5200)
            * Fix zombie villagers only spawning with vanilla professions
            * Fix spawning modded villagers that do not have their own building
 - 25.0.117 Fix the bed position given to the SleepingTimeCheck event (#5107)
 - 25.0.116 Fix some null returns from defaulted registries (#5235)
 - 25.0.115 Only remove synthetic lambda methods referenced in body of SideOnly methods (#5127)
 - 25.0.114 Update skipped_commits.md
 - 25.0.113 fixed visual bug with guislider
 - 25.0.112 Make Forge blockstate variants correctly inherit AO setting from vanilla models (#5190)
 - 25.0.111 Make Forge-provided default transforms accessible to custom models
 - 25.0.110 Actually parse the i18n exception message into the super constructor,
            so the exception has a useful text message, even in crash logs and
            on the server.
 - 25.0.109 Refactor to use naming service, and provide an MCP naming service when
            in userdev. Step 1 to supporting loading SRG mods in userdev.
 - 25.0.108 Fix respawnevent being fired with old player instead of new. Fixes #5658 (#5668)
 - 25.0.107 Implement API for mods to control their server status response..
 - 25.0.106 Merge branch 'pull/5636' into 1.13.x
 - 25.0.105 Fix StartupQuery to run properly on dedicated server.. Closes #5649
 - 25.0.104 Remove remaining deprecations, improve a few patch comments
 - 25.0.103 Fix BrandingControl caching text through resource reload
 - 25.0.102 Add back EntityPlayer patch to return main inventory in IItemHandler
            Fixes #5638
 - 25.0.101 Fire the ModIdRemappingEvent on the Forge Event bus. Closes #5632
 - 25.0.100 Remove redundant method call in Minecraft patch. Also fix a translation
            string error (closes #5643)
 - 25.0.99  Add method to IResourcePack to hide it entirely from the UI (#5525)
 - 25.0.98  Remove game registry comparsion from list ping
 - 25.0.97  Defer configuration of channel until it is actually available during
            connection. Closes #5626
 - 25.0.96  Add class to wrap IItemHandler as IInventory for easier recipe interaction. (#5522)
 - 25.0.95  Remove uses of java.awt (#5591)
            `java.awt` will statically load itself when `java.awt.Color`, `java.awt.Dimension`, etc are loaded.
            This conflicts with lwjgl3 and must be avoided (except for in mojang's server gui).
 - 25.0.94  Fix PlayerInteractEvent using Dist when it should be using LogicalSide (#5611)
 - 25.0.93  Re-Add the list ping compatibility checker
 - 25.0.92  Update Night-Config to 3.5.0, improve defineEnum methods
            Closes #5537
 - 25.0.91  Fix loading errors GUI crashing when errors occur during construction
 - 25.0.90  Revive CapabilityProvider on entity revive. Madders should NOT need this, as caps are copied via NBT.
 - 25.0.89  Do not invalidate caps when entity is being moved across worlds. Should fix #5500
 - 25.0.88  Fix NPE in TileEntityPistonRender when class is created to early.
 - 25.0.87  Fix getDefaultCreatorModId for enchanted books (#5534)
 - 25.0.86  Handle null return from ResourcePackInfo.createResourcePack
 - 25.0.85  Allow login packets to only generate on server based connections
            Run injectSnapshot on the client thread, wait for result and
            disconnect when injectSnapshot fails.
            Fix DevServer to load MOD_CLASSES
            Fix LaunchTesting to properly load log4j2 markers (don't use a
            static variable in that class!)
 - 25.0.84  Exclude PR builds from discord and changelog
 - 25.0.83  Exclude noci branches from travis
 - 25.0.82  Fix being unable to plant nether wart (#5572)
 - 25.0.81  Fix silk touch not working on Ender Chests.
 - 25.0.80  Fix entity spawn packet pitch (reversed yaw/pitch) (#5603)
 - 25.0.79  Fix invalid inventory being sent to ItemCraftedEvent Closes #5580
            Fixed custom ingredient network serialization by removing unneeded mark. Closes #5577
            Changed HorseArmorType constructor to not prefix vanilla paths to custom armors. Closes #5574
            Fix removeBlock being called with invalid canHarvest value. Closes #5570
 - 25.0.78  Add UI for warnings that occurred during loading (#5530)
 - 25.0.77  Fix max entity radius not being settable by making it a instance method on world. Closes #5601
            Fix VoidFluidHandler.INSTANCE not being a instance of VoidFluidHandler. Closes #5602
            Remove backwards compat code and make IItemHandler.isItemValid non-default. Closes #5598
 - 25.0.76  Add way to publish the reobf Jar with the maven-publish
            task. The standard way does not publish reobfuscated
            artifacts.
 - 25.0.75  Add in the ability to load modlists from a file.
            This is simple: <modfile>.list is a newline separated list
            of maven-like coordinates for mods to load into the game.
            They are searched for in all known maven roots.
 - 25.0.74  Fix rails not being able to be placed on hoppers.
 - 25.0.73  DimensionManager.registerDimension now returns the DimensionType instance for convienance.
            You can still access others in DimensionType.getByName()
            Fixed ForgeRegistry rappers not forwarding isEmpty.
 - 25.0.72  Refactor Userdev and Forgedev launching.
            Locating mods on the classpath in dev should solve linked MC sources when debugging.
            As well as loading deobfed mods.
            Rewrote how arguments are handled in dev, so users can overwrite any defaults we provide.
            Added basic Yggdrasil auth support. Passing in --username and --password arguments.
            ONLY USE IF NECESSARY. Forge is NOT responsible for your login information.
 - 25.0.71  Make userdev parse out the classifier for the Forge jar that is on the classpath.
            Should fix debugging Minecraft at dev time.
 - 25.0.70  Tidy up network initialization, and force it to classload early in
            modloading lifecycle. Closes #5576
 - 25.0.69  Tweak log4j2 config and allow access to classdump functionality from
            modlauncher.
 - 25.0.68  Fix #5584 by copying the zipped resource to a temporary directory if
            paulscode is requesting it. This is so icky.
 - 25.0.67  Log a message as well, when we crash.
 - 25.0.66  Try writing a temporary file to disk when a paulscode thread requests
            a resource, because even zipfilesystems return interruptible file channels.
 - 25.0.65  Enforce specversion number for forgeSPI so we don't crash with weird errors later.
 - 25.0.64  Put both LogicalSides on NetworkDirection:
            Origination (where it came from) and Reception (where it arrived at).
 - 25.0.63  Rewrite the FML Handshake packet formats to include actually syncing the registry data and introduce the concept of caching it locally.
            Snapshots are not injected yet due top threading issues.
 - 25.0.62  Handle differing network versions for FML gracefully?
 - 25.0.61  Fix problem with duplicate mods caused by duplicate classes found during scan.
            File Scan results are now sets.
 - 25.0.60  Try to fix #5573 by peeling the worldclient fetch into a separate handler.
 - 25.0.59  Tidy up server launch. The JAR will resolve it's libraries from a relative
            path. We just need to verify what we need is on the classpath, and
            try and handle when it's not, cleanly (by recommending running the
            installer).
            The manifest now embeds the correct launch arguments to allow FML to
            resolve - these were _never_ editable, and belong somewhere out of
            the way.
 - 25.0.58  Add missing constructors in KeyBinding to match existing vanilla constructors. (#5480)
 - 25.0.57  Update MDK Readme to describe new FG3 procedures. (#5553)
 - 25.0.56  Fix Custom Entity Data not persisting between world loads. Closes #5562
            Fix BlockRailState inverting flexibility flag. Closes #5550
            Disable Forge's hooks on dispensing Buckets until Fluid system re-write. Closes #5545
            Fix modifier only keybinds. Closes #5544
 - 25.0.55  Fix entity shearing logic (#5566)
 - 25.0.54  Fix droppers not spawning items in world (#5559)
 - 25.0.53  Allow vanilla connections properly, and allow mods to decide.
 - 25.0.52  Patch DimensionSavedDataManager to not spam FS mkdirs requests for
            empty files that don't exist yet, and don't contain data. Should
            result in a significant performance improvement for those with slower disks.
 - 25.0.51  Fix GUI packet dispatch, add additional blockpos helper for common usecase.
 - 25.0.50  Fix startup Query to actually display (fixed commit).
 - 25.0.49  Update to 0.10 modlauncher API with performance improvements..
 - 25.0.48  Hide the webhook address so people don't spam it.
 - 25.0.47  Remove debug leftovers from Jenkinsfile.
 - 25.0.46  Delete old OreDictionary file, fix type in NUGGETS_IRON field name, and ping discord from jenkins.
 - 25.0.45  Merge extra and data jars. As Log4j has issues with it's config being in a different jar then the custom logger.
 - 25.0.44  Add GuiUtils.drawInscribedRect, use in mod list GUI to fix logo rendering
 - 25.0.43  Fix reference to UnsafeHacks in RuntimeEnumExtender
 - 25.0.42  Fix double tall plants not being shearable, add IShearable to seagrass
            Closes #5524
 - 25.0.41  Add back missing ItemColors patch (#5474)
 - 25.0.40  Fix entities being killed in one hit. Closes #5511
            Fix unloc pattern for tps output
 - 25.0.39  Fix MinecraftForge.initialize not being called.
            Fixes UsernameCache and harvest tools
            Closes #5529
 - 25.0.38  Make BannerPattern extensible (#5464)
 - 25.0.37  Remove EnumFacing internal ID maps from AT file (#5526)
 - 25.0.36  Fix GuiEnchantment using wrong value to index enchantClue array (#5452)
 - 25.0.35  Fix some minor patch regressions (#5490)
 - 25.0.34  Altered EntityType registry to use a Forge based registry (#5493)
 - 25.0.33  Fix bug with ObfuscationReflectionHelper (#5509)
 - 25.0.32  Move unsafehacks to separate JAR built separately..
 - 25.0.31  Clean up Entity patches, remove extra method. Closes #5494
 - 25.0.30  Remove now defunct eclipse files from MDK
 - 25.0.29  Add a simple network API..
 - 25.0.28  Refactor forge and example run configs based on MinecraftForge/ForgeGradle#546
            - Updated run config formats based on the refactored setup
            - Removed old 'runclient' and 'runserver' JavaExec tasks, replacing them by creating the run configs using the refactored setup.
            - Set 'assetIndex' environment variable from FG
            - Updated MDK for new run config setup
 - 25.0.27  Make SpawnPlacementType extensible, remove from ArmorMaterial
 - 25.0.26  Fix connection to vanilla servers. Generate a default mod server config
            for mods connecting to servers.
 - 25.0.25  Fix TPS string
 - 25.0.24  Change openGui to take a Consumer<PacketBuffer>
 - 25.0.23  Fix author and other strings in the mdk mods toml file, update coremods to 0.3.+
 - 25.0.22  Fix World crashing on load Fixes #5499 (#5503)
 - 25.0.21  Actually dispatch handleWorldDataSave. Closes #5492
 - 25.0.20  Merge branch 'pull/5483' into 1.13.x
 - 25.0.19  Fix assetIndexes for 1.13.1
 - 25.0.18  Fix travis build for 1.13.x branch
 - 25.0.17  Merge branch 'pull/5484' into 1.13.x
 - 25.0.16  Fix lazy ModContainer evaluation skipping thrown loadingExceptions
            Fix formatting
 - 25.0.15  Fixes #5446 Listening for the same registry event in two different mods fails
            Tell the mod event bus not to track phasing for events.
 - 25.0.14  Add back missing patch for Item.BLOCK_TO_ITEM
 - 25.0.13  Fix the MDK..
 - 25.0.12  Fix network syncing of SERVER config. Enable COMMON Config. Fix network
            login handling.
 - 25.0.11  Fix serverlang loading issue, by frontloading MC and Forge langs,
            so error messaging works.
 - 25.0.10  Use MC VERSION in the dependencies string for the extra jar
 - 25.0.9   Publish to mainline
 - 25.0.8   Remove Forge ChunkLoader - vanilla has a new system. API will follow.
 - 25.0.7   Fix Block$Properties AT for new class name
 - 25.0.6   Fix VillagerRegistry
 - 25.0.5   Add the language providers to the main classloader as well, so
            their resources are available to other classes..
 - 25.0.4   Fix RegistryManager#getRegistry not working for generic registry entries
 - 25.0.3   Fix license headers
 - 25.0.2   Fix GlowstoneFeature patch name
 - 25.0.1   Fix javac compile issues.
 - 25.0.0   Initial 1.13.2 update. Major thing to note is that Dimensions have been completely revamped.
            DimensionType is not unique per Dimension. See DimensionManager for more details.
            Vanilla now has a chunk loading system, so Forge's will need to be deprecated/adapted.

24.0
====
 - 24.0.192 Actually fix byte array behaviour for openGui.
 - 24.0.191 Fix byte array behaviour for OpenContainer packet
 - 24.0.190 Clean up the mod loading context objects. There is only one ThreadLocal now.
            **BREAKING CHANGE** FMLModLoadingContext is renamed to FMLJavaModLoadingContext.
            LanguageProviders can setup additional contextual data.
 - 24.0.189 Implement a GUI packet and GUIFACTORY for triggering from the server.
 - 24.0.188 Merge branch 'pull/5451' into 1.13-pre
            # Conflicts:
            #	patches/minecraft/net/minecraft/entity/player/EntityPlayer.java.patch
 - 24.0.187 Handle bad formats with an exception. Translators MAKE SURE you watch for this error!
 - 24.0.186 Handle invalid JAR files more gracefully. Don't crash.
 - 24.0.185 Fix JKS to be stored as binary
 - 24.0.184 Enable https to Let's Encrypt endpoints by using an SSL factory with
            the two extra Let's Encrypt root certs installed into an auxiliary
            keystore.
            The keystore was generated using standard commands, documented in the
            FixSSL class.
            The Let's Encrypt certificates are not provided by default in Java 8
            prior to update 101.
 - 24.0.183 Its 2019. Update licence headers to match.
 - 24.0.182 Fix Terminal Handler and GUI logging on dediserver, hopefully..
 - 24.0.181 Fix config to use new system properly, without exploding the server.
            Separates server specific config into the server config file.
 - 24.0.180 Fix up accidental newline removal that broke the console...
 - 24.0.179 Fix #5429 properly, without breaking symlinks on linux..
 - 24.0.178 Move to using Minecrell's terminal logger directly, for better ANSI control and JLine support.
 - 24.0.177 Make a second logger with colour highlighting and control it with a sysproperty:
            forge.logging.colourconsole.level (defaults to off)..
 - 24.0.176 Tidy up modcontainer building and discovery..
 - 24.0.175 Use a configuration value for the thread count, make it default to
            availableProcessors when set to <=0 (default value is -1)
 - 24.0.174 Revert "Make sure to create entire path for directory, fixes #5429"
            This reverts commit 77dd9eb8
            This will completely break symlinks on linux.
 - 24.0.173 Port CommandEvent and custom entity selectors to 1.13 (#5411)
 - 24.0.172 Finish off most old patches, fix issue for mounted entities.
 - 24.0.171 Patch direct accesses to Entity.type to use getter instead (#5308)
 - 24.0.170 Tentatively reintroduce a container-opening system
 - 24.0.169 Add synchronized modifier to runtime enhanced enum methods
 - 24.0.168 Add IExtensibleEnum, fix DimensionType create method
 - 24.0.167 Change IRenderHandler to an interface Closes #4640
 - 24.0.166 Made functional interface IChunkGeneratorFactory public (#5395)
 - 24.0.165 Fix leaking unclosed InputStream in Scanner.fileVisitor (#5432)
 - 24.0.164 Invalidate capabilities that we attach to vanilla entities and TileEntities. Closes #5307
 - 24.0.163 'Fix' Specific y-levels in water behaving like you're in air. Closes #5341
 - 24.0.162 Reintroduce ObfuscationReflestionHelper closes #5373
 - 24.0.161 Fixed Crosshair attack indicator texture issue Closes #5442
            Add friendlier error message for @Mod annotations with missing mods.toml entry. Closes #5440
            Remove Log4J console highlighting. As it doesn't work on many consoles, and prints invalid characters. Closes #5420
 - 24.0.160 Let ItemGroup provide it's own tabs image resource location (#5330)
 - 24.0.159 Allow GuiContainer and ItemGroup to specify slot hover colors (#5332)
 - 24.0.158 Port Minecraft client patch for 'ClientTickEvent' (#5397)
 - 24.0.157 Fix statistics gui crashing when handling input events (#5435)
 - 24.0.156 Properly set context classloader in mod loading threads.
 - 24.0.155 Rework server launching at runtime to include needed default arguments and validate libraries exist.
            Move Forge config loading to manual while config system is in development.
 - 24.0.154 Added 'create'-method for EnumCreatureType (#5400)
 - 24.0.153 Fix redstone power calculation (#5433)
 - 24.0.152 Fix wrong grass block being used for comparisons (#5434)
 - 24.0.151 Make sure to create entire path for directory, fixes #5429
 - 24.0.150 Put the FMLModContainer back in it's cage. Delete the ClasspathLocator.
 - 24.0.149 Use the resource pack directly in the GuiModList, skip the resourcepackinfo.
            Closes #5418
 - 24.0.148 Fix inventory items not properly being synced to client. Closes ##5421 & #5417
 - 24.0.147 Expose the ModFile in the scan data, so languages can read it and make
            mod construction decisions.
 - 24.0.146 Fix RuntimeEnumExtender creating new enums with incorrect ordinal value (#5402)
 - 24.0.145 Config watching and config events now actually work!
            Also fixed small bug with MOD_CLASSES not defaulting to empty string.
 - 24.0.144 ConfigEvents - the beginning.
 - 24.0.143 Merge branch 'pull/5405' into 1.13-pre
 - 24.0.142 Fix 5408 by making Paths from the default provider (not inside jars)
            offer a FileInputStream rather than Files.newInputStream. Fun. Stupid
            ancient paulscode.
 - 24.0.141 More old patch work, cleaned up static methods added to ItemStack, and various networking functions.
 - 24.0.140 Config option implemented
 - 24.0.139 Reimplement update checker
 - 24.0.138 Update for ForgeSPI change, revert back to VersionStatus checking
 - 24.0.137 Bring back the forge beta warning. Use a check to see if the forge minor version is zero, as ForgeVersion.getStatus() is not implemented
 - 24.0.136 Merge branch 'pull/5404' into 1.13-pre
 - 24.0.135 Use recommended approach to applying version data to mdk.
 - 24.0.134 Fix mdk properties - now the mdk offers default console debug logging
            with various useful channels for development enabled.
 - 24.0.133 Fixed missed OptionalCapabilityInstance to LazyOptional refactors in patches
 - 24.0.132 Refactor OptionalCapabilityInstance to LazyOptional; clean up
            - Move to util package, rename to LazyOptional
            - Clean up existing javadocs, add javadocs to everything missing them
            - Add more NonNull functional interfaces, and use them everywhere
            - Move orEmpty() to Capability, works better here anyways
 - 24.0.131 More logging tweaks, including some aimed at userdev.
            `forge.logging.markers=<LIST OF MARKERS>` will enable markers.
 - 24.0.130 Big cleanup of logging. Might do some tweaks of the userdev logging, but this should be good for vanilla..
 - 24.0.129 Cherry pick mezz's logging improvements..
 - 24.0.128 Update to 0.9.0 of modlauncher..
 - 24.0.127 Merge branch 'ichttt-fixDuplicateNamespace' into 1.13-pre
 - 24.0.126 Fix some of minecraft's resources loading twice, as minecraft is on the list of namespaces as minecraft and as an empty string
 - 24.0.125 Fix modsorter to not crash on soft dependencies that don't exist.
 - 24.0.124 Fix resource pack info generator - use the first modid as part of the
            pack prefix.
 - 24.0.123 Make MOD_CLASSES available to the forge development environment as well.
 - 24.0.122 Change MOD_CLASSES to support %% separated paths, that are grouped into
            <prefix>%%<path> sets. Allows for multiple mods to be located in UserDev.
 - 24.0.121 Fix handing the "minecraft" dependency properly by adding it to the list
            of mods.
 - 24.0.120 Send head yaw, use setPositionAndRotation
 - 24.0.119 Add license header
 - 24.0.118 Clean up patch a bit, check for net.minecraft.
 - 24.0.117 Readd modded entity spawning/tracking support
 - 24.0.116 Fix first call to ToolType.get always returning null (#5396)
 - 24.0.115 Fix NPE in ItemGroup concurrency patch
 - 24.0.114 A couple of minor improvements and fixes to ForgeConfigSpec (#5394)
            - Use the config file's path instead of the config object in error messages.
             - Print the dotted path of each config key instead of the array version (group.item instead of [group item]).
             - Fix comments causing a config file to be considered incorrect.
             - Pass each list element to the element validator, rather than the whole list.
 - 24.0.113 Add RecipesUpdatedEvent, fired when recipes are downloaded from the server. (#5303)
 - 24.0.112 [1.13] A sweep through deprecations (#5345)
 - 24.0.111 Add a RayTraceResult method to Block that can be can be overridden (#5354)
 - 24.0.110 [1.13] Make Caps, TESR, Entity renderers, and keybinds thread safe to call during parallel init (#5359)
 - 24.0.109 [1.13] Check canSustainPlant for valid ground in BlockBush (#5362)
 - 24.0.108 Repatch missed hasTileEntity redirects. And cleanup related patches. Closes #5369
 - 24.0.107 Fixed fence and iron bars block placement (#5372)
 - 24.0.106 Make ChunkGeneratorType.Settings accessible for modders (#5376)
 - 24.0.105 Make ItemGroup constructor threadsafe (#5384)
 - 24.0.104 Fix item interaction in creative mode. (#5385)
 - 24.0.103 Fix #5365: Some chat messages lose their formatting (#5386)
 - 24.0.102 Fix vanilla trying to load the constants json as an recipe. Closes #5388
            Force constant names to use namespace of their json file. To prevent conflicts.
 - 24.0.101 Add recipe types for faster runtime iteration. (#5312)
 - 24.0.100 Fix capability attach event not firing with base type
 - 24.0.99  Port Minecraft client patch for 'RenderTickEvent' (#5329)
 - 24.0.98  Add back several missing patches for FML events (#5390)
 - 24.0.97  Fix dependents not being loaded into mod sorter
 - 24.0.96  Improves topological sort
            This can be used for mod sorting, dependencies between registries, etc.
            e.g. https://github.com/MinecraftForge/MinecraftForge/pull/4694#issuecomment-412520302
            New features:
            Now accepts guava graph
            Performance improvement: no longer reverse the graph; changed dfs to bfs
            Accepets a comparator for secondary order, e.g. natural order, index by map
            Now properly reports all cycles in a graph with Tarjan's strongly connected component algorithm
            Adds a test to prove the validity of the sort and cycle detection
            Modified build.gradle for test source directory and dependencies
            Mod loading changes:
            Sort mod file info instead of suppliers (we don't have suppliers instances)
            Moves cycle error reporting out of topological sort and into mod sorter
            Prevent mod file dependencies between mods that share the same file
 - 24.0.95  Expose a couple of mods.toml properties properly. Half-implemented
            override namespace - still needs to be reviewed and determined how this
            might work in detail.
 - 24.0.94  Use the reply logical side when enqueing work
            When receiving a packet, NetworkDirection.getLogicalSide details where
            the packet was the packet was sent from. Therefore, on a client it'll
            be SERVER (and vice virsa), and so the work is queued on the sever
            thread, instead of using Minecraft.
 - 24.0.93  Use minecraft's util class to open files
 - 24.0.92  Validate mod ids
 - 24.0.91  Fix classcast in autoeventsubscriber, also actually make progression
            work properly. This whole thing is a bit of a gross hack.
 - 24.0.90  Fix recipe constants being overridden by a blank map. Closes #5380
 - 24.0.89  Fix case error in AutomaticEventSubscriber
 - 24.0.88  Tell travis to skip 1.13 builds - they don't work there.
 - 24.0.87  Move Registry Events to the mod event bus.
            Add infrastructure to allow parallel or synchronous dispatch of
            mod events, and pass-through of events to the dispatch system.
 - 24.0.86  Greatly improve DeferredWorkQueue API (#5357)
 - 24.0.85  Add utilities that RuntimeEnumExtender expects to exist
 - 24.0.84  Re-introduce patch for injecting registry mappings during world loading.
            And re-introduce registry freezing to ONLY the Register events.
            Filter ObjectHolders by registry type and fire between every Register event.
 - 24.0.83  Implement ConfigValue as a wrapper around ForgeConfigSpec results (#5361)
 - 24.0.82  Fix exploded directory locator to actually scan all paths for a file.
 - 24.0.81  Update MDK for new naming scheme
 - 24.0.80  Fix up event naming, move them to sensible packages and document everything a bit.
 - 24.0.79  [1.13] Expand tag deserializer to add optional values and remove values without overwriting everything. (#5350)
 - 24.0.78  Fix mod lifecycle event names
 - 24.0.77  Update a bunch of libs, rename some of the mod events to more
            meaningful names.
 - 24.0.76  Add list support to ForgeConfigSpec.
            Fix incorrect Supplier used in ForgeConfigSpec.
            Port ForgeChunkManager config to new system.
            Delete old Configuration classes. It's finally gone!
 - 24.0.75  Add list of so-far skipped 1.12 commits
 - 24.0.74  Add CreativeTabs#getLabelColor
            Patch skipped, was already applied in https://github.com/MinecraftForge/MinecraftForge/commit/47a11b9a7e35c2a2273b6828bd802f2cb06f5cd7#diff-0ea0358443c2ecf3b8682228736149b3R71
 - 24.0.73  Allow providing a BufferedImage for banner render generation (#5041)
            Ported to 1.13 using NativeImage
            Co-authored-by: tterrag <tterrag1098@gmail.com>
 - 24.0.72  Fix Mesa biome entry tags in the BiomeDictionary (#5177)
 - 24.0.71  Patch PotionHelper to use registry delegates (#5142)
 - 24.0.70  Update github stale so issues can be Assigned
 - 24.0.69  Fix MC-136995 - Chunk loading and unloading issue with entities placed in exact positions. (#5160)
            This includes three commits from 1.12.x:
            https://github.com/MinecraftForge/MinecraftForge/commit/c20a5e8805f64097430cf0722011f20862a8df9c
            https://github.com/MinecraftForge/MinecraftForge/commit/93b704b459c6f537d3b1651008c49ce1db2e0ca1
            https://github.com/MinecraftForge/MinecraftForge/commit/ee0d43bbde37e258c36de1003436dbe3fcf88077
            Scatter gun patches to improve entity tracking and position tracking.
            Provided by Aikar through the Paper project, this commit of patches combines the following patches:
            https://github.com/PaperMC/Paper/blob/fd1bd5223a461b6d98280bb8f2d67280a30dd24a/Spigot-Server-Patches/0306-Mark-chunk-dirty-anytime-entities-change-to-guarante.patch
            https://github.com/PaperMC/Paper/blob/fd1bd5223a461b6d98280bb8f2d67280a30dd24a/Spigot-Server-Patches/0315-Always-process-chunk-registration-after-moving.patch
            https://github.com/PaperMC/Paper/blob/fd1bd5223a461b6d98280bb8f2d67280a30dd24a/Spigot-Server-Patches/0335-Ensure-chunks-are-always-loaded-on-hard-position-set.patch
            https://github.com/PaperMC/Paper/blob/fd1bd5223a461b6d98280bb8f2d67280a30dd24a/Spigot-Server-Patches/0378-Sync-Player-Position-to-Vehicles.patch
            Co-authored-by: Gabriel Harris-Rouquette <github@gabizou.com>
 - 24.0.68  Fix blockstate id map calculation. (#5279)
 - 24.0.67  Move @EventBusSubscriber application to just after construction instead of pre-init.
 - 24.0.66  Make Block.Builder methods accessible. Closes #5310 (#5313)
 - 24.0.65  Fix exception mismatch for entity types (#5344)
 - 24.0.64  Fix datapack walking not working for mod datapacks. Closes #5334 (#5335)
 - 24.0.63  Add missing setSeed calls to ForgeBlockModelRenderer (#5338)
 - 24.0.62  Reimplement @ObjectHolder scanning, and expose system for others to add handlers.
            Fix forgedev and userdev run configs.
            Fix issue in log functions assuming String arguments.
 - 24.0.61  Fix reference to IForgeDimension.SleepResult being through Dimension, thus causing a Srg2Source issue.
            And improper getWorld patch.
 - 24.0.60  Update userdev and runconfigs for ForgeGradle changes.
 - 24.0.59  Fix some translation strings. Will pull a big string update from crowdin too.
 - 24.0.58  Fire registry events before preinit and after construct.
 - 24.0.57  Update to 0.4.0 of modlauncher
 - 24.0.56  Fix classloading properly. ModLoadingClassLoader doesn't work
            with the proper delegation model. Abandoned it, in favour of injecting
            locators into the Transformer classloader directly.
 - 24.0.55  Fix up some stuff with resource packs, so the guilist works properly.
 - 24.0.54  Update mdk with some tweaks for building
 - 24.0.53  Finish up classloading system. Use ModJARURL to locate resources
            and enable ModLauncher to use those instead. This allows all mods to load
            within the scope of the game classloader, removing weird conflicts and
            class discovery problems.
 - 24.0.52  client and server work standalone and in forge dev. Next up userdev.
            Moved some launchplugin code to the launcher. Moved servermain to
            the launcher.
            server currently needs cmdline arguments  --fml.forgeVersion=24.0.51-1.13-pre --fml.mcVersion=1.13 --fml.mcpVersion=2018.09.12.04.11.00 --fml.forgeGroup=net.minecraftforge.test
 - 24.0.51  fix up some discovery code, and make regular runtime _mostly_ work.
            Still WIP and doesn't quite get to main screen yet.
 - 24.0.50  Fix new launcher jar packaging.
            Run license checker over new code.
 - 24.0.49  separated fmllauncher code from main forge mod code. This enables much
            stronger classloader separation between the two sides. Forge now
            loads as a regular mod.
            Still needs a bunch of debugging, but structure looks good and game loads
            in forge dev.
 - 24.0.48  ResourceLocation Utils for doing things..
 - 24.0.47  Better documentation for IForgeWorldType, TERFast, TERAnimation
            Also rename AnimationTESR to TileEntityRendererAnimation
 - 24.0.46  Fix patch mistake in IForgeWorldType: CUSTOMIZED -> BUFFET
 - 24.0.45  Clean progress bar code and fix TextureMap patch (#5304)
 - 24.0.44  Implement GuiScreen events for mouse and keyboard (#5297)
 - 24.0.43  Add the sender to NetworkEvent.Context for server-side event handlers (#5295)
 - 24.0.42  Port most of the world patches (#5294)
 - 24.0.41  Change how Forge itself is located to be loaded similar to a real mod.
            Fixes Minecraft/Forge annotation data missing.
            Fix Capability injection.
 - 24.0.40  FastTESR -> TileEntityRendererFast
 - 24.0.39  Rendering patches (#5262)
 - 24.0.38  Added JVM argument so lwjgl dll extraction works with unicode os usernames, closes #5282 (#5283)
 - 24.0.37  Change getWorld function name to prevent inheritance change in Chunk
 - 24.0.36  Fix the path handling for mod jar resource packs. (#5228)
 - 24.0.35  Add raytrace logic to the GuiOverlayDebugForge, so that the debug overlay can show the currently targetted block and liquid. (#5278)
 - 24.0.34  Fix typo in patch, that was preventing the key assigned to the chat keybind from working while in a searchable tab in the creative GUI. (#5276)
 - 24.0.33  Fix classloading issues in userdev (and possibly also for things like tests within forgedev) (#5275)
 - 24.0.32  World and TileEntity patch work.
            TerrtainGen events are removed, 1.13's world gen re-write invalidates them all.
 - 24.0.31  Create a userdev-specific main, and include it as an injected file in the userdev jar. (#5231)
 - 24.0.30  More entity patch work. ISpecialArmor deleted.
 - 24.0.29  Port some patches to 1.13 (#5267)
 - 24.0.28  Fix vanilla exception mismatch: DataFixerUpper throws IllegalArgumentException but Minecraft tries to catch IllegalStateException instead, causing a hard crash instead of a soft one. (#5229)
 - 24.0.27  Use getRawSchemeSpecificPart to preserve escape characters in uri, fix #5236 (#5237)
 - 24.0.26  world.gen.feature patches, worldgen should be stable with vanilla. In all places I looked.
 - 24.0.25  More patch work, our async chunk loading doesn't appear to be viable for 1.13.
 - 24.0.24  Entity patches progress.
 - 24.0.23  Fix race condition causing the FML handshake to hang (#5222)
 - 24.0.22  Include project group in ForgeVersion and determine path to patched jar.
            While testing we install to net.minecraftforge.test. So don't hardcode it.
 - 24.0.21  Item and NBT patches, IShearable blocks are responsible for setting themselves to air, to allow for setting other states.
 - 24.0.20  Most client patches done except the render pipeline.
            Someone who has more in depth knowledge of that rendering system will need to do it.
 - 24.0.19  Add my 'patches_old' directory, so that people can see my "progress".
            Once the old folder is done, then patches are done.
            Want to know whats still to do? Look in that folder.
            Now stop asking.
 - 24.0.18  GUI Patches
 - 24.0.17  More patchwork.
 - 24.0.16  Fix imports, remember to re-run gen patches!
 - 24.0.15  Patch work, most of block classes, and fix eclipse run configs.
 - 24.0.14  Add a a test publish stage to jenkins file for PRs. Should allow for full publish cycle test without actually publishing.
 - 24.0.13  Fix crash when placing furnaces or brewing stands in 1.13 (#5225)
 - 24.0.12  Fix changelog classifier, and prevent jenkins from running concurrent builds.
            And remove caching from setup, as it doesn't use the rangemap.
 - 24.0.11  Make Forge group/name dynamic in MDK as well.
 - 24.0.10  Include changelog in published artifacts.
 - 24.0.9   Fix jenkinsfile version detection and attempt caching rangemap again.
 - 24.0.8   Fix version number not having MC prefix, and build artifacts.
 - 24.0.7   Workaround for gradle issue with jar signing.
 - 24.0.6   Setup instead of build.
 - 24.0.5   Change checkout process.
 - 24.0.4   Disable tests until we re-make them.
 - 24.0.3   Move cache again, documentation is vague.
 - 24.0.2   Potentially fix cache in Jenkinsfile.
 - 24.0.1   Fix missing quote.
 - 24.0.0   Create jenkins file for new jenkins.
            Change version scheme to tag based versions.

v8.99
=====
 - v8.99.2104 Add missing license headers. (#5192)
 - v8.99.2103 MDK progress.
 - v8.99.2102 Widen scope of gitignored eclipse files
 - v8.99.2101 AdvancementRewards 1.13 patch
 - v8.99.2100 Fix mod asset loading
 - v8.99.2099 Fix diffuse lighting being broken on vanilla pipeline (#5185)
 - v8.99.2098 run textcomponenttranslations through the ForgeI18N message format translator as well.
 - v8.99.2097 load languages on the server as well as the client, and fix up a bunch of data packs.
 - v8.99.2096 Server run profile, also setup logging for client profile.
 - v8.99.2095 Tweak library locating code. Works well on vanilla and dev now.
 - v8.99.2094 Fix the forge version presented to the game (remove MC prefix)
 - v8.99.2093 Move the version packages somewhere that is now filtered so it doesn't
              load twice.
 - v8.99.2092 Fall colours
              🎃🎃🎃🎃🎃🎃🎃🎃🎃🎃
 - v8.99.2091 Missing language now presents to the UI.
 - v8.99.2090 Better error passing from early to game client launch.
 - v8.99.2089 Use the maven artifact code rather than our very outdated copy
 - v8.99.2088 Add SHAs for post processors to allow the installer to skip if matching.
              SpecialSource needs a update to stabilize output before it can be cached.
 - v8.99.2087 Launch in the vanilla launcher now.
 - v8.99.2086 More installer related tweaks.
 - v8.99.2085 Specify version information using Java 8's Package Version system.
 - v8.99.2084 Fix builds without crowdin key, and installer work.
              Started moving version out of code.
              Include expected vanilla class hashes in universal so we can validate them at runtime.
 - v8.99.2083 fix up the examplemod for new FML and add a couple of extra bits.
 - v8.99.2082 Use latest paulscode (removes need for soundfix transformer) and fix gitignore.
 - v8.99.2081 Branding fixup.
 - v8.99.2080 Config GUI tweaks, and MCP is now part of the "minecraft" entry.
 - v8.99.2079 Installer work, universal obfed to srg names, and binpatches against SRG named clients.
 - v8.99.2078 Fixup the config GUI and get things working again.
 - v8.99.2077 Work on installer json generation.
 - v8.99.2076 Basic error display GUI.
 - v8.99.2075 Work on publishing tasks.
              Userdev/universal/mdk done.
              mdk needs updating once FG3 user side is finished.
              Installer waiting on Interaller project re-write to do install time deobf/patching.
 - v8.99.2074 Some tweaks to get the launcher working.
 - v8.99.2073 Update mappings to 09/21 snapshots.
              Conflict with getMatrix in ITransformation, so renamed to getMatrixVec.
 - v8.99.2072 Disable eclipse compiler and switch to SRG patches.
 - v8.99.2071 Fix remaining issues preventing compilation, launching, and loading worlds (#5156)
              Fix duplicate ID for ingredient serializers
              Fix KeyBinding compile errors. No GuiKeyBindingList patches yet.
              Implement controls GUI and WorldServer patches
 - v8.99.2070 Fixed all compile errors except the 4 in KeyBinding.
 - v8.99.2069 More because git likes to split to many
 - v8.99.2068 Ran License checker to fix the headers of files missing them.
 - v8.99.2067 More work on compile errors, New system for ToolClasses, using a ToolType class instead to de-stringify things.
 - v8.99.2066 Block patches and event work (#5138)
 - v8.99.2065 Add concept of pushing/poping levels to ForgeConfigSpec as well as comments on those levels.
 - v8.99.2064 Fix borked Item patch
 - v8.99.2063 Fix the rest of the "easy" compile errors (#5151)
              * Add Entity.changeDimension patch and transitively required patches
              * Fix throws declaration on CommandSetDimension#execute
              * Fix rest of errors in fluid package
              * Add PLAYER_REACH attribute
              * Fix compile errors in fml.client.config and add GuiButton patch
              * Delete unnecessary client.config classes, fix all config errors
              * Comment some fluid errors in models
              * Fix all errors in common package root, except ForgeHooks
              * Mass comment network package
              * Experimental conversion of extended states to generic base class
              * Fix errors in common.util
              * Remove config annotation stuff cuz lex said so
              * Make extended state stuff compile fully
 - v8.99.2062 Beginning work on redesigning Config API.
 - v8.99.2061 More work on recipes, custom ingredients, recipes, and constants should work now.
 - v8.99.2060 Tweak to remove javac compile errors related to generics on registries.
              Also remove the recipes registry call - they're gone from registries completely.
 - v8.99.2059 Net handling pass 2. Tidied up login packet sourcing, generate registry packets.
 - v8.99.2058 Net Handshake phase 1. Validates pairings on client and server.
 - v8.99.2057 Migrate most of the OreDictionary to tags.
 - v8.99.2056 Enforce bounds on min/max registry IDs
 - v8.99.2055 Recipe work. No longer a registry. OreDictionary related code removed in favor of Tags. Started moving some OreDict items to tags.
              Added code to RuntimeEnumExtender to return existing enum values with the same name if they exist instead of creating more.
 - v8.99.2054 Fix errors in commands and getDimension->getId
 - v8.99.2053 Revert unintentional change to FG version
 - v8.99.2052 Command work, and Added TileEntityType as a Forge Registry.
 - v8.99.2051 More compile cleanups. (#5139)
 - v8.99.2050 Update MCPConfig to use new ForgeFlower to fix AccessTransformer issues on inner classes.
 - v8.99.2049 Fix most of the compile errors in the client package (#5137)
              * Add KeyBinding#getKey and clean up errors in KeyModifier
              * Add dimension IRenderHandler patches
              * Fix most of the compile errors in client package.
              The rest are missing Block/KeyBinding patches
              * Disable selective reloads until configs are finished
              * Add OnlyIn on IForgeDimension to match those of Dimension
 - v8.99.2048 Pin MCPConfig version
              Cleanup and implement BrewingRecipes
              Delete client command related things
              Cleanup some biome stuff.
 - v8.99.2047 Fix vanilla bug with GLFW init error display - actually the error, not the memory address containing the message
              Load natives from the environment var, not hardcoding.
 - v8.99.2046 Fix launching in dev
 - v8.99.2045 Fix AnvilChunkLoader not having access to chunk cap dispatcher
 - v8.99.2044 Add I18n accessor, fix up some mod log messages, make the EnumExtender work.
 - v8.99.2043 Port capability patches to 1.13 and refactor to new system (#5134)
              * resource package and misc leftover rendering stuff
              * Port Item and ItemStack patches
              * Extract most item patches to interface
              * Refactor Item#setNoRepair to be part of Item.Builder
              * Adapt AnimationItemOverrideList to new cap system
              * Improve null contract of OptionalCapabilityInstance
              * Remove Capability.cast
              * Update CapabilityAnimation to new cap system
              * Remove OptionalCapabilityInstance#flatMap and add NonNullConsumer
              * Add capability patch to Entity, not everything yet
              * Fix Entity patch and add missing methods to IForgeEntity
              * Fix null contract of CapabilityDispatcher
              * Add TileEntity caps
              * Adapt FluidUtil to new cap system
              * Add world caps
              * Add chunk caps
              * Clean up cap patches
              * Replace all tabs with spaces
              * Move builder methods on Item to Item.Builder
              Whitepsace fix
              * Sided stuff take 2
              * Prevent OptionalCapabilityInstance creating additional empty instances
              * Cache getCapability result in AnimationTESR
              * Fix imports in TileEntity patch
              * Pull out cap code to base class, add village caps
 - v8.99.2042 Initial blind port of the mod error screens
 - v8.99.2041 Porting Forge rendering code to 1.13 (#5132)
 - v8.99.2040 Introduce rework of Capability provider. And reduce errors to <2000
 - v8.99.2039 Remove old paulscode libraries.
              Re-work EnumHelper and ObjectHolder systems to bypass JITer of final fields.
              Other cleanups.
 - v8.99.2038 More error cleanup, reinstanted IForgeReigstryEntry.
              The abstract class will be used as the default, and to enable delegates but we should keep it api simple by keeping the interface.
              Removed some patches that didnt get removed in the rebase.
 - v8.99.2037 Add some missing libraries and work on GuiIngameForge. Down 700 errors.
 - v8.99.2036 Tweak
 - v8.99.2035 Network init
 - v8.99.2034 Server starts
 - v8.99.2033 Patches deleted
 - v8.99.2032 Zeroth pass on 1.13
 - v8.99.2031 Moving some stuff around, network and server events.
 - v8.99.2030 Dediserver runs and talks to clients.
 - v8.99.2029 A much more straightforward networking system.
 - v8.99.2028 Some beginnings of a network again.
 - v8.99.2027 Well, it works, for a game, now.
 - v8.99.2026 Some more stuffs. ObjectHolder's replacement?
 - v8.99.2025 Things. they work. Obviously still WAY more to do.
 - v8.99.2024 more things. Moving ModContainer around.
 - v8.99.2023 metadata is dead
 - v8.99.2022 Fidgeting while the world burns 🔥🔥🔥🔥🔥🔥
 - v8.99.2021 WOW 😲 such broken. Many brokes.
 - v8.99.2020 Holy Moly, it's a big fat commit of broken code!
 - v8.99.2019 Starting to put the launch itself together
 - v8.99.2018 Access Transformer. Starting to try and launch things.
 - v8.99.2017 Early signs of modloading
 - v8.99.2016 Coremod
 - v8.99.2015 Update NewFML.md
 - v8.99.2014 Add documentation explaining changes.
 - v8.99.2013 Goodbye @Mod, it was lovely knowing you!
 - v8.99.2012 Goodbye @Mod, it was lovely knowing you!
 - v8.99.2011 Delete MarkerTransformer. I don't think this has been used in years.
 - v8.99.2010 Fix --mods and --modListFile arguments not making it past LaunchWrapper.
 - v8.99.2009 Remove BlamingTransformer (#5115)
 - v8.99.2008 Fix more apache exclusions.
 - v8.99.2007 Change org.apache to org.apache.maven. class loader exclusion.
 - v8.99.2006 Increase time it takes for Github Pull Requests to go stale
 - v8.99.2005 Add variant alias for item models not loaded via blockstate (#5025)
 - v8.99.2004 Added getter for children of CompoundIngredient (#5082)
 - v8.99.2003 Allow network leak detection level to be specified (#5067)
 - v8.99.2002 Fix saved toolbars not working with non-vanilla items (#5063)
 - v8.99.2001 Fix server watchdog thread occasionally crashing on first run (#5019)
 - v8.99.2000 New SleepingTimeCheckEvent to add yet another way to control sleeping. (#5013)
 - v8.99.1999 Allow sending packets to client from ServerConnectionFromClientEvent (#4991)
 - v8.99.1998 Fixed overworld spawn point reset when respawning in another dimension (#4982)
 - v8.99.1997 Fix ModList cache never being updated (#5081)
 - v8.99.1996 Fix loading languages with no underscore in the name (#5105)
 - v8.99.1995 Fixed Redstone and RedstoneDiodes placement on modded blocks that use BlockFaceShape.SOLID for Top.  (#5100)
 - v8.99.1994 Fix blank Server GUI console log (#5089)
 - v8.99.1993 Fix SlotItemHandler.isItemValid check
 - v8.99.1992 Improve performance of FluidRegistry.getBucketFluids
 - v8.99.1991 Fix received data for last vertex format element not being recorded (#5074)
 - v8.99.1990 Fix missing lang entry for Swim Speed attribute (#5064)
 - v8.99.1989 Added Swim Speed Attribute to EntityLivingBase (#4990)
 - v8.99.1988 Add function to lookup model location for an ItemStack (#5017)
 - v8.99.1987 Allow custom SpawnPlacementType registration (#4973)
 - v8.99.1986 Resource type sensitive ResourceManager reloading, Disabled by default, but may increase performance. (#4658)
 - v8.99.1985 Improve crash report details (#5011)
 - v8.99.1984 Fire colour events for mesa and swamp biomes (#5029)
 - v8.99.1983 Add functionality in IItemHandler to test if a slot can accept an item (#5033)
 - v8.99.1982 Added CreativeTabs#getBackgroundImage (#5034)
 - v8.99.1981 Add wooden doors to the OreDictionary. (#5036)
 - v8.99.1980 Update and clean up Forge fluid render model (#4763)
 - v8.99.1979 Allow configuring log levels using system properties. (#5024)
              Defaults are:
              -Dforge.logging.mojang.level=info (note that setting this to debug or trace will enable extra debug behavior which may slow things down or detect issues and crash)
              -Dforge.logging.console.level=info
              -Dforge.logging.file.level=info
              -Dforge.logging.debugFile.level=trace
 - v8.99.1978 Update README on github to fix the CLA section
 - v8.99.1977 Add support for FluidStack-dependant colouring to Forge bucket (#4952)
 - v8.99.1976 Use itemstack in LivingEntityUseItemEvent.Finish before it was used (#5015)
 - v8.99.1975 Check use item result before calling onItemUseFirst. (#5016)
 - v8.99.1974 Clean up and improve ICapabilityProvider javadocs (#4978)
 - v8.99.1973 Update license header on ChunkIOThreadPoolExecutor
 - v8.99.1972 Fix potential deadlock when chunkload raises non-IO exception (#4861)
 - v8.99.1971 Fix MDK not having license texts.
 - v8.99.1970 Change some client hooks to use GlStateManager functions (#5010)
 - v8.99.1969 Move some test mods into appropriate packages (#5006)
 - v8.99.1968 Write full class name in undefined packet error messages. (#4970)
 - v8.99.1967 Fix ItemHandlerHelper.giveItemToPlayer creating item entities with incorrect contents (#5007)
 - v8.99.1966 Run licenseFormat to apply license header to all files.
 - v8.99.1965 Restore original license headers in Maven versioning package
 - v8.99.1964 Restore original license headers of delta package
 - v8.99.1963 Setup configuration for licenser Gradle plugin
 - v8.99.1962 Fix player movement status not syncing across dimension change (MC-10657) (#4974)
 - v8.99.1961 Fix some ClassCastExceptions incorrectly being logged in FML handshake. (#4972)
 - v8.99.1960 Fix ISpecialArmor to allow for "Unblockable" damage to be handled if the armor opts in. (#4964)
 - v8.99.1959 Fix FML entity network spawning not using EntityBuilder's facctory. Closes #4845 and #4846
 - v8.99.1958 Fix NPE when sleeping in some custom beds. Closes #4956
 - v8.99.1957 Added Fluid Place Block Event for when fluid changes blocks in world. (#4627)
 - v8.99.1956 Cleanup licenses
 - v8.99.1955 Add Farmland Trample Event  (#4895)
 - v8.99.1954 Switch from trove to fastutil collections (#4933)
 - v8.99.1953 Added Item#readNBTShareTag(ItemStack, NBTTagCompound) (#4932)
 - v8.99.1952 Fix MC-234: Z-fighting when viewing break animation side-on (#4928)
 - v8.99.1951 Clean up some dimension manager code and add a command to list dimensions (#4902)
 - v8.99.1950 Change item model loading priority to fix model conflicts (#4898)
 - v8.99.1949 Improve server console implementation (#4821)
 - v8.99.1948 Add validation to recipe registry (#4957)
 - v8.99.1947 Fix flickering leaves when mods break the blurMipmap settings (#4997)
 - v8.99.1946 Clear out stored errors after model loading finishes (#4938)
 - v8.99.1945 Fix AutomaticEventSubscriber error message (#4986)
 - v8.99.1944 Always wrap mod creation errors in LoaderException
              to make error message more clear
 - v8.99.1943 Fix vertex lighter using stale normal data (#4917)
 - v8.99.1942 Fix structure template processors causing cascading world generation (#4979)
 - v8.99.1941 Fix scala mods crashing with the json annotation cache.
 - v8.99.1940 Fix black flickering on animated models by clamping max diffuse lighting multiplier to 1.0 (#4962)
 - v8.99.1939 Fix crash from search tree processing invalid recipes (#4942)
 - v8.99.1938 Fix names in JSON annotation data not matching expected format. Closes #4953
 - v8.99.1937 Bump version in prep for new RB.
 - v8.99.1936 Add potential support for models defining 'vanilla like' rotations in Forge's Modified Blockstate format.
 - v8.99.1935 Copy the Dedicated server's EULA checking to main() function so it can exit earlier. Closes #3659, #3661
 - v8.99.1934 Fix Forge bucket not declaring all texture dependencies (#4930)
 - v8.99.1933 Reuse multipart model instances across variants (#4791)
 - v8.99.1932 Fix language parsing for creating the java locale
 - v8.99.1931 Fixes parameter inconsistency in IFieldWrapper (Fixes #4325) (#4766)
 - v8.99.1930 Added formatting support for status messages (#4925)
 - v8.99.1929 Fix server-side data not being released (#4882)
 - v8.99.1928 Fix memory leaks in EnchantmentHelper (MC-128547) (#4880)
 - v8.99.1927 Change composite models to fetch quads from submodels using full context (#4809)
 - v8.99.1926 Expand Villager Farmer AI to generic crops. (#4745)
 - v8.99.1925 Check name prefix used for tile entity registrations (#4681)
 - v8.99.1924 Add an event to control nether portal formation (#4735)
 - v8.99.1923 Allow custom models to have per-state lighting (#4732)
 - v8.99.1922 Fix some light-emitting blocks letting light through (MC-119932) (#4642)
 - v8.99.1921 Preserve original ChunkPos for decoration events. (#4767)
 - v8.99.1920 Fix library folder detection on various JVMs.
 - v8.99.1919 Add supports for redirects when doing mod version checks (#4826)
 - v8.99.1918 Fix imports
 - v8.99.1917 Give immediate and complete error messages when there is a crash during startup (#4869)
 - v8.99.1916 Revert "Give immediate and complete error messages when there is a crash during startup (#4869)"
              This reverts commit a38f5fd6a24297490671cd300b5e4a9020189f63.
 - v8.99.1915 Remove invalid optimization in ItemStackHandler#setStackInSlot #3465
 - v8.99.1914 Give immediate and complete error messages when there is a crash during startup (#4869)
 - v8.99.1913 Clean up mod dependency checking code (#4922)
 - v8.99.1912 Fix version range check for required mods #4918
 - v8.99.1911 Add javadoc note about minimum required Forge versions for old Forge. Close #4918
 - v8.99.1910 Fix possible NPE when calling Loader.getIndexedModList #4919
 - v8.99.1909 Fix MC-12269 Various Particles glitchy movement (#4914)
 - v8.99.1908 Fix deobfuscator not regenerating super maps (#4856)
 - v8.99.1907 Clean up broken aliases caused by registry bug #4894. (#4909)
 - v8.99.1906 Move registry snapshot read/write code to Snapshot class. Cleaner code.
 - v8.99.1905 Only revert to frozen data on server shutdown on client. Should fix race condition exposed by #4904
 - v8.99.1904 Potentially fix issue with BungeeCord or other servers resetting the registry mappings on the client while the game is running.
              Errors may still occure if the client knows about world data beyond vanilla. Servers should NEVER send world/registry invocations before they have sent registry mappings.
              Closes #4901
 - v8.99.1903 Reduce range requirement for World.checkLightFor from 17 to 16 (#4729)
 - v8.99.1902 Fix typo in validation of vanilla registry wrappers (#4899)
 - v8.99.1901 Fix #4772: add an "isActivator" boolean to powered rails (#4774)
 - v8.99.1900 Add checks for undefined packet discriminators when sending messages (#4890)
 - v8.99.1899 Fix some code holding client world references longer than needed (#4881)
 - v8.99.1898 Don't try to render removed tile entities. Fixes MC-123363 (#4811)
 - v8.99.1897 Fix overrides typo in saving registry data. Closes #4894
 - v8.99.1896 Fix library path and soft fail when repository root is not found.
 - v8.99.1895 Fix libraries not being added to the modlist when using external metadata. Closes #4879
 - v8.99.1894 Fix dragon fight not initialising correctly under some circumstances (#4868)
 - v8.99.1893 Cleanup some issues with the mod extraction to the memory modlist. Closes #4874 #4875
 - v8.99.1892 Improve missing mod dependency error screen (#4762)
 - v8.99.1891 Fix biome dictionary's biome type detection (#4878)
 - v8.99.1890 Clean up Reader/Writer handling to use a specified charset (#4872)
 - v8.99.1889 Suppress firing events at load time if an error has already occurred (#4801)
 - v8.99.1888 Fix FluidUtil.getFluidHandler skipping some fluid tile entities (#4854)
 - v8.99.1887 Parse contained dependency Timestamp as long instead of int (#4866)
 - v8.99.1886 Fix Forge's metadata not being loaded. Closes #4865
 - v8.99.1885 Fix mods without ModSide meta value.
 - v8.99.1884 Rewrite dependency extraction to use mod list system (#4841)
 - v8.99.1883 Bump Forge version for new dev chunk.
 - v8.99.1882 Fix vanilla duplication bug.
 - v8.99.1881 Slow down Forge chunk gen worker when save queue is to high.
              Prevents task from completing while tons of chunks are pending save.
              And add minimum notification every 60 seconds.
 - v8.99.1880 Add support for World Workers skipping ticks without being removed from the worker list.
 - v8.99.1879 Fix MC-88179 in a better way that avoids and closes #4824 (#4830)
 - v8.99.1878 Improve the warning logged for cascading world generation (#4725)
 - v8.99.1877 New ITeleporter interface making dimensional teleportation easier. (#4602)
 - v8.99.1876 Add a FML outbound target for all players tracking a point or entity in the world. Closes #3677 (#4631)
 - v8.99.1875 Prevent EntityPlayer.attackEntityFrom from firing LivingAttackEvent twice (#4661)
 - v8.99.1874 Add a way to get a list of registered biome types (#4685)
 - v8.99.1873 Improve performance of some ExtendedBlockState methods (#4698)
 - v8.99.1872 Optimise adding normal element to vertex formats (#4699)
 - v8.99.1871 Check for empty dimensions outside of chunk unloading loop, culling worlds without needing chunk unloads to trigger it. (#4704)
 - v8.99.1870 Create event for overriding mob griefing flag based on entity. (#4710)
 - v8.99.1869 Add description to Error raised by the server hang watchdog. (#4714)
 - v8.99.1868 Update ItemHandlerHelper.giveItemToPlayer to allow player who picked up the item to hear the sound as well (#4720)
 - v8.99.1867 Fixed Spectator mode particles and sounds computed from where you have been before (MC-46445) (#4728)
 - v8.99.1866 Add a WorldProvider#canSleepHere() method to allow providers to control sleeping in beds separately from re-spawning. (#4741)
 - v8.99.1865 Fix FMLCommonHandler#exitJava printing useless/wrong calling info (#4742)
 - v8.99.1864 Reduce memory usage of model transforms (#4753)
 - v8.99.1863 Fix some block connection logic not matching vanilla (#4781)
 - v8.99.1862 Fix for the player inadvertently being removed from the Entity Tracker when the chunk they were in unloads after they teleport out of it. (#4784)
 - v8.99.1861 Small performance improvement to ItemStack, by using Items.AIR directly instead of getting it from the Block map. (#4786)
 - v8.99.1860 Added chunk instance to ChunkWatchEvent (#4805)
 - v8.99.1859 Add fences and fence gates to ore dictionary (#4807)
 - v8.99.1858 Fix entities sometimes not rendering when out-of-world (#4823)
 - v8.99.1857 Fix issues with the test mods
 - v8.99.1856 Reorganise test mods into packages (#4706)
 - v8.99.1855 Fix servers crashing due to initializer on @SideOnly field (#4825)
 - v8.99.1854 Cleaner TileEntityItemStackRenderers, now stored on the Item. Modders should be careful and cache their renderers. (#4700)
 - v8.99.1853 Add support for creator mod ID for modded enchanted books, potions, arrows, and spawn eggs (#4810)
 - v8.99.1852 Remove Mercurius from optional mods.
 - v8.99.1851 Fixed sound engine crash when stopping streaming sounds (#4765)
 - v8.99.1850 Merge vanilla pre-decompile annotations with Forge's post-patching. Fixes #4769 Crash detail classes causing class not found errors.
 - v8.99.1849 Fix NBT data loss when shift-clicking stacked items in the enchantment table (MC-17431) (#4817)
 - v8.99.1848 Update docs for ItemTooltipEvent
 - v8.99.1847 Fix some IResources being leaked (#4806)
 - v8.99.1846 Fix server console logging issues
              Closes #4808
 - v8.99.1845 Fix up logging and log4j configuration (#4802)
 - v8.99.1844 Make lookupFluidForBlock work for flowing water and lava (#4675)
 - v8.99.1843 Patched BlockInfo#updateLightMatrix to use IBlockState#doesSideBlockRendering instead of Block#doesSideBlockRendering (#4798)
 - v8.99.1842 Fix integrated server crash not stopping client (#4796)
 - v8.99.1841 Fix #4792 TextComponentHelper handling for FakePlayers
 - v8.99.1840 Fix serverside startup failure when checking for vanilla acceptance (#4783)
 - v8.99.1839 Improve how smooth lighting code handles translucency (#4711)
 - v8.99.1838 Prevent various vanilla blocks from loading unloaded chunks (#4689)
 - v8.99.1837 Improve the "Mod rejections" error message when connecting to a server (#4761)
 - v8.99.1836 Fix the ForgeChunkManager to use the writebehind FileIO thread for writing (#4777)
              the chunk file. Closes #4775
              This is a performance tweak - doing File IO on the server thread during
              world saves causes significant lag spikes. This is one of many.
 - v8.99.1835 Fix vanilla crash classes not being preloaded. Closes #4769
              Fix classes not being aggregated for mods using the new annotation cache.
 - v8.99.1834 Fix incorrect dimension ID being used for maps (#4690)
 - v8.99.1833 Don't cull generated item models with non-default transforms (#4749)
 - v8.99.1832 Maintain deterministic order in deserialised Forge blockstates (#4748)
 - v8.99.1831 Add function to BufferBuilder to directly insert byte data. Closes #4722
 - v8.99.1830 Clean up some GUI code and change magic numbers to GL constants (#4734)
 - v8.99.1829 Minor cleanup for TestAnnotationParser
 - v8.99.1828 Initial implementation of JSON based annotation scanning.
              Disabled by default for now, until proven to be fully function.
              Enable using -Dfml.enableJsonAnnotations=true
 - v8.99.1827 Remove Mercurius from release JSON, Sadly it's dead we may address it at a later date.
 - v8.99.1826 Update Github Stale bot message to better explain how to un-stale issues
 - v8.99.1825 Bump version for RB.
 - v8.99.1824 Change chunk gen command to only keep the target dimension loaded (#4705)
 - v8.99.1823 Fix inconsistency between vanilla and modded glass. Closes #4679 (#4680)
 - v8.99.1822 New hook in WorldProvider to control client lighting re-checks (#4645)
 - v8.99.1821 New hook to delegate some liquid related physics to the blocks themselves. (#4604)
 - v8.99.1820 Remove texture loads from SimpleModelFontRenderer (#4721)
 - v8.99.1819 Fix some shapeless recipes using damageable items not working (#4713)
 - v8.99.1818 Use relative time offset, rather than absolute value, for animations (#4635)
 - v8.99.1817 Fixed UV contraction for the texture in the top-left corner of the texture map (0, 0), see sp614x/optifine#1024 (#4703)
 - v8.99.1816 Fix some test mods preventing Forge server-Vanilla client connections (#4616)
 - v8.99.1815 Fix errors in preInit being lost when followed by a crash in fireRegistryEvents or objectHolder
 - v8.99.1814 Added @Ignore to the annotation based Config system. (#4696)
 - v8.99.1813 Improve error message on server when a vanilla client connects (#4691)
 - v8.99.1812 Fixed pumpkins passing the wrong position to isSideSolid on placement (#4686)
 - v8.99.1811 Fix MusicType enumhelper not working (#4682)
 - v8.99.1810 Make FluidUtil sounds server-side, add simulate option for tryFill/EmptyContainerAndStow (#4623)
 - v8.99.1809 Expose CriteriaTriggers.register, closes #4109 (#4634)
 - v8.99.1808 Catch and log exceptions during model baking (#4609)
 - v8.99.1807 Fix forge fluids being treated as solid blocks (#4606)
 - v8.99.1806 Add MobSpawnerBaseLogic reference to SpecialSpawn and CheckSpawn events (#4600)
 - v8.99.1805 Fix default GUIConfig displaying child categories twice (#4599)
 - v8.99.1804 Added a tooltip color event. (#4595)
 - v8.99.1803 Moved firing the MinecartInteractEvent from individual subclasses up to EntityMinecart, which as a result automatically supports EntityMinecartMobSpawner and EntityMinecartTNT. (#4583)
 - v8.99.1802 Add missing check for allowed values to recolorBlock() (#4579)
 - v8.99.1801 Avoid copying Forge Registry keys, values, and entries (#4545)
 - v8.99.1800 Make async chunk loading a config option (#4544)
 - v8.99.1799 Allow WorldProviders to specify in-game music (#4539)
 - v8.99.1798 Block::addRunningEffects (#4248)
 - v8.99.1797 [1.12.x] Implement hooks allowing mods to add horse armor. Partially addresses #3975. (#3994)
 - v8.99.1796 Fix debug flags for ClassPatchManager not working. Closes #3674
 - v8.99.1795 Fix FML error logging for mods that crash during FMLLoadCompleteEvent
 - v8.99.1794 Minor code and documentation cleanup. (#4664)
 - v8.99.1793 Fix dormant chunk cache allowing entity data to be overwritten (#4528)
 - v8.99.1792 Fix dimension data not being saved (#4667)
 - v8.99.1791 Don't copy state from variant to multi-part model (#4629)
 - v8.99.1790 Fix vanilla giant jungle trees causing cascading generation (#4652)
 - v8.99.1789 Fix Beetroot crops don't break/drop when trampled (#4644)
 - v8.99.1788 Enhance crash message when custom models return null default state (#4615)
 - v8.99.1787 Update Github StaleBot config to run on old Issues as well as PRs
 - v8.99.1786 Downgrade RegistryEntry's dangerous alternative prefix message to info instead of BigWarning.
              This is still most likely a broken mod, but nobody ever actually fixes themselves, and i'm tired of being blamed for 'spamming' the logs.
 - v8.99.1785 Fix missing call to release() in the event channel handler (#4513)
               (reverted from commit cd99957627625f7baeff8761c6382b05db9699d3)
 - v8.99.1784 Added Custom Slime Block hook for Piston. (#4520)
 - v8.99.1783 Add some extra context to Advancements/Minecart/Fishing/TileEntity loot handlers.(#4443)
 - v8.99.1782 Adjust light matrix calculations to use per-face logic (#4339)
 - v8.99.1781 Fix applyUVLock not preserving input order (#4336)
 - v8.99.1780 Adjust diffuse light calculation to match vanilla facing values (#4305)
 - v8.99.1779 Fix invalid rendering of single-frame B3D models (Fix #3815)
 - v8.99.1778 Fix animation of rotated block parts (#4156)
 - v8.99.1777 Fix BakedQuadRetextured not overriding getSprite (#4137)
 - v8.99.1776 Added LivingKnockBackEvent event to allow better control over knock back effects. (#4503)
 - v8.99.1775 Delay egg creation to avoid null statistics (#4508)
 - v8.99.1774 Fix missing call to release() in the event channel handler (#4513)
 - v8.99.1773 Reimplemented TileEntity and Entity Update Profiling in the /forge track command (#4521)
 - v8.99.1772 [macOS] Fix missing text on loading error screens (#4532)
 - v8.99.1771 Don't enforce IPv4 for clients connecting to IPv6-only servers (#4563)
 - v8.99.1770 Add an event for registering block/item colour handlers (#4565)
 - v8.99.1769 Fix: Anvil Bug with Custom Damage Items. (#4570)
 - v8.99.1768 BlockFlowerPot now checks solid top side instead of old method. (#4571)
 - v8.99.1767 Fix startIndex for /forge generate position parsing (#4572)
 - v8.99.1766 Make vanilla powered rails receive power from mods' custom powered rail subclasses (#4573)
 - v8.99.1765 Deprecate passing a class to CapabilityManager::register (#4574)
 - v8.99.1764 Add missing nullability annotations to some Forge-added methods (#4578)
 - v8.99.1763 Change how chests check if they're blocked. (#4584)
              Readd Vanilla Bug: https://bugs.mojang.com/browse/MC-378
 - v8.99.1762 Allow EntityFishHook to spawn water particles in all liquids that use Material.WATER (#4585)
 - v8.99.1761 Add Sound loading progress bar (#4593)
 - v8.99.1760 Clean up capability checking for entities (#4591)
 - v8.99.1759 Fix sometimes being unable to extract items from double chests (#4590)
 - v8.99.1758 Fix item handler documentation that says returning ItemStack.EMPTY is required (#4587)
 - v8.99.1757 Added color as field with setter to Fluid class.  (#4460)
 - v8.99.1756 Prevent tooltips from going off the top of the screen.
 - v8.99.1755 [1.12] Add Advancement Event (#4467)
 - v8.99.1754 Update java docs for IItemHandler. Fix #4553
 - v8.99.1753 Restore binary compatibility in EntityItemPickupEvent
 - v8.99.1752 Re-enable Vanilla's Shapeless recipe matching.
 - v8.99.1751 Fix for the EntityItemPickupEvent having 0 count item when event is fired. (#4549)
 - v8.99.1750 Don't force IPv4 network stack if IPv6 is specifically requested (#4547)
 - v8.99.1749 Fix more bad shapeless recipe matching. Closes #4557
 - v8.99.1748 Version bump for Recommended Build.
 - v8.99.1747 Add TAG_LONG_ARRAY to Constants.NBT (#4552)
 - v8.99.1746 Create custom shapeless recipe matching system. Should solve #4516 damageable items in shapeless recipes.
 - v8.99.1745 Clean up old code for detecting BaseMods. Close #4530 (#4540)
 - v8.99.1744 Fix BufferBuilder not expanding under some conditions. (#4538)
 - v8.99.1743 Add support.yml for support bot on github.
 - v8.99.1742 Fix errors caused by multi-target messages sent from LAN host (#4536)
 - v8.99.1741 Fix server icon response leaking buffer (MC-122085) (#4534)
 - v8.99.1740 Fix CompoundIngredents not working properly in shapeless recipes.
 - v8.99.1739 [1.12.x] Added BucketUse event to ForgeUniversal Bucket (#4454)
 - v8.99.1738 Non-player entities now respect WorldProvider.getMovementFactor, closes #4470 (#4471)
 - v8.99.1737 Fix entity spawn messages not handling buffer correctly (#4524)
 - v8.99.1736 Make Ingredient explode wildcard values like OreIngredient.
              Fixes some issues related to Grums order fix for Shapeless recipes.
              Other more advanced usages need to be documented and tested.
 - v8.99.1735 Fix server incorrectly marked as stopped before forge's handleServerStopped() (#4517)
 - v8.99.1734 Fix network buffer leak with multi-part messages (#4511)
 - v8.99.1733 Fix buffer leak in vanilla custom payload packet handling (#4512)
 - v8.99.1732 Fix network buffers not being released in some places (#4510)
 - v8.99.1731 Fix resource loading on some mac systems when SplashProgress is enabled (#4082)
 - v8.99.1730 Fix MC-51150 (#4495)
 - v8.99.1729 Fix incorrect lighting of item models (#4493)
 - v8.99.1728 Change item model alpha tests to match values used for rendering (#4490)
 - v8.99.1727 Fix NPE when player tries to sleep without bed (#4487)
 - v8.99.1726 Added tint index of 0 to fluid models (#3938)
 - v8.99.1725 Fix FastTESR quad sort (#4298)
 - v8.99.1724 Fix the incorrect matching algorithm in ShapelessRecipes and ShapelessOreRecipe (#4472)
 - v8.99.1723 Fix BlockDynamicLiquid using mismatched state/position pair (#4501)
 - v8.99.1722 Fix more test mod warnings (#4477)
 - v8.99.1721 Add LivingDamageEvent (#4349)
 - v8.99.1720 Create IRecipeContainer interface and implementation to allow RecipeBook to work on custom GUIs (#4480)
 - v8.99.1719 Add InputUpdateEvent (#4356)
 - v8.99.1718 Added a cloud renderer that uploads geometry to the GPU. (#4143)
 - v8.99.1717 [1.12] Replace ThrowableImpactEvent with a more generic version (#4040)
 - v8.99.1716 Clean up BlockSnapshot code (#3737)
 - v8.99.1715 Fixed property losing state after rename. (#4123)
 - v8.99.1714 Fix GameData#revert ignoring RegistryManager parameter (#4232)
 - v8.99.1713 Allow custom selector types to be defined (#4259)
 - v8.99.1712 Clean up more deprecated library functions (#4283)
 - v8.99.1711 Improve performance of World.collidesWithAnyBlock (#4286)
 - v8.99.1710 Move reach distance to an attribute (#4331)
 - v8.99.1709 Resolve a crash relating to plantFlower when biome has no flowers (#4381)
 - v8.99.1708 Improve the Forge Bucket (#4435)
 - v8.99.1707 Prevent fake players from making advancements (#4438)
 - v8.99.1706 Further reduce quad count of generated item models  (#4448)
 - v8.99.1705 Fix killing blow causing combat tracker to lose data (MC-121048) (#4452)
 - v8.99.1704 Recalculate chunk height map minimum on load (#4453)
 - v8.99.1703 Changed BlockFluidBase "fog" color use color from Fluid getColor() method (#4462)
 - v8.99.1702 Improve performance of inserting into inventory wrappers (#4468)
 - v8.99.1701 Fix some locations where State Sensitive Materials were not used. Closes #4474
 - v8.99.1700 Add caching of data for flat lighting (#4358)
 - v8.99.1699 Fix spider/chicken jockeys being unable to spawn naturally (MC-103516) (#4429)
 - v8.99.1698 Clean up Forge commands. Add HelpCommand. Fix #4444 (#4451)
 - v8.99.1697 Fix some more test mod warnings (#4469)
 - v8.99.1696 [1.12.x] [Animation API] Add rotation origin variable (#4466)
 - v8.99.1695 Fix some warnings produced by test mods (#4456)
 - v8.99.1694 Fix performance regression in FastTESR rendering
 - v8.99.1693 Fix outdated VersionParser javadoc link
 - v8.99.1692 Add configuration for probot-stale for github
 - v8.99.1691 Update mcp mappings to 20171003
 - v8.99.1690 [1.12] Add support for client & server dependencies for mods (#4403)
 - v8.99.1689 Add Item.getModId to show which mod is associated with a subitem (#4330)
 - v8.99.1688 Add Chunk capabilities (#4228)
 - v8.99.1687 Fix some chunk data packets being created unnecessarily (#4414)
 - v8.99.1686 Improve performance of vertex format mapping by caching hashcodes (#4370)
 - v8.99.1685 Reduce the number of quads generated by ItemLayerModel (#4332)
 - v8.99.1684 [1.12] Check both hands for sneak interaction bypass (#4256)
 - v8.99.1683 Allow item models to use formats other than ITEM (#4273)
 - v8.99.1682 Fix being unable to see with night vision under some conditions (#4383)
 - v8.99.1681 Fix block and torch placement logic not matching vanilla (#4210)
 - v8.99.1680 Add hook to configure EntityEquipmentSlot for item.
 - v8.99.1679 Store entity data for dormant chunks using NBT (#4162)
 - v8.99.1678 Allow for MapDecoration to use alternate rendering, for example a custom spritesheet (#4027)
 - v8.99.1677 Remove limitation of Shaped crafting recipes not being used on grids larger than 3x3
 - v8.99.1676 Fix not being able to write in a blank, renamed Book and Quill (#4433)
              https://bugs.mojang.com/browse/MC-1685
 - v8.99.1675 Add new /forge entity list command for displaying a list of all entities in world.
              As well as tracking down chunks with large amounts of entities.
 - v8.99.1674 Fix test mod shield JSON incorrect bottom face UV's (#4295)
 - v8.99.1673 Prevent a mutable BlockPos leak in World#setBlockState (#4388)
 - v8.99.1672 Fix IngredientNBT comparing stackSize when checking if ingredient is valid (#4418)
 - v8.99.1671 Auto-detect registry namespace when using a legacy string id in EntityEntryBuilder fixes #4410 (#4411)
 - v8.99.1670 Introduce entity entry builder, useful in the Register<EntityEntry> event replacing needed calls to EntityRegistry. (#4408)
 - v8.99.1669 MC 1.12.2 update.
 - v8.99.1668 Fix lightmap calculation vertex clamping (#4387)
 - v8.99.1667 Fix chunk gen mobs not firing the CheckSpawn event. Closes #4394 (#4396)
 - v8.99.1666 Add an extra error check for OBJ model materials (#4402)
 - v8.99.1665 Fix up test mods (#4399)
 - v8.99.1664 Add new /forge gen command to generate large amounts of chunks.
              Usage: /forge gen <position> <count> [dimension] [notifications]
              Position is in Block Coords, and can be relative to the player. These will be converted to chunk coords for you.
              Count is the number of chunks to load. This is not a radius, actual total number of chunks.
              Dimension is optional, you can use this to pregen other worlds.
              Notifications is the chunk interval to inform you of the generating progress. This is optional and will be 5% or 100 whichever is higher.
              Added new config option to modify vanilla world gen to fix various cascading issues. MC-117810 MC-114332 and more.
              This WILL change block placement from vanilla world gen. So this is a opt-in value. Do not report differences in worlds with this flag enabled.
 - v8.99.1663 Fixed ShapedOre recipes not laying out correctly with the guidebook.
 - v8.99.1662 Fixed search tabs using wrong contents. (#4393)
 - v8.99.1661 Bump version for RB.
 - v8.99.1660 Fix #4386 Race condition when unloading chunks causes dead tile entities
 - v8.99.1659 Patch block model renderer to use location-aware light value (#4303)
 - v8.99.1658 Improve generation of normals for vanilla models (#4313)
 - v8.99.1657 Fire RenderGameOverlayEvent for vignette (#4360)
 - v8.99.1656 Fix light sources rendering wrongly with night vision (MC-58177) (#4365)
 - v8.99.1655 Fix CustomModLoadingErrorDisplayScreen not being handled during init or preinit. (#4320)
 - v8.99.1654 Insert FML handler before Vanilla connection handshake completes (#4380)
 - v8.99.1653 Add missing bounds checks to ItemTextureQuadConverter (#4343)
 - v8.99.1652 Allow custom GuiEditArrayEntries without having to recreate the object in several places (#4329)
 - v8.99.1651 Add support instructions to be displayed when creating an issue on Github (#4323)
 - v8.99.1650 Adjust float (un)packing functions to be slightly more accurate (#4316)
 - v8.99.1649 Fix vanilla map pixel data being used in various places (#4068)
 - v8.99.1648 [1.12] Remove patches adding chunkExists() function, switch to vanilla code (#4054)
 - v8.99.1647 Added missing MapGen types to the InitMapGenEvent (#4322)
 - v8.99.1646 Fix nether wart, pumpkins, and melons passing the new state as the original state to CropGrowEvent.Post (#4377)
 - v8.99.1645 Fix FieldWrapper.MapWrapper initialising wrong category (#4335)
 - v8.99.1644 Don't parse category names as regular expressions in FieldWrapper.MapWrapper (#4334)
 - v8.99.1643 Fix issue saving observers using different metadata then vanilla.
 - v8.99.1642 Fix netty warning spam when sending >1MB packets (#4363)
 - v8.99.1641 Fix FML handshake crash, fixes #4285 and #3974 (#4304)
 - v8.99.1640 Fix recipe book auto-fill not working for OreDictionary ingredients.
 - v8.99.1639 Fix KeyBindings reset buttons being inverted.
 - v8.99.1638 Fix for dummied server side registry entries while client has read entries.
 - v8.99.1637 Tabulate crash report mod list and add signature information (#4251)
 - v8.99.1636 [1.12] Fix wood plank ore dictionary recipes (#4310)
 - v8.99.1635 Fix UnknownFormatConversionException during erroring TE/Entity removal (#4312)
 - v8.99.1634 Add support for server side only recipes, as well as detection of vanilla client recipe book filter to prevent errors.
 - v8.99.1633 Fix typo in CapabiltyFluidHandler (#4306)
 - v8.99.1632 Fix splitting big packets skipping one byte per additional part (#4301)
 - v8.99.1631 Fix tests
 - v8.99.1630 Add PlayerSPPushOutOfBlocksEvent. (#4091)
 - v8.99.1629 Add Ability to Override PotionEffect Default Sort Order (#4172)
 - v8.99.1628 Add support for oredict item predicates in advancements, and add a registry for item predicates (#4188)
 - v8.99.1627 Add support for running IModel.retexture() on models from blockstates (#4200)
 - v8.99.1626 Fix invalid FastTESR quad ordering (#4267)
 - v8.99.1625 Continue loading mod recipes and advancements after encountering an error (#4277)
 - v8.99.1624 Add a hook to allow world providers to change the lightmap colours (#4279)
 - v8.99.1623 Fix MC-117075 lag spike when unloading many tile entities (#4281)
 - v8.99.1622 Better descriptions on dependency version range error screen (#4284)
 - v8.99.1621 Filter out scala libraries in forge dev workspace.
 - v8.99.1620 Fix IOUtils import error caused by server/client libraries desync.
 - v8.99.1619 Fix odd NPE with list files for empty directories.
 - v8.99.1618 Fixed missing line in logger.
 - v8.99.1617 Cleanup some output and move the Jar-In-Jar extractor to before any coremods/mods are loaded so.
              The intention is to rework this entire thing to use maven style storage, IF we can get Mojang to pass in the Libraries folder.
 - v8.99.1616 Lex doesn't like this.
              Revert "Fix up MC version compatibility checking to be a little less verbose."
              This reverts commit 1927fd76e20a1b3075cb841b09c2caeb57ebd242.
 - v8.99.1615 Fix up MC version compatibility checking to be a little less verbose.
              If people use properly formatted version compatibility strings, or the
              default compiled in one, this will work exactly as before, but has
              less dependence on specific formats for the mcversion string. So a mod
              declaring [1.11, 1.12] will now be 1.12.1 compatible by default, for
              example.
 - v8.99.1614 1.12.1 Update, Not much modder facing changes, 1.12 mods should load and run fine on this version.
 - v8.99.1613 Add smarter getter for block slipperiness (#4116)
              Fixed MC-119811, Boats rubber banding when dismounted.
 - v8.99.1612 Add GuiContainer Foreground render event. (#4127)
 - v8.99.1611 Use ClassValue to store tileentity names for profiler in lazy cache.  (#4021)
 - v8.99.1610 Move client-only config options to client config (#4084)
 - v8.99.1609 Added CriticalHitEvent to allow more control over whether a attack is a critical or not, and what damage it does.
 - v8.99.1608 Fix stacked entity item rendering using the wrong transform for the extra items. (#4158)
 - v8.99.1607 Fix lopsided 'V' in FML icons. (#4179)
 - v8.99.1606 Added pages to the advancements GUI to allow for unlimited root advancements. (#4183)
 - v8.99.1605 Ignore neighbor changes for comparators on the client (Vanilla behavior) (#4186)
 - v8.99.1604 Fixed bug where config categories errored if they contained regex special characters. (#4187)
 - v8.99.1603 Allow sneaking to bypass villager interaction GUI. (#4193)
 - v8.99.1602 Clean up Block.getLightValue(IBlockState, IBlockAccess, BlockPos) (#4203)
 - v8.99.1601 Make LivingEntityUseItemEvent not abstract (#4208)
 - v8.99.1600 Replace hardcoded block check with isTopSolid method call for placing button/lever (#4212)
 - v8.99.1599 Added support for oredict dyes to Fireworks, Armors, and Shulker recipes.  (#4223)
 - v8.99.1598 Limit some server to client update packets for Item Capabilities (#4252)
 - v8.99.1597 Fixed Armor bar disappear after changing dimension. MC-88179 (#4265)
 - v8.99.1596 Fix the firing location of InputEvent.MouseInputEvent (#4270)
 - v8.99.1595 Fix some broken test mods (#4245)
 - v8.99.1594 Fixed swapping of finite fluids with negative densities. (#4237)
 - v8.99.1593 Fix overrides not being read from the server registry snapshot (#4224)
 - v8.99.1592 Fix some test mods crashing server caused by model loading (#4225)
 - v8.99.1591 Fix FML handshake race condition, fixes #4219 (#4220)
 - v8.99.1590 Prevent player from dying infinitely due to zero max health (MC-119183)
 - v8.99.1589 [1.12] Allow the server to handle item-block interaction if onItemUse doesn not return PASS (#3967)
 - v8.99.1588 Allow support for custom Shields and Shield disabling weapons.
 - v8.99.1587 Make Optional.Interface repeatable (#4138)
 - v8.99.1586 Log a warning if a coremod does not follow best practices (#4146)
 - v8.99.1585 Ignore fortune for anything but seeds in crops (#4160)
 - v8.99.1584 Added support for vanilla "nbt strings" in json recipes (#4113)
 - v8.99.1583 Fix tripwire statemap not being complete when mappings change. Closes #3924
 - v8.99.1582 Fixed invalid erroring case during loading Advancements form mods that don't have advancements.
 - v8.99.1581 Fixed issue where rendered held items wouldn't properly update when the reequip animations isnt shown. Closes #4175
 - v8.99.1580 Send remap event when data is frozen to notify modders to bake things.
              Fixes search not working when connecting to vanilla servers.
 - v8.99.1579 Fire recipe registry event after json recipes are loaded.
 - v8.99.1578 Clean up uses of deprecated library functions (#4130)
              Avoid catching and rethrowing runtime exceptions
              Append error messages to exceptions instead of the log
 - v8.99.1577 Remove unneeded block patches (#4167)
 - v8.99.1576 Improve javadocs for Mod dependencies (#4168)
 - v8.99.1575 Stop "Binary patch set is missing" error log in dev environment
 - v8.99.1574 Add basic Github issue template
 - v8.99.1573 Fix errors in test mods
 - v8.99.1572 Remove unnecessary maxStackSize restrictions on brewing potions. (#4155)
 - v8.99.1571 Fix game freeze when resizing the window too small on the mods gui (#4148)
 - v8.99.1570 Adjust EnumHelper#addCreatureType to EnumType (#4089)
 - v8.99.1569 Allow advancement icons to have nbt (#4114)
 - v8.99.1568 Attempt fix, or at least better debugging for RecipeBook accessing unknown recipes.
 - v8.99.1567 Fix MC-68754, Screen is not resizeable after exiting fullscreen due to LWJGL bug
 - v8.99.1566 Use Item's custom FontRenderer for tooltips in the Creative Gui (#4101)
 - v8.99.1565 Fix Recipe Toast crash when granted more than 5000 recipes (#4124)
 - v8.99.1564 Throw packet encoding exceptions instead of suppressing them, to prevent corrupt packets (#4144)
 - v8.99.1563 Quiet down warning for missing translation files.
 - v8.99.1562 Update JOpt version on the dedicated server to match client.
 - v8.99.1561 Fix getting missing models for overridden Item registry entires
 - v8.99.1560 Fix override duplication caused by bad comparison.
 - v8.99.1559 Fix log spam when creating dummy blocks.
 - v8.99.1558 Include location of the call when a mod uses System.out or System.err (Fix #4135)
 - v8.99.1557 Fix unblockable damage being blocked by armor. (#3933) (#4106)
 - v8.99.1556 Improve furnace fuel handling (#4083)
 - v8.99.1555 Add isSpawner parameter to the CheckSpawn event (#4075)
 - v8.99.1554 RenderLivingEvent now stores partialTick
              2
 - v8.99.1553 Fix missing messages of missing models (#4120)
 - v8.99.1552 Correct the default resource location of potion registry (#4117)
 - v8.99.1551 Version bump for RB
 - v8.99.1550 Added Block::getFogColor to allow custom blocks to control fog colors while inside them. (#4090)
 - v8.99.1549 Optimize ExtendedBlockState.getClean, cache the return value instead of calculating it. Closes #3936
 - v8.99.1548 Squelch spam in EventBus register, Closes #4102
 - v8.99.1547 Add @ObjectHolder scanning to vanilla MobEffects, Biomes, Enchantments, SoundEvents, and PotionTypes constants. Closes #4104
 - v8.99.1546 Use java 8 collection functions
 - v8.99.1545 Use lambdas for short anonymous methods
 - v8.99.1544 Use multiple catch, try-with-resources, replace system.out and e.printStackTrace
 - v8.99.1543 Fix the creative menu search function. Closes #4100
 - v8.99.1542 Fix MissingMapping REMAP action. Closes #4069
 - v8.99.1541 Repopulate client SearchTreeManager when registries are refreshed. Closes #4094
 - v8.99.1540 Fix Biome unit test
 - v8.99.1539 Add support for loading mod advancements from the mod jar files.
 - v8.99.1538 Fix error when using RegistryBuilder and not specifying a max id number.
 - v8.99.1537 Allow the recipe registry to be modified.
 - v8.99.1536 Fix BiomeDictionary not collecting correctly.
 - v8.99.1535 Remove incorrect call to .toString() when instantiating custom config array entries. (#4078)
 - v8.99.1534 Remove outdated patch to BlockDoublePlant
 - v8.99.1533 Fix substitution tests
 - v8.99.1532 Remove some deprecated methods and clean up
 - v8.99.1531 Remove the call to client.refreshResources during loading (#4032)
 - v8.99.1530 Added dependencies and dependency ordering for textures. (#4070)
 - v8.99.1529 More work on registry override ability. Closes #4079
 - v8.99.1528 Fix ItemStack/Block/BlockSpecial not applying at runtime.
 - v8.99.1527 Add a FluidUtil method to interact with an arbitrary IFluidHandler (#4080)
 - v8.99.1526 Further Java 8 cleanup (#4077)
 - v8.99.1525 Fix missed side only on BlockFlower
 - v8.99.1524 Fix ModelBlockAnimation expsing a private class.
 - v8.99.1523 Make Block.getSubBlocks not client side only.
 - v8.99.1522 Cleanup of model system, taking advantage of java 8;
              replaced guava Optional and Function with java 8 versions.
 - v8.99.1521 Reload client recipe book after loading modded recipes.
 - v8.99.1520 Make Dummy block an Air block.
 - v8.99.1519 Fix NPE in MissingMappings event. Closes #4067
 - v8.99.1518 Make getSubItems non-client only. Use it for Ingredient iteration.
 - v8.99.1517 Fix Emerald generation causing chunk loading.
 - v8.99.1516 Fix minecraft:item_nbt ingredient type.
 - v8.99.1515 Add Block.getDrops that uses NonNullList, deprecate the old method. Fix #3567 (#3778)
 - v8.99.1514 Remove arrival/departure message methods from WorldProvider (#2733)
 - v8.99.1513 Clean up logging
 - v8.99.1512 Use instanceof ItemFishingRod instead of item equality (#4060)
 - v8.99.1511 [1.12] Cleanup of files with old licence headers, Add missing LGPL 2.1 licence headers (#4051)
 - v8.99.1510 Fix uncaught ClassCastException from invalid recipe file (#4043)
              A JsonSyntaxException will now be thrown, caught and logged when the conditions property of a recipe isn't an array
 - v8.99.1509 Fix onBlockClicked handler firing twice and Item.onArmorTick in the wrong place (#4037)
 - v8.99.1508 Update MCP to 20170624
 - v8.99.1507 Remove Java 8 warnings now that Minecraft requires it
 - v8.99.1506 Fire AnimalTameEvent for parrots (#4003)
 - v8.99.1505 Make ForgeRegistry iterator sorted. Closes #4058 (#4059)
 - v8.99.1504 Loosen up registry locks until data freeze.
 - v8.99.1503 Fix conflicts
 - v8.99.1502 Implement override tracking and syncing.
              Overrides MUST be registered within a tracked event so we know what mod it came from.
              This will allow servers/saves to select which mod 'wins' and becomes to active entry.
              This should also mean that when connecting to a vanilla server things will revert.
 - v8.99.1501 Disable substitution test, substitutions are not managed the way they used to be.
              We do not care about substitutions, People who replace entries should make them compatible with the existing item.
 - v8.99.1500 Fixup some registry tests, dummies are now persisted across syncing.
 - v8.99.1499 More work, game loads and runs now.
              Moved Registry events to directly AFTER PreInit instead of before.
              This allows modders to register handlers for it without @EventBusSubscriber.
              It also allows you to register custom things needed before the construction of blocks or items such as Fluids.
              TODO: Move Fluids to a real registry.
              @ObjectHolder can now be used on private fields.
              Reworked FMLModIdMappingEvent to include data for all registries.
              Tile Entities are now registrable.
 - v8.99.1498 First pass of registry rewrite.
              Tests do not run yet.
              Things of note:
              Removed the idea of substitutions, just register multiple items with the same name they will override each other like a normal map.
              Decoupled Forge registries from vanilla classes. They now use bouncer classes. MODDERS SHOULD NEVER USE THESE
              Introduced more stringent registry locking. As it sits things are only allowed to be registered during the RegistryEvent.Registry phases!
              This is to force modders to split up their registrations, and pave the way for calling these functions multiple times during a single MC lifecycle.
              ObjectHolder, Missing Mappings, etc... *should* now work for all registry types, nothing should be special cased to Blocks/Items anymore.
              Added optional generic dummy factory to registries, to allow registry creators the ability to dummy more then just Blocks.
              Re-worked the ItemStack transformer and applied it to ItemBlock and ItemBlockSpecial. Allowing us to cleanup reflective hacks in Block callbacks.
              Registry onAdd callback is now only fired on the ACTIVE registry, fixing any issues of temp registries overriding active objects.
 - v8.99.1497 Fix Universal bucket handling for Fluids with NBT (Fix #3757)
 - v8.99.1496 Clean up Logging (#3953)
              # Conflicts:
              #	patches/minecraft/net/minecraft/client/renderer/texture/Stitcher.java.patch
              #	patches/minecraft/net/minecraft/client/renderer/texture/TextureMap.java.patch
              #	patches/minecraft/net/minecraft/entity/EntityList.java.patch
              #	patches/minecraft/net/minecraft/tileentity/TileEntity.java.patch
              #	src/main/java/net/minecraftforge/oredict/OreDictionary.java
 - v8.99.1495 Fix ShapedOreRecipe matching. #4038
 - v8.99.1494 Fix recipe names in packaged jars. Closes #4039
 - v8.99.1493 Update NoteBlockEvent with new instruments. Resolves #4018. (#4019)
 - v8.99.1492 Fix Chunk  patch (#4036)
 - v8.99.1491 IRecipeConditions forge:and and forge:false (#4017)
 - v8.99.1490 Fix patches in Chunk and Explosion (#4036)
 - v8.99.1489 Fix itemstack comparison with null
 - v8.99.1488 Fix loading recipe jsons from jar files.
 - v8.99.1487 Fix shapeless recipes not being able to use NBT on output, and fixed issue with null groups.
 - v8.99.1486 [1.12] Fixes Exception when getting modlist for a vanilla client (#4028)
 - v8.99.1485 Remove unused patch to ItemRecord. Closes #2686. (#4035)
 - v8.99.1484 Log info on Travis tests
 - v8.99.1483 Disable TestNetworkHandshake to make Travis work again
 - v8.99.1482 Add timeout to TestNetworkHandshake setup
 - v8.99.1481 Add missing Override annotations
 - v8.99.1480 Update MCP mappings to 20170617
 - v8.99.1479 Update mcp mappings to 20170611
 - v8.99.1478 Clean up ShapedOreRecipe and ShapelessOreRecipe
 - v8.99.1477 Allow condition factories to be registered from JSON (#4015)
 - v8.99.1476 Patch a small bug in SPacketLoginSuccess that lets us emulate the network
              handshake. This will be very useful as I rebuild the networking.
 - v8.99.1475 Filter any recipe starting with _, Such names are reserved for metadata.
              Actually implement conditions for recipes.
 - v8.99.1474 Fix NBT ItemStack support in json loader. Closes #4002
 - v8.99.1473 Fix OreIngredient comparing items in reverse. Closes #3999
 - v8.99.1472 Make registries persist by default, fixes #3989 (#3998)
 - v8.99.1471 Fix exception in ShapedOreRecipe.checkMatch for recipes that don't fill entire crafting grid (#3995)
 - v8.99.1470 Fix parseShaped missing Empty slot item. Closes #3990
 - v8.99.1469 Fix CraftingHelper.parseShapred error. Closes #3979
 - v8.99.1468 Fix NPE in config menu with custom keybinds. Closes #3985
 - v8.99.1467 In-progress Registry system enhancement.
              Needs cpw to take a look at enabling removing/overriding in the registry stuff.
              But in theory it loads json recipes for mods now.
 - v8.99.1466 Update ASM for 5.2, and host it on Forge's maven now.
 - v8.99.1465 Update VanillaRegistryTests
 - v8.99.1464 Try a different way of doing the callback, it removes the derpitude, but at
              one point, I thought the way it was was necessary. Is this a race condition?
              Dunno, but it's a lot simpler and doesn't rely on a netty hack.
 - v8.99.1463 Fix the netty bug introduced by netty commit https://github.com/netty/netty/commit/29fdb160f33776c76f0b46aada48a9c9f3babcbf
              that means we don't get activated until after handlerAdded is complete.
              In effect, our handler can't handle anything until handlerAdded has
              completed.
 - v8.99.1462 Initial patch update to 1.12.
              Some things to note:
              Netty is screwy so currently can't join single player. @cpw
              Crafting has been MAJORY reworked. The current GameRegistry functions are nooped, this is IN THE WORKS.
                Just need to move the recipe list to a full class registry, and then re implement the in-code recipe registration.
                Also, it IS advised that modders move to JSON, because ideally we'll see a S->C recipe syncing system in 1.13
                which would allow servers to have custom recipes.
                OreDictionary currently 1/2 works, need to write a better algorithm for replacing ingredients.
                Please be patient
              Rendering:
                A lot of functions got a new float parameter, this is similar to partial ticks, needs more research
 - v8.99.1461 Fix getShareTag replacing data on the server (#3776) Closes #3682
 - v8.99.1460 Fix crashed caused by bad mods reflectively breaking the grass drop list. Closes #3943
 - v8.99.1459 Fix shaders not loading from mod domains Closes #3921
 - v8.99.1458 Clean up MapData patch (#3905)
 - v8.99.1457 NBTTagList implements Iterable<NBTBase> (#3884)
 - v8.99.1456 Fix canRiderInteract being called on the wrong entity (#3934)
 - v8.99.1455 Changed Event.setCanceled To throw UnsupportedOperationException instead of IllegalArgumetnException when called on a non-cancelable object (#3926)
 - v8.99.1454 Make Teleporter fields accessible to subclasses (#3930)
 - v8.99.1453 Deprecate vanilla getExplosionResistance and properly annotate the forge replacement (#3929)
 - v8.99.1452 Make World.isValid and World.isOutsideBuildHeight public (#3919)
 - v8.99.1451 Clean up formatting of Forge Test mods and disable noisy ones (#3908)
 - v8.99.1450 Fix broken milk bucket model (#3925)
 - v8.99.1449 Fix patches of GuiScreen(#3704) and ItemDye(#3736) (#3878)
 - v8.99.1448 Make hopper update accessible to subclasses. Closes #3849
 - v8.99.1447 Update EntityPlayer armor calculations and ISpecialArmor (#3838)
 - v8.99.1446 Tweak vertex lighter to avoid causing excess array initialisations (#3771)
 - v8.99.1445 Fixes for PlayerDestroyItemEvent being called with empty itemstacks. (#3728)
 - v8.99.1444 [1.11.2] Added support for Village capabilities (#3648)
 - v8.99.1443 Fixes BlockLiquidWrapper placing a Static fluid where it should place a Flowing one (#3893)
 - v8.99.1442 Disable frost walker enchantment on anything but vanilla water (#3906)
 - v8.99.1441 Fix head being angled badly when riding mobs. Fixes MC-1207 (#3901)
 - v8.99.1440 Print system details on startup without printing a full crash report (#3909)
 - v8.99.1439 Reduce memory pressure from new objects during loading screen (#3907)
 - v8.99.1438 Add methods to write IForgeRegistryEntry to ByteBuf (#3806)
 - v8.99.1437 Fix normals not being generated for formats without normals (#3896)
              Fix normals not being generated for formats without normals
 - v8.99.1436 Fix MC-117087, prevent calling Class.getSimpleName on TEs unnecessarily (#3873)
 - v8.99.1435 Add a configurable delay when unloading dimensions, fixes #3455 (#3679)
 - v8.99.1434 Changed custom entity selectors from event based to factory based. (#3579)
 - v8.99.1433 Create ItemFishedEvent, the event is cancelable, but items are not mutable. Use LootTables to control that. (#3705)
 - v8.99.1432 Fix forge pipeline block shifts (#3789)
 - v8.99.1431 Add pack.mcmeta to examplemod (#3813)
 - v8.99.1430 Relocate TileEntity#onLoad call to after it's added to the world instead of the chunk so as to have a valid world reference (#3836)
 - v8.99.1429 Improvements to FluidUtil (#3839)
 - v8.99.1428 Allow client commands to control whether they can be invoked without prefix. (#3847)
 - v8.99.1427 When the window is closed during loading, exit the game quickly (#3858)
 - v8.99.1426 Remove splash.properties option for Mojang logo (has been disabled) (#3859)
              Fix backgound color being applied to the Forge logo
 - v8.99.1425 Fix GuiMultipleModsErrored ignoring scrolling with mouse wheel. (#3861)
 - v8.99.1424 [1.11.2] Fixed Zombie Villagers not setting and getting professions correctly (#3678)
 - v8.99.1423 Prevent NPE in ConfigManager and fix config gui being enabled for all mods. Fixes #3856. (#3860)
 - v8.99.1422 Fix return value of ItemHandlerHelper.insertItem being incorrect when destination was null. Closes #3840
 - v8.99.1421 Fix vanilla inventory wrappers not properly calling markDirty. Closes #3854 and #3810
              Also updated IItemHandler javadocs to reflect returning EMPTY instead of NULL.
 - v8.99.1420 Add in a check to the splash screen. If the Display.update call takes
              too long on average (over first 200 frames) we'll use a sleep based
              timer to allow mods doing splash screen work some time on the
              LWJGL global lock.
              (cherry picked from commit 03d7eaa)
 - v8.99.1419 Cleanup AccessTransformer debug output
 - v8.99.1418 Fix NumberFormatException being thrown for empty ItemStack deserialization
              Thanks @gabizou, 1.11.2 version of #3830
 - v8.99.1417 Fix Fluid models rendering with gaps (#3747) Closes #2993
 - v8.99.1416 Fix mutable blockpos leak MC-114281 (#3742)
 - v8.99.1415 Fix typo in LootEntry.Serialiser causing incorrect serialisation. Closes #2757, Fixes MC-115407 (#3823)
 - v8.99.1414 Fix invulnerable items becoming invisible client side MC-53850 (#3807)
 - v8.99.1413 Add Item.canDestroyBlocksInCreative() allowing more items to not break blocks in creative (#3805)
 - v8.99.1412 Ignore calls to sendMessage for fake players. Fixes #3796. (#3798)
 - v8.99.1411 Fixed HarvestDropsEvent issue by fixed-length lists on getDrops (#3778)
 - v8.99.1410 Add GenerateMinable event for mesa gold (#3774) Closes #3738
 - v8.99.1409 Skip loading models if there is a fatal mod dependency error (#3772) Close #3768
 - v8.99.1408 Add AnimalTameEvent for handling animal taming (#3763)
 - v8.99.1407 Added missing bounds check to ChunkCache.getBiome (#3752)
 - v8.99.1406 Allow result of PlayerInteractEvent to be changed when it's cancelled (#3744)
 - v8.99.1405 Add EnumHand and ItemStack to BonemealEvent (#3736)
 - v8.99.1404 Added a boolean flag for disabling Entity onUpdate (#3731)
              The flag is false by default, and if true the Entity will not update. It is saved and loaded from NBT, and is called updateBlocked. Modders are responsible for managing this flag for entities they with to 'freeze' or 'unfreeze'.
 - v8.99.1403 Revert block snapshots in reverse order. Fixes #3608.
 - v8.99.1402 Add LootTableManager to the LootTableLoadEvent (#3717)
 - v8.99.1401 Fix EntityFallingBlock check for ITileEntityProvider (#3711)
 - v8.99.1400 Added ClientChatEvent. Closes #1442 (#3704)
 - v8.99.1399 Fix custom array entry class for config GUI being ignored when adding new entries (#3697)
 - v8.99.1398 Use thread groups to detect the effective side (#3644)
 - v8.99.1397 New LivingDestroyBlockEvent for controlling if some entities can destroy blocks (#3628)
 - v8.99.1396 Fix breaking particles on dedicated server. Closes #3825
 - v8.99.1395 Fix arrays in map values for config system
 - v8.99.1394 [MC-2518] Fixed missing break sound and particles. Closes #3821
 - v8.99.1393 Fix java 6/7 compatibility in GuiConfig (#3824)
 - v8.99.1392 [1.11.x] Fix blank tab in creative inventory when additional tabs evenly divisible by 10 (#3817)
 - v8.99.1391 Adding config GUIs to the @Config based configuration System (#3735)
              Lots of internal API that modders should not touch. See test mods for example usages.
 - v8.99.1390 Fix vanilla bug where player reputations villages were reset on read.
              Deprecated Username based API in favor of UUID based API.
 - v8.99.1389 Add setter for default key in RegistryBuilder. Closes #3804
 - v8.99.1388 Fix error when reading world info for old saves with missing dimensions. Closes #3786 #3331
 - v8.99.1387 Detect and log cascading chunk generation issues during terrain population (#3756)
 - v8.99.1386 Fix duplicate achievements getting added to the achievement list (#3770) (#3779)
 - v8.99.1385 Fix #3733 Splash Screen memory bar background matches screen background (#3775)
 - v8.99.1384 Add additional constructors to EnergyStorage to set values at load time.
 - v8.99.1383 Fix parameter-names for WorldProvider.shouldMapSpin (#3767)
 - v8.99.1382 Fix MC-112730 TE global renderer duplicate render (#3651)
              * Fix TE global renderer duplicate render
 - v8.99.1381 Fix entity write catch block (#3726)
 - v8.99.1380 Fixed TESR items not rendering correctly before entering world (MC-112292) (#3666)
              Fixed crash when rendering text in TESR items before entering world
 - v8.99.1379 Fixed 'reset to defaults' button not working on some Forge config fields.
 - v8.99.1378 Add DifficultyChangeEvent (#3525)
 - v8.99.1377 Allow mods to set other default "home dimensions" for respawning. (#3528)
 - v8.99.1376 Persist PotionEffect curative items and initialize defaults from Potion (#3573)
 - v8.99.1375 Added Forge slot methods to creative container (#3581)
 - v8.99.1374 Restore missing Biome GetWaterColor event. Closes #3164. (#3625)
 - v8.99.1373 Fixed Missing Furnace Fuels (#3627)
 - v8.99.1372 Fix @Config.Comment not working on subcategory Objects. Closes #3593
 - v8.99.1371 Prevent concurrent modification of ClassInheritanceMultiMap (#3632)
 - v8.99.1370 Improve exception messages during initialization.
 - v8.99.1369 Fixed ChunkCache.getTileEntity creating tile entities off world thread.
 - v8.99.1368 Start firing AttachCapabilitiesEvent<ItemStack> (#3645)
 - v8.99.1367 Add @Name annotation to config system allowing you to use custom key for value.
              Also added category option to root config to allow customization. See examples/docs for information.
 - v8.99.1366 Fixed Flower Forests not having proper flowers. Closes #3652
 - v8.99.1365 Fix Poppy to Dandelion ratio
 - v8.99.1364 Fix forge:default-item missing case for FIXED transform (#3663)
 - v8.99.1363 Add implementation for Living Attack event on client-side for players (#3667)
              * Fixed unused import
 - v8.99.1362 Fix bug caused by ItemMinecart patch (#3672)
 - v8.99.1361 Make getRGBDurabilityForDisplay use getDurailityForDisplay by default. Closes #3670 (#3673)
 - v8.99.1360 Add a null check for the throwable message in NetWorkDispatcher#exceptionCaught (#3688)
              (cherry picked from commit 1be1bb59c5c4c7432c515ef07beb6bf7e1f6ef27)
 - v8.99.1359 Use Forge setting to determine baby zombie chance. Fixes #3690.
 - v8.99.1358 Properly fix IShearable implementation. Fixes shears taking damage twice, mooshroom particles, and blocks dropping incorrect loot.
 - v8.99.1357 Fix English injection for some mods on dedicated server.
 - v8.99.1356 Fix hoppers being able to insert shulker boxes into shulker boxes.
 - v8.99.1355 Override Mojang's new logging config to re-enable our logging to text file.
              The new launcher's GUI for logs WILL NOT WORK until they add support on their end.
 - v8.99.1354 Fix for bad decompile process on Particle.java that causes onGround flag to not get set properly as well as motionX and motionZ not being set to 0 when their axis has collision happening (#3716)
 - v8.99.1353 Fix ClientTickEvent Post firing inside another profiler section (#3715)
 - v8.99.1352 Fix Item.doesSneakBypassUse being applied incorrectly.
 - v8.99.1351 Added check for quad builder to always have the particle texture set, and fixed where that wasn't true. Fixes #3653
 - v8.99.1350 Stop rotation of extended pistons, beds, and double chests Fixes #3634 
              Fix rotation of repeaters and comparators
 - v8.99.1349 Fixed TileEntity#getRenderBoundingBox not offsetting correctly causing more TEs to render then needed (#3709)
 - v8.99.1348 [1.11.2] Make AbstractSkeleton implementable by fixing limited access on getStepSound (#3702)
 - v8.99.1347 Fix extracted mods crash report file name for Windows (#3701)
 - v8.99.1346 Remove dynamic lambda methods when inside of SideOnly methods
              Clean signatures of ReflectionHelper methods.
 - v8.99.1345 Fix spawn-fuzz formula (#3695)
 - v8.99.1344 Fix world spawn fuzz. (reverted from commit 450c3a80c10c1dc27ef68a3f5e5f58af6a827fde)
              Protip Don't code while groggy.
 - v8.99.1343 Fix world spawn fuzz.
 - v8.99.1342 Fix some cases where world time is not passed through the WorldProvider. (#3685)
 - v8.99.1341 Fix addTypes not adding in the base types. (#3681)
 - v8.99.1340 Replace listSubtypes with listSupertypes to match the intended behavior. (#3564)
 - v8.99.1339 this finaly fixes #2866 (#3656)
 - v8.99.1338 Fix MC-111753 (#3655)
 - v8.99.1337 Fix default missing model zoom text not being set to false on all places.
 - v8.99.1336 Small bugfix in lighting logic.
 - v8.99.1335 Added the variant name to the missing model. (#3328)
 - v8.99.1334 Fix #3635 MC-103403 fix ingredient count for ingot block recipes (#3640)
 - v8.99.1333 New client config option to force all chunk rendering off the main thread.
              This may help FPS issues, but may also result in world holes/rendering issues.
              Also fix Forge configs not saving properly.
 - v8.99.1332 Cache entity constructors for a small performance optimization
 - v8.99.1331 Bypass forge chunk cache if it's configuratively disabled
              (cherry picked from commit 9fe6385)
 - v8.99.1330 Fix category comments not working. Closes #3593
 - v8.99.1329 Fix Biome#getSpawnableList returning an empty list for non-vanilla EnumCreatureTypes (#3611)
 - v8.99.1328 Skip first baking in ModelLoader (#3621)
 - v8.99.1327 Allow block to specify their type for AI pathfinding (#3546)
 - v8.99.1326 Fix vanilla bug MC-98707 (#3565)
 - v8.99.1325 Improve performance of inserting into inventory wrappers (#3622)
 - v8.99.1324 Add missing patch to ItemStack isItemStackEqual (#3577)
 - v8.99.1323 Add Iron Nugget to OreDictionary (#3571)
 - v8.99.1322 Fix ContainerRepair patch to prevent NPE (#3553)
 - v8.99.1321 Fix DungeonHooks method to use correct type (#3587)
 - v8.99.1320 Removed an unsafe usage of `EntityMinecart.getType()` (#3592)
 - v8.99.1319 Fix #3576 Unnecessary warning about totem being renamed (#3614)
 - v8.99.1318 Fix milk not working on anything at all (#3574)
 - v8.99.1317 Fix #3596 Close jar sources safely in Java 6 (#3597)
 - v8.99.1316 Clean up null issues, add more annotations (#3590)
 - v8.99.1315 Small cleanup for PlayerInteractEvent (#3563)
 - v8.99.1314 Fix and clean up ItemBow.onPlayerStoppedUsing() patch (#3555)
 - v8.99.1313 Fix IItemHandler's IStorage using nulls (#3580)
 - v8.99.1312 Fix null check in BrewingRecipeRegistry (#3584)
 - v8.99.1311 Fix a couple more ItemStack null checks (#3586)
 - v8.99.1310 Use travis_wait to extend the timeout on gradlew build (#3610)
 - v8.99.1309 Fix super call to ItemOverrideList constructor inside AnimationItemOverrideList, fixes #3264.
 - v8.99.1308 Added caching for baked vanilla models, fixes #3594.
 - v8.99.1307 Fix horse cap patch being reapplied in the wrong place (#3609)
 - v8.99.1306 Add .travis.yml (#3598)
              * Add .travis.yml
              * fix --refresh-dependencies
              * try java 8
              * add build with stracktrace
              * Fix running test
              * try building with java 6
              * try using simplified init.gradle
              * Revert "try using simplified init.gradle"
              This reverts commit e56041e794e3b8c13453245eb2605118e4ac68ce.
              * Revert "try building with java 6"
              This reverts commit 51795385f453fdd8a0e77c632b5463d8754b1ba4.
              * Fix running tests
              * skip createExe task
              * Test with broken debug mod
              * Revert "Test with broken debug mod"
              This reverts commit 3b26700582ba4f4f5477f5927b0006ef0fe85bb0.
 - v8.99.1305 Fix tests...
 - v8.99.1304 Inital 1.11 update.
 - v8.99.1303 Fix #3561 import io.IOUtils instead of compress.utils.IOUtils (#3562)
 - v8.99.1302 Update MCP mappings to snapshot_nodoc_20161220 (#3551)
 - v8.99.1301 Properly deobfuscate lambda expressions (#3552)
 - v8.99.1300 Add nullable annotations to IGuiHandler (#3550)
 - v8.99.1299 Add hook to allow any block to respond to filtered block updates like the Observer block (#3547)
 - v8.99.1298 Fix some resources that are never closed, close in a finally block (#3544)
 - v8.99.1297 [1.11] Fixes for Chunk.getBlockLightOpacity implementation (#3537)
 - v8.99.1296 [1.11] Fix ItemHandlerHelper canStack and ItemStack areTagsEqual methods not checking capabilities  (#3500)
 - v8.99.1295 Make NBSP character display as a space. MC-2595 (#3522)
              Add easy getter for the Locale: MinecraftForgeClient.getLocale()
 - v8.99.1294 Added Oak door to Ore Dictionary Exclusion list to fix able to craft it with any wood type (#3519)
 - v8.99.1293 Fix setting the world in TileEntity.addTileEntity (#2863) (#3517)
 - v8.99.1292 [1.11] Made WalkNodeProcessor consider burning blocks (#3515)
 - v8.99.1291 Fix uses of uppercase "Forge" where it fails Loader.isModLoaded(modID) (#3513)
 - v8.99.1290 Patch EntityPlayerSP to use location-aware version of isNormalCube (#3494)
 - v8.99.1289 [1.11] Add memory display to loading screen (#3447)
 - v8.99.1288 reset repo to upstream and reapplied patches (#3434)
 - v8.99.1287 [1.11] Added EnchantmentLevelSetEvent (#3433)
 - v8.99.1286 Register Minecraft mod container in FML loader (#3414)
 - v8.99.1285 Small memory optimization in Registries.
 - v8.99.1284 Fix modid field name for ProjectInjector.
 - v8.99.1283 Enable Enforcement of modid formatting. Must be lowercase and <= 64 characters
 - v8.99.1282 Bump version for RB.
 - v8.99.1281 [1.11.x] Refine fluid placement utilities (#3509)
 - v8.99.1280 Properly filter out annotations that are for multiple mods in the same mod source.
              This prevents disabled mods from getting their proxies injected.
              Also prevents mods from getting their proxies injected multiple times.
              Effects the @EventBusSubscriber, @Instance, @Metadata, @SidedProxy annotations.
              If the target modid is not in the annotation data, and there are multiple mods in the source, it will attempt to find it by matching the annotations's class names.
              This is a potentially breaking change. Review your logs for "skipping" messages.
 - v8.99.1279 Prevent a crash when scheduling block updates for non-existing blocks #3485
 - v8.99.1278 Fix issue reading chunks from the network when client and server do not agree on block count. Closes #34925
 - v8.99.1277 Restore missed patch in World.updateComparatorOutputLevel. Closes #3495
 - v8.99.1276 Make SlotItemHandler override Slot.getSlotStackLimit. Closes #3497
              Make Container.mergeItemStack respect target slot's max size when slot is non-empty. Closes #3498
              Fix Shift clicking in Beacons with stacked items when fuel slot is empty.
 - v8.99.1275 Added gradle.properties to  MDK (#3361)
              The file sets the default max heap size to 3 GiB so that the decompilation doesn't fail as often.
              (cherry picked from commit 49ec3d1b9322ee2b7a1312059118173b0b3fe6d0)
 - v8.99.1274 Add ItemBlockSpecial#getBlock (#3343)
              (cherry picked from commit cf26f4acbe48ee8790edc03d0b5c16c1167278ab)
 - v8.99.1273 Add null check and informative error message when client receives an invalid update packet (#3266)
              (cherry picked from commit 882e0e3bf22784d693e3816b0efeba5fbedb1a22)
 - v8.99.1272 Fix for showing config default values twice in tooltip (#2257) (#3338)
              (cherry picked from commit be73ec3d5ebd972cfacb0f255f71112a0430bc43)
 - v8.99.1271 Added isItemValidForSlot check to hopper extraction (#3444)
              (cherry picked from commit 0348760a774ca7ed9639376baadae38e272f5bf8)
 - v8.99.1270 Fix NPE when rendering missing mod screen with version bound requirements. #3501
 - v8.99.1269 Make sure to log kick messages in NetworkDispatcher. Closes #3507
 - v8.99.1268 [1.11] Fix null checks in shouldCauseReequipAnimation (#3482)
 - v8.99.1267 [1.11] Add biome dictionary types for newer biomes (#3475)
 - v8.99.1266 [1.11] Add canApplyAtEnchantmentTable to Item (#3463)
              Allowing increased control of which enchantments can be put on an item over Vanilla's hard-coded item type checks.
              Render enchantment buttons disabled when the item is enchantable but the enchantability requirement is not met on lower levels.
 - v8.99.1265 Add a way for modded GuiScreens to cancel mouse and keyboard events (#3438)
 - v8.99.1264 Add missing pooled BlockPos retain in World patch (#3486)
 - v8.99.1263 Moved TextureStitchEvent.Pre to allow custom sprites for blocks (#3436)
 - v8.99.1262 Fix sky colour blending not working for render distances >16 (#3476)
 - v8.99.1261 Allow connectable blocks to choose what they can connect to (#3437)
 - v8.99.1260 Changed Armor Material to use an ItemStack aware version (#3469)
 - v8.99.1259 Fix Redstone Torch memory leak (#3474)
 - v8.99.1258 BiomeDictionary code cleanup (#3466)
 - v8.99.1257 Added EquipmentChangeEvent (#3411)
 - v8.99.1256 Update assets to new Forge brand (#3464)
 - v8.99.1255 First pass at exposing data fixers to modders.
              Each mod gets its own version number, mods SHOULD NOT rely on other
              mod's fixers, just care about yourself.
              Walkers can use IDataFixerData to retrieve their version.
 - v8.99.1254 Add getSlotLimit(slot) to IItemHandler (#3445)
 - v8.99.1253 Pass along if the respawn event was the result of the end being conquered or not (end respawning is really FUNKY code and uses death instead of 'change dimension')
 - v8.99.1252 Add method to check if an Entity can trample a Block. Fixes #2510 (#2730)
 - v8.99.1251 Provide access to GuiContainer location and dimensions (#3440)
 - v8.99.1250 Clean up handling of changes to IVertexConsumer (#3458)
 - v8.99.1249 Provide access to ShapedOreRecipe width and height (#3439)
 - v8.99.1248 Quick fix for another ItemStack null check (#3426)
 - v8.99.1247 Fix problem with the server hanging around after forcing the client to exit, leaving behind stale processes.
 - v8.99.1246 Fix using the wrong Pair implementation (#3449)
 - v8.99.1245 Fix #3432 Hopper and Dropper item moving does not exactly match vanilla (#3442)
 - v8.99.1244 Fix #3424 ItemCraftedEvent returns air when shift-clicking (#3441)
 - v8.99.1243 Cleanup some null checks and remove deprecated methods in Item and Block (#3429)
 - v8.99.1242 Fix max CustomPayload size, 1MB not 16MB.
 - v8.99.1241 Insert FML packet handler into Vanilla pipelines in case modders send FMLPacket to vanilla. Fixes #3422
 - v8.99.1240 Make all tests one side only, so we can test vanilla clients in dev env.
 - v8.99.1239 Fix AbstractMethodException in FML Registries. Closes #3427
 - v8.99.1238 Fix ItemStack null check in PlayerInteractionManager
 - v8.99.1237 Move EntityHorse capability patches to AbstractHorse (#3417)
              Fixes #3409
 - v8.99.1236 Fix Item transfers related to Hoppers.
 - v8.99.1235 Remove Block.addInformation exists in vanilla (#3413)
 - v8.99.1234 Initial annotations/nullability changes (#3392)
 - v8.99.1233 Add GetCollisionBoxesEvent. Allows manipulation of the collision boxes of blocks for entities. MC1.11 edition. (#3405)
 - v8.99.1232 First draft of Entity Registry re-write.
 - v8.99.1231 Make Wither Skulls respect Block.canEntityDestroy. Closes #3404
              (cherry picked from commit 6b52023a5c341420d976cb50359e2a2a4a6a9192)
 - v8.99.1230 Added EnumHand parameter to Block.getStateForPlacement (#3402)
 - v8.99.1229 Fix client side placement issue on blocks with GUIs. Closes #3399
 - v8.99.1228 Fix issues with ZombieVillagers Closes #3398
              1.11 doesn't intertwine zombie types anymore so our edits to split them out for custom professions are not needed.
 - v8.99.1227 Fix Villagers for 1.11 (#3401)
              - Add cartographer registry entry
              - Fix textures for the nitwit
 - v8.99.1226 [1.11] Fix nullability issues around ForgeHooks and Capabilities (#3395)
 - v8.99.1225 Change OreDictionary over from "null" to the new ItemStack system. (#3400)
 - v8.99.1224 Do not install mod_list.json for optional mods.
              Classpath scanning is in so they will still be detected
 - v8.99.1223 Include Mercurius in installer. See Forge Forums for more info.
 - v8.99.1222 Restore the ability to register modded TileEntities.
 - v8.99.1221 Implement fluid item capabilities without item swapping
 - v8.99.1220 Remove deprecated Fluid stuff
 - v8.99.1219 Fix crafting causing crash (#3388) Closes #3387
 - v8.99.1218 Fix ItemStackHandler's constructor ignoring size. Closes #3386
 - v8.99.1217 Fixed damage bar color. Closes #3389
 - v8.99.1216 Make EntityShulker fire EnderTeleportEvent. Closes #3383
              (cherry picked from commit d48985fafaed6de6f09136b999ca8aa44184a7b9)
 - v8.99.1215 Added event to allow modification of player visibility to mobs/AI (#3382)
              (cherry picked from commit 0a5ef64d6ea96fe85d7c62107081ced649e6a3e9)
 - v8.99.1214 Restore another missing patch in WorldProvider.
 - v8.99.1213 Disable capabilities for empty ItemStacks.
 - v8.99.1212 [1.11] Fix initCapabilities for ItemStacks (#3379)
 - v8.99.1211 Apply missed patch to WorldProvider.
 - v8.99.1210 Fix build.gradle problems:
              Installer missing url.png
              UploadArchives erroring on local systems due to missing changelog
              Adding branch name improperly.
 - v8.99.1209 Fix localizations not loading correctly in legacy resource packs.
 - v8.99.1208 Fix FurnaceRecipy registration.
 - v8.99.1207 Fixed test cases for 1.11 changes.
 - v8.99.1206 Initial 1.11 release update.
 - v8.99.1205 Initial 1.11-pre1 update
 - v8.99.1204 regenerate entitylivingbase patch
 - v8.99.1203 Update to 20161111 mcp names
 - v8.99.1202 Improve error message from crashes during loading (#3362)
 - v8.99.1201 Added events for crop growth (#3320)
 - v8.99.1200 Add support for custom entity selectors in commands (#3356)
 - v8.99.1199 Added PermissionAPI (#3155)
 - v8.99.1198 Add hand argument to BlockEvent.PlaceEvent (#3221) (#3270)
 - v8.99.1197 Fixes #3237 and #2752. (#3347)
              * Fix #3237 by correctly utilising the keepLooking argument.
              * Explain within SimpleNetworkWrapper's javadoc that the execute of the handler isn't on the main Minecraft thread.
 - v8.99.1196 Made default slot implementation respect inventory stack size limit.
 - v8.99.1195 Fixed Block.setBedOccupied ignoring 'occupied' parameter
 - v8.99.1194 Add Item#getNBTShareTag (#3342)
              * Add Item#getNBTShareTag
              * Update comment
 - v8.99.1193 Call Looting Event on player death and loot table drops (#3275)
              * Call Looting Event on player death and loot table drops
              * Simplify patches
              * More code cleanup: Replace old usage with compact forgehooks implementation
 - v8.99.1192 Fix POTENTIAL issue with Texture Stitcher exceeding max size.
 - v8.99.1191 Fixed Ore Dictionary replacing the oak boat recipe (#3329)
              Fixes the oak boat recipe being able to be crafted with any wood
 - v8.99.1190 Improve the default isItemValid() and getItemStackLimit() implementations in SlotItemHandler. You can now properly swap the player's held itemstack with the slot's itemstack. (#3273)
 - v8.99.1189 Fixed texture stitcher not using full texture height before expanding width.
 - v8.99.1188 Update readme to be a little more clear.
 - v8.99.1187 Special case not drooping snowballs for water and snow layers. Closes #3326
 - v8.99.1186 Fix MC-105406 (OpenGL leak in View Frustum) (#3308)
 - v8.99.1185 Fix very laggy mipmap slider MC-64581 (#3305)
 - v8.99.1184 Add Block#getStateForPlacement (#3129)
 - v8.99.1183 Add better key modifier behavior for GUI contexts (#3307)
 - v8.99.1182 Make item repair recipe respect itemstack's getMaxDamage (#3295)
 - v8.99.1181 Fix infinite loop in dragon fight when the dragon is over the void.
 - v8.99.1180 Fix Tabbing issues with config classes.
 - v8.99.1179 Initial pass a re-working the configuration system.
              Work in progress.
 - v8.99.1178 Add in missing test runner for a test. Fixes failing tests on jenkins, hopefully.
 - v8.99.1177 Fix substitutions being broken after freezing - actually store the original state in registry copies, not the computed state, which is wrong because it only sees the sub, not the original.
 - v8.99.1176 Revert "Another fix for registry substitutions. Closes #3212"
              This reverts commit ec2977afc919c0f676f59977e6065148ea635f9e.
 - v8.99.1175 @ObjectHolder will now inject null for dummied objects. Closes #3301
 - v8.99.1174 Allow all Forge Registries to work with ObjectHolder (#3220)
 - v8.99.1173 Revert commits related to filtering proxy and Automatic Subscriber annotations.
              Broke some existing setups, will require a annotation definition change in 1.11.
 - v8.99.1172 Fix proxy injector filtering. (#3300)
 - v8.99.1171 Bump version for new Recommended Build.
 - v8.99.1170 Introduce IContextSetter for events.
              This will set the active mod container for events using the normal EventBus.
              Fixes improper warnings from initializing mods using the new Registry events.
              Modders, you should not use this as it has many performance implementations
              and if abused will slow down the event bus A LOT. ActiveModContainer is not
              thread safe.
 - v8.99.1169 Filter out proxy injectors for incorrect mods.
              Prevents mod classes being initialized early when multiple mods are in the same source.
 - v8.99.1168 Small Cleanup in example build.gradle.
 - v8.99.1167 Fix unbound keybindings are activated by unknown keyboard keys (#3288)
 - v8.99.1166 caseSensitiveCustomCategories must be set before loading the configuration file. (#3269)
              Otherwise one set with categories in lowercase letters and on case sensitive
              set is generated.
 - v8.99.1165 Fix typo in sky rendering causing tons of BlockPos allocations (#3267)
 - v8.99.1164 Add in registry registration events, new subscription events you can use to make sure you're registering things at the "best" time.
 - v8.99.1163 Add support for generic filtering of events.
              Please DO NOT use this in performance sensitive environments where you will have tons of things added to the listener list.
              If that's the case define sub-classes as they have completely separate lists and will thus be more efficient when firing the event.
 - v8.99.1162 Fix roofed forests posting decoration events for small mushrooms rather than big (#3259)
 - v8.99.1161 Add support for offhand bow aiming animation (#3085)
              Vanilla allows you to use a bow in your offhand, but it's not visible to others or in third person.
              Fixes MC-88356
 - v8.99.1160 Remove oredict for Bone Block recipe, stop white dye to bonemeal exploit (#3255)
 - v8.99.1159 Fixed Biome.platFlower not being called when bonemealing grass. Closes #3254
 - v8.99.1158 Added getCommandMap() & getSortedCommandList() in CommandTreeBase (#3251)
 - v8.99.1157 New event to allow mutating a baby entity based on it's parents (#3227)
 - v8.99.1156 Added CommandTreeBase (#3193)
 - v8.99.1155 Fix debug command creating empty file (MC-103399) (#3218)
 - v8.99.1154 Fix universal bucket not being returned in crafting recipes (#3234)
 - v8.99.1153 Create EnergySystems.md
 - v8.99.1152 Fix potential shading issue in GuiEditArrayEntries. Closes #3247
 - v8.99.1151 Introducing a new standardized energy capability system.
              Heavily inspired by the old RedstoneFlux API developed by King Lemming and Team CoFH.
 - v8.99.1150 Fixed ItemStacks having ForgeCaps tag when no caps are serialized.
 - v8.99.1149 Fix Cactus being able top be planted on incorrect soil.
 - v8.99.1148 Fix wrong var being used during getMaxSpawnPackSize check. (#3240)
 - v8.99.1147 Move dismount version of EntityMountEvent to Entity class. Should fix canceling dismounting. Closes #3226
 - v8.99.1146 Yet another fix for stupid stairs. Closes #3224
 - v8.99.1145 Make StructureBlock TESRs always render. Closes #3222
 - v8.99.1144 Fix item use stats (#3216)
 - v8.99.1143 Fixed decorate event being called with SHROOM type for both convered trees and large mushrooms. Closes #3215
 - v8.99.1142 Another fix for registry substitutions. Closes #3212
 - v8.99.1141 Update gradle wrapper to 2.14, reference MC json, and add java6 compat lines to default MDK build.gradle.
 - v8.99.1140 Add legacy support for signature change of AddCallback.
 - v8.99.1139 Revert changes to ItemTool for binary compatibility (#3211)
 - v8.99.1138 Expand getHarvestLevel to include player and blockstate (#3192)
 - v8.99.1137 Make enchantment tables spawn particles for any custom energy provider. Closes #3208
 - v8.99.1136 Allow blocks to affect the beacon color (#3205)
 - v8.99.1135 Fix armors rendering badly. Closes #3196
 - v8.99.1134 Fixed NPE from missing Capabilities (#3191)
 - v8.99.1133 Fix World Capabilities NPE when there are no attached capabilities.
 - v8.99.1132 Introduced Capabilities for World (#3069)
 - v8.99.1131 Fix vanilla bug in BlockFalling that caused blocks to loose state info during world gen. Closes #3183
 - v8.99.1130 Added PlayerBrewedPotionEvent (#3187)
 - v8.99.1129 Don't crash if you select a fake player
 - v8.99.1128 Skip searching for mods in the JAVA_HOME directory. Closes #2249 and #2250
 - v8.99.1127 Fix leather armor overlay not rendering when armor is pure white. Closes #3184
 - v8.99.1126 Fix test mod IDs, names, and versions (#3122)
              Most of our test mods have bad IDs (uppercase) and are missing names or
              versions. Forge produces a bunch of warnings in the console about this, which
              makes it more likely that an important message will be missed.
 - v8.99.1125 Make InventoryHelper#spawnItemStack use ItemStack#splitStack to avoid losing capability data. (#3163)
 - v8.99.1124 Unlike BakedQuad, UnpackedBakedQuad does not propagate the diffuse lighting flag to Vertex Consumers. Made UnpackedBakedQuad conform to BakedQuad's behavior. (#3181)
 - v8.99.1123 Add RenderTooltipEvent (#3034)
 - v8.99.1122 Set ModelLoader.WHITE's texture size iniatlly instead of defaulting to zero and being set later.
 - v8.99.1121 Fix #3165 Dispensers with buckets can destroy fluid handler blocks (#3180)
 - v8.99.1120 Fix Fire not using getFireSpreadSpeed. Closes #3175
 - v8.99.1119 Fix issue with stairs.
 - v8.99.1118 Removed unintentional functionality when using the Splash Screen.
 - v8.99.1117 Disable DecorateEventDebug by default.
              Prevents me thinking that decoration is broken >.<
 - v8.99.1116 Compleetly skip FML handshake for Vanilla connections. Should fix race condition. Closes #3084
 - v8.99.1115 Fix name in legacy support in registry changes.
 - v8.99.1114 Make stair culling use actual state, and be more robust. Closes #3170
 - v8.99.1113 Fix Vertex Transformer for breaking models (#3132)
              * Add setTexture to IVertexConsumer and propagate it.
 - v8.99.1112 Fix Forge fluids not serializing properly. Closes #3152
 - v8.99.1111 Restone binary compatibility with registry substitution rework.
              Modders please switch to using the provided RegistryBuilder to ensure more forward compatbility. Closes #3144
 - v8.99.1110 Second pass at fixing 'Dissapearing Doors' This now more robustly fixes ALL uses of get and has slight performance improvements for itterable states. Closes #3139
 - v8.99.1109 Added config option to disable Forge's fix of Stair/Slab face culling.
              Some vanilla resource packs exploit this issue in their custom models causing unintended rendering issues.
 - v8.99.1108 Fixed 'Dissapearing Doors', An issue where the world would try to save blockstates that are not serializeable.
 - v8.99.1107 Allow CommandEvent to change the parameter set. Closes #1762
 - v8.99.1106 Another pass at substitutions - now capable of fixing up ItemBlock to point at the right block when a block is substituted, should also handle substituting itemblocks. There's some hackery in the way we have to change the value of ItemBlock.block, but it's not too egregious in my opinion.
 - v8.99.1105 Clean up AT file
 - v8.99.1104 Merge remote-tracking branch 'origin/pr/3120' into 1.10.x
 - v8.99.1103 Fix anvil output slots being wrong by adding new ones. Closes #3121 without breaking existing mod workarounds for the badly ordered slots.
 - v8.99.1102 Expose vanilla brewing recipe registration
              (cherry picked from commit 24bf163)
 - v8.99.1101 Clean up some legacy settings, making sure there's translation strings. Closes  #2965 Thanks for the prompt Zaggy!
 - v8.99.1100 Refresh patch after cherry pick (cherry picked from commit 71f75bf)
 - v8.99.1099 Fix MC-91728
              (cherry picked from commit 71f75bf)
 - v8.99.1098 Remove sideonly on all other SoundType methods
              (cherry picked from commit 46c7cac)
 - v8.99.1097 Fixed NeighborNotifyEvent not containing the piston facing direction.
              (cherry picked from commit 5637c41)
 - v8.99.1096 Use extended state for breaking models (#3086)
 - v8.99.1095 Clean up block patch. Also push json update.
 - v8.99.1094 Merge remote-tracking branch 'origin/pr/3116' into 1.10.x
 - v8.99.1093 Merge remote-tracking branch 'origin/pr/3089' into 1.10.x
 - v8.99.1092 Merge remote-tracking branch 'origin/pr/3125' into 1.10.x
 - v8.99.1091 Fix #3126 - duplicate stat id error - don't use the "universal iterators" in statbuilding, use the one without the duplicate entries. (The duplicate entry one is for rendering setup)
 - v8.99.1090 FIX : IndexOutOfBoundException
 - v8.99.1089 Tidy up some more todos
 - v8.99.1088 Mark it for actual removal in 1.11
 - v8.99.1087 Fix a vanilla bug with the blockstate ID map not being properly symmetric with respect to block.getStateFromMeta - closes #3012 properly but probably has a random MCJIRA ticket somewhere too.
 - v8.99.1086 Update decorate for biomes to support Decorate event
 - v8.99.1085 No-nonsense getSoundType
 - v8.99.1084 Merge remote-tracking branch 'origin/pr/3072' into 1.10.x
 - v8.99.1083 Merge remote-tracking branch 'origin/pr/3087' into 1.10.x
 - v8.99.1082 Rename the event to RenderSpecificHandEvent
 - v8.99.1081 Merge remote-tracking branch 'origin/pr/3115' into 1.10.x
 - v8.99.1080 Merge remote-tracking branch 'origin/pr/3110' into 1.10.x
 - v8.99.1079 Merge remote-tracking branch 'origin/pr/3112' into 1.10.x
 - v8.99.1078 Add shouldCauseBlockBreakReset callback to Item. This allows to keep breaking blocks if the NBT or similar changes.
 - v8.99.1077 Use CreateFluidSourceEvent for mod fluids as well
 - v8.99.1076 Add a test for CreateFluidSourceEvent
 - v8.99.1075 Add CreateFluidSourceEvent to control infinite fluid sources
 - v8.99.1074 Merge remote-tracking branch 'origin/pr/3055' into 1.10.x - closes #3055 and #3043 hopefully. Complex solution, but it seems legit. Needs testing.
 - v8.99.1073 Something that needs to happen: warn people about bad modids- if they're not lowercased, or if they're too long.
 - v8.99.1072 Add missing cancelable
 - v8.99.1071 Add hand-specific render event
 - v8.99.1070 Fix hotkey with default modifier loading wrong when modifier set to NONE
 - v8.99.1069 Fix async race condition on new chunks (closes #3020) (#3090)
              This patch fixes a race condition that sometimes caused a just generated chunk
              to be generated a second time.  In some this caused generated structures to
              appear incomplete such as in Issue #3020 when the second generated version
              effectively overwrote the original version of the chunk.
              This patch ensures when ProvideChunk calls LoadChunk synchronously we always
              attempt to load the chunk (if not cached) thus avoid the race condition without
              changing the logic for async loading for chunks already saved to disk.
              Thus this should retain the async functionality from PR #2946 while preventing
              generation issues caused by the race condition.
 - v8.99.1068 Some tweaks to ContainedDeps - it should extract to a file in versionedMods directly, even if the tag in the jar has a subpath element. It'll also skip if there is a matching filename in the main mods dir.
 - v8.99.1067 Add the new tests into the suite
 - v8.99.1066 Some dummy block replacement tests - it seems they work correctly.
 - v8.99.1065 Some more substitution tests. It seems like it's working as it should.
 - v8.99.1064 More tests. Substitutions now work, and a fix is included. *sigh* Closes too many bugs to count.
 - v8.99.1063 Some test harness stuffs. Time to get the registry manager properly tested.
 - v8.99.1062 Add TextureDump forge test mod
 - v8.99.1061 Added support for using static methods as event listeners, Register the .class instead of an instance.
              And added an improvement to calltime listener rebuilding.
 - v8.99.1060 Fixed sound paused/resume issue
 - v8.99.1059 Force mipmap even if textures are the wrong size
 - v8.99.1058 Lets make a half-decent readme. Thanks to Rorax for the install video!
 - v8.99.1057 Merge remote-tracking branch 'origin/pr/3036' into 1.10.x Closes #3036 Thanks Mezz!
 - v8.99.1056 Bump version for a RB
 - v8.99.1055 Merge #3060 into 1.10.x
 - v8.99.1054 Remove event stuff
 - v8.99.1053 Move to a hook in EntityMinecart
 - v8.99.1052 Add throwable impact event (#3071)
 - v8.99.1051 Add ability for custom detector rail output
 - v8.99.1050 Update build.gradle to not append the branch name if it matches the minecraft version.
 - v8.99.1049 Fix hopper extract behavior being broken on edge cases due to IItemHandler capability. Closes #3062
 - v8.99.1048 Add an event that allows to modify the looting level based on damage source
 - v8.99.1047 Fixed FPS graph and new debug lines not being rendered in Debug screen. Closes #3054
 - v8.99.1046 Restore (buggy?) behavior of vanilla BlockPistonMoving and ignore drop chance (#3052)
 - v8.99.1045 Fix villages generating to high when using a cusom sea level. Closes #3050
 - v8.99.1044 Update build.gradle to have single line for specifying minecraft version, and will update ForgeVersion.java as needed.
 - v8.99.1043 Forge will now load extra mods from mods/mod_list.json and mods/mc_version/mod_list.json.
              As defined by the same json spec as --modListFile.
              And now if repositoryRoot is prefixed with absolute: the path will NOT be relative to the MC directory.
 - v8.99.1042 Store member field mappings in the mapping table, possible fix for #3043
 - v8.99.1041 Fixed MC version number...
              I could of SWORN we removed this in favor of a automated system...
 - v8.99.1040 1.10.2 Update
 - v8.99.1039 Fix mob-spawners crashing for non-living entities and simply the patch in the process (#3042)
 - v8.99.1038 Fix milk bucket is fillable with water or lava when milk is unregistered (#3039)
 - v8.99.1037 Fix legacy handling for ItemBucket subclasses and non-universal buckets (#3038)
 - v8.99.1036 Fix FluidContainerRegistry handling potions as water bottles (#3037)
 - v8.99.1035 Remove duplicated universal buckets from the creative list (#3035)
 - v8.99.1034 Big warning for recipe types found without being registered, it turns out this is pretty severe, modders need to fix it.
 - v8.99.1033 Add Forge fluid handler test
 - v8.99.1032 Fix comparison stability of the Recipe Sorter with unknown recipes #2962 (#3030)
 - v8.99.1031 Fixed Husks rendering as standard zombies. Closes #3028
 - v8.99.1030 Fixed chests being replaced when trees grew.
 - v8.99.1029 Simple implementation of a Open/Close container event (#3017)
 - v8.99.1028 Provide 'cleaner' version of TextureMap.setTextureEntry. Closes #1385
 - v8.99.1027 Fix incorrect logic in ChunkCache.isSideSolid. Closes #3026
 - v8.99.1026 Fixed incorrect variable being sent to doSpecialSpawn. Closes #2986
 - v8.99.1025 Fixed shifted patch in GameSettings causing settings to not load properly. Closes #3025 #3022
 - v8.99.1024 Fix doors popping off solid sides.
 - v8.99.1023 Fix that the Missing blocks/items/registries prompt often got stuck.
 - v8.99.1022 Fix Realms button text to be shorter again. Closes #3019
 - v8.99.1021 Fix item pickup dupe bugs. Closes #3015
 - v8.99.1020 [1.10] Fix keys with KeyModifier failing to load (#3018)
              Fix key options with KeyModifier failing to load due to NumberFormatException
 - v8.99.1019 Accept more 1.9.4 version strings. Fix NPE for custom villager types and their associated zombie spawns. Still needs review.
 - v8.99.1018 Fix all guis closing as soon as they are opened (#3013)
 - v8.99.1017 Fix version number.
 - v8.99.1016 Update to 1.10
 - v8.99.1015 Fix the MDK - it gets the license too!
 - v8.99.1014 Update the build.gradle script to ship the new license and stop shipping the old licenses.
 - v8.99.1013 In accordance with our stated goal of relicensing Forge to LGPL v2.1, this commit enacts that change. Although it is using the 1.9.4 codebase, it is intended that this branch become public with the 1.10 changes, as such the license will take effect at that time. The three commits from persons who have failed to accept the new license, as documented in #2789, have had their commits reverted. This should complete the license transition. Commits after the commit date of this commit should be considered licensed by LGPLv2.1, as indicated in LICENSE-new.txt. All patches are now considered owned by the Forge project and Forge Development LLC in particular (note that they will not get the license boilerplate, as they are machine generated files).
 - v8.99.1012 Revert "Added PlayerOpenContainerEvent and added ForgeHooks.canInteractWith"
              This reverts commit 8d0b58ee6fe1dca88f5874a9dd08368b0f5859e6.
              # Conflicts:
              #	common/net/minecraftforge/common/ForgeHooks.java
              #	patches/minecraft/net/minecraft/entity/player/EntityPlayer.java.patch
              #	patches/minecraft/net/minecraft/entity/player/EntityPlayerMP.java.patch
 - v8.99.1011 Revert "Added tab completion"
              This reverts commit fe327fbd7662e0a1e71b89125f0a94ae48239bd0.
              # Conflicts:
              #	src/main/java/net/minecraftforge/server/command/ForgeCommand.java
 - v8.99.1010 Revert "Changed forge command tab completion to use getListOfStringsMatchingLastWord()"
              This reverts commit 6a299a483a4865e13cd61e5d900a9e0c004a9226.
              # Conflicts:
              #	src/main/java/net/minecraftforge/server/command/ForgeCommand.java
 - v8.99.1009 Made forge-type spawn eggs spawn childs, when right clicking EntityAgeable again. (#2982)
 - v8.99.1008 Merge remote-tracking branch 'origin/pr/2994'
              # Conflicts:
              #	patches/minecraft/net/minecraft/item/ItemStack.java.patch
 - v8.99.1007 Make ASMDataTable more useful: (#2911)
              - EnumHolder now has getters for it's data
              - enum arrays work now
              - nested annotations work now outside of being in arrays
              (cherry picked from commit f10f750)
 - v8.99.1006 Fix incorrect FluidUtil doc (#2996)
 - v8.99.1005 Improve the "missing mods" on-screen error message (#2997)
 - v8.99.1004 Fix ItemStack deserialization can't clear nbt (#3005)
 - v8.99.1003 Update CONTRIBUTING.md
 - v8.99.1002 Update CONTRIBUTING.md
 - v8.99.1001 Fix #2918 Make dispensers with buckets work with modded fluids (#2947)
 - v8.99.1000 Fixed brewing stand returning incorrect solts for side inventories.
 - v8.99.999  Fixed villager career display names being off by one.
 - v8.99.998  Fix broken EntityItem merging for Items with capabilities
 - v8.99.997  Fix DataParameter mixup when vanilla clients are connected causing CCE in zombie renderer (#2992)
 - v8.99.996  Fix AnimationItemOverrideList not falling back to super (#2990)
 - v8.99.995  Fix #2961 Capability data is not preserved by fluid handler interactions (#2976)
 - v8.99.994  Slight tweak to early loading, to accommodate FMP
 - v8.99.993  Fixed Fernflower decompile issue in AnvilChunkLoader.saveExtraData() Closes #2985
 - v8.99.992  Mute the connection reset by peer exception - it's spamilicious for the most part.
 - v8.99.991  Fix missing IMC message query.
 - v8.99.990  Read a Update JSON in UTF-8 (#2978)
 - v8.99.989  Add getter for the world to LootContext (#2954)
 - v8.99.988  Fixed arrows not showing in non default AchievementPages (#2968)
 - v8.99.987  Add methods to Fluid to allow custom vaporization overrides (#2959)
 - v8.99.986  Fixes #1984.
 - v8.99.985  Modified SimpleModelState to ignore the parts it doesn't know about. Fixes model part hiding always applying to some models when transformations are specified in the blockstate json.
 - v8.99.984  Pass the GL context back from the splash screen during the EntityRenderer init.
 - v8.99.983  Fire ChunkWatchEvent.Watch event, closes #2767. Based on @sfPlayer1 patch suggestion. It looks like this logic has shifted relative to 1.8, so there may be differences in event behaviour now.
 - v8.99.982  Fix asynchronous chunk loading (#2946)
              Since the update to Minecraft 1.9.4 chunks were actually never loaded
              asynchronously because a sync request was always made from the
              PlayerChunkMap shortly after the chunk had been queued.
              - PlayerChunkMapEntry now only loads chunks synchronously *after* the
                chunk failed to load asynchronously.
              - Fixed some minor bugs that caused "Attempted to dequeue chunk" messages
              - Simplified ChunkProviderServer patch. loadChunk no longer generates chunks,
                so there is no need to handle that.
              - Moved loader and provider to ChunkIOProvider so there is no need for
                "hashCode abuse"
 - v8.99.981  Make it easier to use FluidTanks that have input/output restrictions (#2945)
              These internal function should NOT be used by anything except the owner of the tank.
 - v8.99.980  Fixed BiomeProvider.getModdedBiomeGenerators method name. Closes #2937
 - v8.99.979  Several bugfixes for PlayerInteractEvent (#2943)
              * Don't change Result if setCanceled(false) called
              * Fix RightClickEmpty firing even when targeting a block or entity
              * Add a left click empty event
              * Move hook point for EntityInteractSpecific to the right place
              * Fix LeftClickBlock not firing clientside in creative, and clarify docs about creative
 - v8.99.978  Add new IFluidHandler for capabilities. (#2942)
              Old fluid system is deprecated and slated for removal in the next cleanup cycle.
 - v8.99.977  Add a Slot#isSameInventory() method (#2884)
              This fixes shift + double clicking items in Containers that use
              SlotItemHandler slots.
 - v8.99.976  Fixed POTENTIAL issue where mods would query world infrom from TEs before they are set. Closes #2863
 - v8.99.975  Expanded custom villagers to Zombies and world gen.
              Fixed edge cases where custom professiosn wernt being used correctly. Closes #2862
 - v8.99.974  Fixed client side ticking TileEntites after they are unloaded. Closes #2852
 - v8.99.973  Fixed position sent to sanSustainPlant from cactus. Closes #2941
 - v8.99.972  Forge will now warn the user and ask permission to load a world with unknown registries. Closes #2934
 - v8.99.971  Fix BlockFluidBase having collision. Closes #2932
 - v8.99.970  Merge branch '1.9.4'
 - v8.99.969  Initial support for model visibility system. Implemented it for OBJ, B3D and normal vanilla models; fixed NPE accessing parent state in B3DModel. Fixes #2801.
 - v8.99.968  Improve JavaDoc links, fix some broken JavaDocs (#2833)
              Improve JavaDoc links, fix broken JavaDocs
 - v8.99.967  Reordered transformations during LayerHeldItem rendering, fixes #2827.
 - v8.99.966  Fixed new ICrashReportDetail loader working with packaged mods by delaying it until the ModContainer's construct event. Closes #2924
 - v8.99.965  Fixed issue with @ObjectHolder and the new registry system. Closes #2640
              Only run static initalizers for classes we need to get the names from values.
 - v8.99.964  Fixed village wells not having their biomes set. Closes #2499
 - v8.99.963  Fixed TileEntityBeacon not using position-aware getLightOpacity. Closes #2530 and #2910
 - v8.99.962  Fixed potential issue with Chunk.getLightOpacity being called before the chunk is added to the world map. Closes #2529
 - v8.99.961  Fixed FluidUtil.tryEmptyFluidContainerItem not checking if the tank can accept fluids first. Closes #2527
 - v8.99.960  Make sure tool-classes for vanilla tools are initialized early. Closes #2909 and #2525
 - v8.99.959  Fix tooltip for survival tab in the creative menu not drawing on any but the first page. Closes #2908 and #2504
 - v8.99.958  Fix Thorns enchantment bypassing ISpecialArmor.damageArmor function. Closes #2463
 - v8.99.957  Reinitalize statistics information on Mapping changes.
              Fixes mismatched stats to item/block ids. And auto registers stats for modded items.
              Closes #2454
 - v8.99.956  Fixed NBTTagString.toString not properly escaping \'s. Closes #2393
 - v8.99.955  Add ServerHangWatchdog to TerminalTransformer whitelist. Closes #2203
 - v8.99.954  Fix setTileEntity causing the world to remove the new and old tile entities. Closes #2164
 - v8.99.953  Fixed EntityRegistry.addSpawn adding duplicate spawn entries. Closes #2112
 - v8.99.952  Fix javadocs for BiomeColor events. Closes #2093
 - v8.99.951  Fire LivingSpawnEvents for MobSpawners. Closes #2079
 - v8.99.950  Fire PopulateChunkEvent Pre and Post in ChunkProviderFlat. Closes #2050
 - v8.99.949  Move getArmorModel hook up two lines so that the attributes and animation information is set. Closes #1939
 - v8.99.948  Close player's inventory to prevent potential dupe issues on some modded items. Closes #1431
 - v8.99.947  More uniformly apply Configuration.caseSensitiveCustomCategories. Closes #1353
 - v8.99.946  Set Enchantment table's harvest level. Closes #1349
 - v8.99.945  Capture interfaces when scanning classes and preload implementations of ICrashReportDetail.
 - v8.99.944  Fix installer downloading vanilla jar when not needed. And filter some more known libraries.
 - v8.99.943  Strip Optional from the class signature as well, since that's loaded by the TypeToken registry code and might cause a crash.
 - v8.99.942  Pass the correct position into isSideSolid in BlockRailBase#canPlaceBlockAt (#2919)
 - v8.99.941  Add hook for TE data sync on client (#2893)
 - v8.99.940  Switch new constructor to use floats (#2904)
 - v8.99.939  Make unit test for EnumHelper more robust and less spammy. Now detects missing accessors as well.
 - v8.99.938  Fix paramters for addArmorMaterial, addOption and addGameType.
 - v8.99.937  Add Unit Test to detect mismatches between EnumHelper and Enum ctor
 - v8.99.936  Add alternative ItemAxe Constructor
 - v8.99.935  Fix villagers having farmer skin on vanilla servers. Closes #2894
 - v8.99.934  Fire playerDestroyItem event's in some cases where we were not.
 - v8.99.933  Fix Container.compouteStackSize not respecting stack version of maxStackSize. Closes #2756
 - v8.99.932  Set max enchantment ID to Short.MAX_VALUE. Closes #2799
 - v8.99.931  Tipped arrows are now not affected by infinite enchantment but are still effected by creative mode.
 - v8.99.930  Take capabilities into account when comparing ItemStack NBT's. Closes #2726
 - v8.99.929  Fix screenshot link paths on Windows (#2886)
 - v8.99.928  Tweak build file slightly - allow passing buildNumber using gradle parameters (-PbuildNumber=...) and provide a "resetBuildNumber" function to reset the buildNumber to zero in the ForgeVersion file. Means builds can be reproducible in-IDE.
 - v8.99.927  Add Unit Test to detect mismatches between EnumHelper and Enum ctor
 - v8.99.926  Update example mod for new mappings.
 - v8.99.925  Bump version information for 1.9.4.
 - v8.99.924  Fix schizophrenia in version numbers.
 - v8.99.923  Update mappoings snapshot to 20160518
 - v8.99.922  1.9.4 Update.
              Major things to note:
              Class renames: https://gist.github.com/LexManos/44dd211f90f498ad4015279b103dff86
              Tile Entities are now packed in the ChunkData packet.
              Forge intends to work around this to better support large moded worlds, but for the time being modders should implement the new function carefully and only send what data they need to!
              Minecraft's codebase now has annotations, these are directly from Mojang and should be adheared to!
              Added support for package-info.java's containing @Nullable information for all MC code base.
 - v8.99.921  Fix Bucket rendering and add sound (#2865)
              * Adjust generated quads from texture to take texture size into account #2858
              *  Fix universal bucket not passing through when rightclicking on a non-block
              Add proper sound events when picking up modded fluids #2821
              * Have FluidUtil execute properly on both sides and sync as expected. Add default sounds to interacting with tanks
              * Save sound for filling/emptying in the fluid
 - v8.99.920  Lets just simply this. Fixes last commit.
 - v8.99.919  Add modder facing API for Villager Career level trades. Ref: #2854
 - v8.99.918  Extended Animation State Machine format to allow multiple transitions from one state.
 - v8.99.917  Fix up release jsons to clean up extraneous netty references
 - v8.99.916  Make LootPool constructor public again. Closes #2847
 - v8.99.915  Fix type in LootEntry json name. And rename LootTable.finalize to freeze to avoid overriding Object function. Closes #2846 and #2847
 - v8.99.914  Fixed joint animation application correctly.
 - v8.99.913  Add ScreenshotEvent (#2828)
              Add ScreenshotEvent
 - v8.99.912  New LootTable interaction system and event.
              Modders can now modify and reference internal elements of a loot table by name.
              Editing can ONLY be done in the event and any external editing will cause a exception to be thrown.
              See this gist for more information: https://gist.github.com/LexManos/77c983d67b9ad27010428478b66d50fd
 - v8.99.911  Fixed joint hierarchy not being used fully in the animation system.
 - v8.99.910  Fixed issue in ChunkIO that would potentially cause NPEs on chunks. Closes #2837
 - v8.99.909  Fixed map extension recipie.
 - v8.99.908  Fix the rand given to PopulateChunkEvent (#2834)
 - v8.99.907  Fix areas where dimension types are used as dimension IDs.
 - v8.99.906  Add NPE protection to in-hand item rendering.
 - v8.99.905  Fix url regex (#2815)
              Fixed url detection in chat messages. Stops false positives such as `um.....no`
 - v8.99.904  Bump version for new RB.
 - v8.99.903  Slightly better practice because wait can be randomly interupted.
 - v8.99.902  Merge in a fix from 1.8.9 for rails
 - v8.99.901  Merge branch '1.9'
 - v8.99.900  Remove usage of AsynchronousExecutor library in favor or a simpler implementation.
 - v8.99.899  Add a java version detection and nag system for users on Java 7 or below.
              Added detection of mods that rely on Java 8 and a graceful error screen.
              The nag screen will be shown once a day. It can be disabled by editing the forge.cfg.
              However it is HIGHLY recomended that user update to Java 8.
 - v8.99.898  Fix withers breaking bedrock. Closes #2813
 - v8.99.897  Fixed villager profession not being set correctly on the client, and fixed custom village texture rendering. Closes #2766.
 - v8.99.896  Fixed cooldown overlay sometimes rendering opaque. Closes #2772.
 - v8.99.895  Make ChunkRenderDispatcher.countRenderBuilders configurable. Closes #2775.
 - v8.99.894  Fixed custom fluid sufraces not rendering from the bottom. Closes #2800.
 - v8.99.893  Fix TextureMap failing when registering a sprite's resource location twice (#2785)
 - v8.99.892  Call markDirty when restoring blocks with TileEntities. (#2809)
              This change makes sure the updated tileentity is saved properly within the
              chunk.
 - v8.99.891  Call markDirty when restoring blocks with TileEntities. (#2808)
              This change makes sure the updated tileentity is saved properly within the
              chunk.
 - v8.99.890  Call markDirty when restoring blocks with TileEntities. (#2807)
              This change makes sure the updated tileentity is saved properly within the
              chunk.
 - v8.99.889  Add Potion.renderHUDEffect (#2798)
 - v8.99.888  Fix wrong blockstate being passed to notifyNeighborsRespectDebug. (#2806)
 - v8.99.887  Only run block physics for TileEntities while capturing block placement. (#2805)
              Currently, all blocks placed by players that are not TE's run physics
              twice. Blocks that contain a TileEntity are not affected due to a check in
              'ForgeHooks.onPlaceItemIntoWorld'.
              In order to fix the problem, 'Chunk.setBlockState' will now verify if
              blocks are being captured before running onBlockAdded and if so, only run
              physics if the block has a tileentity. This check also prevents blocks
              such as TNT's from running its physics (explosion) when placement event is
              cancelled.
 - v8.99.886  Only run block physics for TileEntities while capturing block placement. (#2803)
              Currently, all blocks placed by players that are not TE's run physics
              twice. Blocks that contain a TileEntity are not affected due to a check in
              'ForgeHooks.onPlaceItemIntoWorld'.
              In order to fix the problem, 'Chunk.setBlockState' will now verify if
              blocks are being captured before running onBlockAdded and if so, only run
              physics if the block has a tileentity. This check also prevents blocks such
              as TNT's from running its physics (explosion) when event is cancelled.
 - v8.99.885  Fix sluggish scrolling on GuiScrollList's and fix small rendering issue with scroll bar on certian screen sizes.
 - v8.99.884  Fix SidedInvWrapper accessing wrong slots for setStackInSlot. (#2797)
              Fix DoubleChestItemHandler not implementing IItemHandlerModifiable
 - v8.99.883  Close #2780 add CMD localization for Mac key bindings (#2792)
 - v8.99.882  Update LICENSE-new.txt
              Better words
 - v8.99.881  Update LICENSE-new.txt
              Words
 - v8.99.880  Update LICENSE-new.txt
              Clarification on infectivity
 - v8.99.879  Add the new license text. Not yet applicable to forge.
 - v8.99.878  Fix NPE on shield break. Closes #2786
 - v8.99.877  Boss bar render event (#2701)
              Allow control over increment height
 - v8.99.876  Fix forge:default-block transformation. (#2760)
              The first-person left-hand rotation was a little bit of.
 - v8.99.875  Expose a central place to access all of Vanilla and Forge's registries using the new registry API.
 - v8.99.874  Fix log spam from invalid key modifiers (#2746)
 - v8.99.873  make WorldSavedData implement NBTSerializable (#2745)
 - v8.99.872  Don't use import static with net.minecraft classes. Using the latest MCP snapshots this causes an import conflict. (#2742)
 - v8.99.871  Add cancelable event for Potions shifting the gui position (#2667)
              Add cancelable event for Potions shifting the gui position
 - v8.99.870  Fix ForgeChunkManager world unloading check (#2736)
 - v8.99.869  Fix being kicked from server when climbing ladders.
 - v8.99.868  Fix potential desync between Forge's Villager profession and vanilla's int based system.
 - v8.99.867  Update ore dictionary (#2721)
              Updated the Ore Dictionary with more vanilla items:
                -Prismarine Shard ( "gemPrismarine" )
                -Prismarine Crystals ( "dustPrismarine" )
                -Prismarine Block ( "blockPrismarine" )
                -Prismarine Brick ( "blockPrismarineBrick" )
                -Dark Prismarine ( "blockDarkPrismarine" )
                -Nether Wart ( "cropNetherWart" )
                -Sugarcane ( "sugarcane" )
                -Paper ( "paper" )
                -Ender Pearl ( "enderpearl" )
                -Bone ( "bone)
                -Gunpowder ( "gunpowder)
                -String ( "string" )
                -Nether Star ( "netherStar" )
                -Leather ( "leather" )
                -Feather ( "feather" )
                -Egg ( "egg" )
                -End Stone ( "endstone" )
                -Torch ( "torch" )
                -Vine ( "vine" )
                -Cactus ( "blockCactus" )
                -Grass ( "grass")
                -Obsidian ( "obsidian" )
                -Red Sandstone ( added to "sandstone" )
                -Crafting Table ( "workbench" )
                -Slime Block ( "blockSlime" )
                -Granite ( "stoneGranite" )
                -Polished Granite ( "stoneGranitePolished" )
                -Diorite ( "stoneDiorite" )
                -Polished Diorite ( "stoneDioritePolished" )
                -Andesite ( "stoneAndesite" )
                -Polished Andesite ( "stoneAndesitePolished" )
 - v8.99.866  Merge pull request #2729 from kashike/feature/bossinfo
              Remove @SideOnly(Side.CLIENT) from BossInfo/BossInfoServer methods
 - v8.99.865  Remove @SideOnly(Side.CLIENT) from BossInfo/BossInfoServer methods
              These methods can also be used by the server (see BossInfoServer, it sends packets to the client but the methods are @SideOnly(Side.CLIENT))
 - v8.99.864  Made forge fluids use smooth lighting.
 - v8.99.863  Fixed NPE in dedicated server languages. And fixed logger for main FML event bus.
 - v8.99.862  Cleanup OBJLoader parse function and fix issues related to JVM differences.
              Also fix support for sopme of the spec that was partially respected.
 - v8.99.861  Enhance some error logging related to OBJLoader issues, and RegistryEntries.
 - v8.99.860  Merge pull request #2723 from mezz/pick-fix
              Fix some plain keybinds not working when a modifier is active
 - v8.99.859  Fix some plain keybinds not working when a modifier is active
 - v8.99.858  Merge pull request #2719 from mezz/pick-fix
              Fix #2717 Pick block hotkey not working in inventories
 - v8.99.857  Fix #2717 Pick block hotkey not working in inventories
 - v8.99.856  Merge pull request #2718 from nekosune/patch-1
              Corrected CapabilityItemHandler.readNBT ignoring anything in slot 0 in 1.9
 - v8.99.855  Corrected CapabilityItemHandler.readNBT ignoring anything in slot 0 in 1.9
 - v8.99.854  Merge pull request #2714 from nekosune/patch-1
              Corrected CapabilityItemHandler.readNBT ignoring anything in slot 0
 - v8.99.853  Corrected readNBT ignoring anything in slot 0
 - v8.99.852  Fixed forge fluid having a collision box.
 - v8.99.851  Fixed zip being closed too early in the server language loading.
 - v8.99.850  Merge pull request #2709 from iTitus/bucketModel
              Fix dynbucket item transformation.
 - v8.99.849  Fix dynbucket item transformation.
 - v8.99.848  Fixed some test mods not being marked as client-only.
 - v8.99.847  Fixed mod languages not being loaded on the server.
 - v8.99.846  Merge pull request #2708 from Zaggy1024/1.9
              Fix PlaySoundEvent replacing a sound with PositionedSound causing an NPE.
 - v8.99.845  Fixed using PlaySoundEvent to replace a sound with a PositionedSound causing an NPE due to the Sound field not being set by a call to ISound.createAccessor(SoundHandler).
 - v8.99.844  Merge pull request #2707 from mezz/keyBinding19-4
              Add modifier support to vanilla keybindings.
 - v8.99.843  Merge pull request #2604 from williewillus/pie
              New PlayerInteractEvent for 1.9
 - v8.99.842  Player Interact Event
 - v8.99.841  Add modifier support to vanilla keybindings.
              Add Orange conflict color for modifier/key conflicts
              (like Ctrl and Ctrl-Z conflicting)
              Related to #2692
 - v8.99.840  Merge pull request #2704 from AEnterprise/1.9
              onBlockHarvested is no longer called twice
 - v8.99.839  Fix improper logic in ItemHandlerHelper.giveItemToPlayer causing some items to not be added. Closes #2705
 - v8.99.838  Fixed EntityJoinWorldEvent not being fired for some entitites on Server Worlds. Closes #2685
 - v8.99.837  Fix issue caused by setting spawnRadius to 0. Closes #2624
 - v8.99.836  Made both exceptions occuring during item model loading print in the log; closes #2696.
 - v8.99.835  Added the ability to change the printed model error count; Added printing of actual exceptions causing missing variants related to blockstate loading, closes #2689.
 - v8.99.834  onBlockHarvested is no longer called twice
 - v8.99.833  Merge pull request #2702 from McJty/1.9
              Added DimensionManager.createProviderFor() to WorldClient constructor…
 - v8.99.832  Added DimensionManager.createProviderFor() to WorldClient constructor similar to what is done
              in WorldServer to make sure the correct provider is created client-side too.
 - v8.99.831  Merge pull request #2616 from iTitus/updateNotificationIcon
              Add update notification icon made by @gigaherz, closes #2582
 - v8.99.830  Merge pull request #2697 from mezz/keyBinding19-3
              Fix inability to attack while holding modifier keys
 - v8.99.829  Fix inability to attack while holding modifier keys
 - v8.99.828  Merge pull request #2695 from mezz/keyBinding19-2
              Re-Add key binding modifiers and contexts.
 - v8.99.827  Re-Add key binding modifiers and contexts.
 - v8.99.826  Revert "Add key binding modifiers and contexts.", until it's fixed.
              This reverts commit 34c3af7e853d578c8e17e1f0cdf886251fad74ae.
 - v8.99.825  Changed generic signature of GameRegistry.register methods to work around the type inference bug; updated all example mods to the new block/item registration method.
 - v8.99.824  Merge pull request #2693 from Adubbz/1.9
              Fixed mismatched registry names and mod ids
 - v8.99.823  Merge pull request #2692 from mezz/keyBinding19
              [1.9] Add key binding modifiers and contexts.
 - v8.99.822  Properly deprecate and link the replacement methods in GameRegistry. Add helper method for registering a block with default ItemBlock because people keep complaining -.-
 - v8.99.821  Fixed mismatch registry names and mod ids
 - v8.99.820  Add key binding modifiers and contexts.
              Same as #2674, but for Minecraft 1.9
 - v8.99.819  Fixed compile error in registry code with Eclipse.
 - v8.99.818  Capture a vanilla freeze - will be used when FML connects to vanilla servers, soon
 - v8.99.817  Support ResLocations for IMC
 - v8.99.816  Improved UV offset hackery - should fix most visible custom model seams.
 - v8.99.815  MinecraftForge-2684 [1.9] New Registry ignores keys
 - v8.99.814  MinecraftForge-2683 InvocationTargetException for Forge 1820 for 1.9
 - v8.99.813  Add registries for soundevents, enchantments and potiontypes
              MinecraftForge-2576 [1.9] SoundEvents (and Enchantments and PotionTypes) need a FML registry
 - v8.99.812  Reconcile Block.patch
 - v8.99.811  Squashed commit of the following:
              commit b3b290aec9d3010a134859da6001ea28a96c2fdc
              Merge: c6ce6a0 d803f7d
              Author: cpw <cpw@weeksfamily.ca>
              Date:   Fri Mar 25 13:28:04 2016 -0400
                  Merge branch 'RegistryRework' of https://github.com/LexManos/MinecraftForge into LexManos-RegistryRework
                  Implement proper registry slaves. Should help with rollback related issues.
                  Missing patch
              commit d803f7db76f65db9d27302c9804a643bc853dc22
              Author: LexManos <LexManos@gmail.com>
              Date:   Tue Mar 22 03:36:14 2016 -0700
                  Update VillagerRegistry and use it. Should in theory make custom villagers work now. Using string version instead of int id for networking.
              commit eb5e5b4b42fdca26d2a104e4dc1e6a3ea3051a7b
              Author: LexManos <LexManos@gmail.com>
              Date:   Tue Mar 22 02:14:16 2016 -0700
                  More cleanup.
              commit edbc56b2ff314629d0e402709f3cf29fc79c4a3d
              Author: LexManos <LexManos@gmail.com>
              Date:   Tue Mar 22 02:05:23 2016 -0700
                  More cleanups, removed deprecated UniqueIdentifier {ResourceLocation now}
              commit e2df8d1be3c97601508f83dc97b0e8853fa1e271
              Author: LexManos <LexManos@gmail.com>
              Date:   Tue Mar 22 01:29:19 2016 -0700
                  Stupid generics....
              commit 46d57dc4677fa5ff3923e64eaccfb33d7e5aad8d
              Author: LexManos <LexManos@gmail.com>
              Date:   Tue Mar 22 01:00:25 2016 -0700
                  Some registry tweaking to provde a non-complicated API modders can use.
 - v8.99.810  Fix remapped blocks being overriden with dummy air blocks. Closes #2491
 - v8.99.809  Merge pull request #2679 from tterrag1098/render_in_layer_state
              Add state param to Block.canRenderInLayer
 - v8.99.808  Add state param to canRenderInLayer
 - v8.99.807  Merge pull request #2678 from shadowfacts/BlockAddInfo-19
              Forward ItemBlock#addInformation to Block#addInformation
 - v8.99.806  Forward ItemBlock#addInformation to Block#addInformation
 - v8.99.805  Merge pull request #2659 from kashike/feature/immutable-blockpos
              Replace Forge's getImmutable method with the vanilla method
 - v8.99.804  Merge pull request #2664 from gigaherz/capability-storage
              Make access to the Capability IStorage less annoying
 - v8.99.803  Fix landing particles not showing up. Cloes #2661
 - v8.99.802  Make NoteBlockEvent raw constructor protected to allow subclasses. Closes #2153
 - v8.99.801  Fix bows not animating properly when picking up ammo while using. Closes #2672
 - v8.99.800  Fix shrubs not generating correctly. Closes #2663
 - v8.99.799  Fix EntityPlayer still running old armor logic. Closes #2670
 - v8.99.798  Merge pull request #2634 from mezz/null-pick
              Fix Block.getPickBlock returning an ItemStack with a null Item
 - v8.99.797  Fixed StackOverflow caused by the previous commit, closes #2669.
 - v8.99.796  Prevent missing model from loading multiple times.
 - v8.99.795  Fix Block.getPickBlock returning an ItemStack with a null Item
 - v8.99.794  Add wrapper methods for IStorage#readNBT/writeNBT.
 - v8.99.793  Replace Forge's `BlockPos#getImmutable` method with the included `BlockPos#toImmutable` (func_185334_h), while keeping the override in PooledMutableBlockPos to prevent mutable leaks.
              Also prevent a mutable blockpos leak in World#setTileEntity
 - v8.99.792  Fixed crosshair always being white, closes #2653.
 - v8.99.791  Enabled diffuse lighting by default in UnpackedBakedQuad.Builder.
 - v8.99.790  Fixed diffuse lighting not being applied if forge lighting pipeline is disabled, closes #2651
 - v8.99.789  Merge pull request #2650 from mezz/1.9
              Make tooltips layout in the right direction, wrap if there is no room
 - v8.99.788  Make tooltips layout in the right direction, wrap if there is no room
              Same as #2649, but for Minecraft 1.9
 - v8.99.787  Merge pull request #2649 from mezz/tooltips
              Make tooltips layout in the right direction, wrap if there is no room
 - v8.99.786  Make tooltips layout in the right direction, wrap if there is no room
              Fixes #2255
 - v8.99.785  Disabled erroring block, fixed DynBucketTest.TestItem model.
 - v8.99.784  Merge pull request #2645 from diesieben07/populate_event
              Fix PopulateChunkEvent.Post not firing.
 - v8.99.783  Made some more public fields either private or final.
 - v8.99.782  Removed RenderWorldEvent, encapsulated all public event fields.
 - v8.99.781  Removed LanguageRegistry and CollectionWrapperFactory.
 - v8.99.780  Fixed isSideSolid causing infinite loops due to the call to getActualState.
 - v8.99.779  Cleanup: removed IEEP, removed redundant casts, fixed imports, fixed typos.
 - v8.99.778  New Builder class in BlockStateContainer. Makes building containers with both listed and unlisted properties cleaner.
              Make all methods of BiomeGenBase$BiomeProperties public so that modders can use that class outside subclasses.
 - v8.99.777  Fix PopulateChunkEvent.Post not firing
 - v8.99.776  Merge pull request #2643 from diesieben07/beetroots
              Fix BlockCrops.getDrops not respecting new age methods (for beetroots)
 - v8.99.775  Fix BlockCrops.getDrops not respecting new age methods (for beetroots)
 - v8.99.774  Add flashing update notification icon made by @gigaherz, closes #2582
              It is added to the "Mods" button in the main menu and to out-of-date mods in the mod list (there it replaces the "U").
              Also fixes a little typo.
 - v8.99.773  Register the animation Capability. No idea how it worked before at some point.
 - v8.99.772  Show meaningful error if ModelLoaderRegistry is used before the missing model is initialized.
 - v8.99.771  Fix typo causing biomes to be generated in wrong chunks. Closes #2632
 - v8.99.770  Fixed custom entities unique ids.
 - v8.99.769  Update FML Entity Spawn packet for 1.9's location change. Closes #2567
 - v8.99.768  Merge pull request #2622 from williewillus/dupedropfix2
              Actually fix dupe drop
 - v8.99.767  Added Capability.cast, to allow avoiding unchecked casts in ICapabilityProvider.getCapability
 - v8.99.766  Fix swap animations for sure this time.
 - v8.99.765  Actually fix dupe drop
 - v8.99.764  Make OreDictionary.initVanillaEntries() private so that dumb modders will stop calling it.
 - v8.99.763  Allow finite fluids to be drained correctly
 - v8.99.762  Merge pull request #2531 from Choonster/finite-fluid-drain-fix
              Allow finite fluids to be drained correctly
 - v8.99.761  Merge pull request #2587 from diesieben07/spawn_egg_fix
              Fix mod spawn eggs and EntityList.func_188429_b
 - v8.99.760  Merge pull request #2592 from matthewprenger/patch-1
              Pass exceptions thrown in mod event buses back to FML to handle appropriately
 - v8.99.759  Merge pull request #2593 from williewillus/dupedropfix
              [1.9] Fix double dropping of items. Closes #2549
 - v8.99.758  Merge pull request #2621 from Thutmose/patch-1
              Fix pushing players inside blocks.
 - v8.99.757  Fix pushing players inside blocks.
              same changes made to the 1.9 branch
 - v8.99.756  Merge pull request #2614 from williewillus/entitycaps
              Expose IItemHandler on vanilla entities
 - v8.99.755  Added support for custom dyes with Banners. Closes #2596
 - v8.99.754  Make RenderLivingBase.add/remvoeLayer, Closes #2573
 - v8.99.753  Fix pushing players inside blocks.
 - v8.99.752  Update according to suggestions
 - v8.99.751  Exclude jna from termal tansformer.
 - v8.99.750  Add ShieldDecoration and Tipped arrows to recipe sorter. Closes #2613
 - v8.99.749  Fixed Item.shouldCauseReequipAnimation hook.
 - v8.99.748  Fix Chests not opening correctly with semi-solid blocks on top.
 - v8.99.747  Merge pull request #2618 from Thutmose/patch-1
              Allow players sized smaller than 1 block to walk into small spaces
 - v8.99.746  Merge pull request #2605 from Thutmose/playersize
              Fixed players smaller than 1 block not being able to walk under overhang
 - v8.99.745  Rework DimensionManager for new DimensionType enum, replaces the old provider registry. Also fixed save folder issues with dimensions. Closes #2570
 - v8.99.744  Allow players sized smaller than 1 block to walk into small spaces
              Same as #2605 but for 1.9 branch
 - v8.99.743  Allow players sized smaller than 1 block to walk into small spaces
 - v8.99.742  Merge pull request #2612 from CovertJaguar/master
              Add missing Minecart/Track hook.
 - v8.99.741  Added default left hand transforms for forge transform strings. Closes #2615.
 - v8.99.740  Made VertexBuffer.sortVertexData cleanup pointers after it's done. Closes #2528.
 - v8.99.739  Ignore blocks/items with null registry name during model loading. Fixes NPE during resource reloading in worlds with removed blocks/items.
 - v8.99.738  Removed blockCenterToCorner from TRSRTransformation constructor. Closes #2461.
 - v8.99.737  Implemented slightly more generic version of UVLock, re-enabled it for json models. Closes #2607.
 - v8.99.736  Expose IItemHandler on vanilla entities
 - v8.99.735  Add missing Minecart/Track hook.
 - v8.99.734  instance -> INSTANCE
 - v8.99.733  Separated model classes to client and common packages.
 - v8.99.732  Switched animation system to capabilities, added animated item example, fixed state passing in MultiModel.
 - v8.99.731  Merge pull request #2610 from gigaherz/1.9-enchantment
              Fix for enchantment table rolling invalid enchants
 - v8.99.730  Merge pull request #2590 from blay09/patch-1
              [1.9] Fix KeyInputEvent only being fired if Keyboard.getEventKeyState() is false
 - v8.99.729  Merge pull request #2606 from CovertJaguar/1.9
              Fix #2601 Minecart infinite acceleration
 - v8.99.728  Fix a condition that caused the enchantment table to roll invalid enchantments.
 - v8.99.727  Fix #2601 Minecart infinite acceleration
 - v8.99.726  Fix EntityList.func_188429_b not supporting mod-entities, fixes spawn eggs, fixes #2581
 - v8.99.725  Merge pull request #2594 from Corosauce/master
              Fix for patch targetting the wrong field to change for failed pathfinding penalty
 - v8.99.724  Fix for patch targetting the wrong field to change for failed pathfinding penalty
 - v8.99.723  Merge pull request #2589 from diesieben07/player_riding_fix
              Fix broken patch in EntityPlayer.updateRidden
 - v8.99.722  Merge pull request #2586 from williewillus/fixcrops
              [1.9] Fix BlockCrops looking for wrong AGE property for subclasses. Fix #2555
 - v8.99.721  Merge pull request #2585 from iTitus/patch-1
              Fix the EntityPlayer patch
 - v8.99.720  Merge pull request #2584 from Corosauce/1.9
              Fix for patch targetting the wrong field to change for failed pathfinding penalty
 - v8.99.719  Fix bucket test
 - v8.99.718  Merge branch 'master' into 1.9
 - v8.99.717  Ignore classes directory
 - v8.99.716  Fix double dropping of items. Closes #2549
 - v8.99.715  Pass exceptions thrown in mod event buses back to FML to handle apropriately
 - v8.99.714  Fix KeyInputEvent only being fired if Keyboard.getEventKeyState() is false.
              It used to be called for both key-up and key-down states prior to 1.9, so I assume Vanilla's changes to F3 behavior broke the patch.
 - v8.99.713  Fix broken patch in EntityPlayer.updateRidden
 - v8.99.712  Fix #2555
 - v8.99.711  Fix the EntityPlayer patch
              In 1.8.9 the call goes to getDisplayNameString() so that any changes from the PlayerEvent.NameFormat event are being take into account.
              In this patch the call goes to func_70005_c_() which is the getter for the GameProfile name.
              I changed it back.
              Sorry if you do not want to accept it because it is a one-liner.
 - v8.99.710  Fix for patch targetting the wrong field to change for failed pathfinding penalty
 - v8.99.709  Fixed sprite not being passed to the quad builder for custom models.
 - v8.99.708  Fixed outline shader rendering, closes #2560.
 - v8.99.707  Fixed Block.doesSideBlockRendering, closes #2564.
 - v8.99.706  Fixed invalid index calculation in BakedQuadRetextured.
 - v8.99.705  Fix AT lines.
 - v8.99.704  Fixed quads that don't need diffuse lighting getting it anyway.
 - v8.99.703  Merge pull request #2559 from Adubbz/master
               BlockColors and ItemColors no longer assume non-Vanilla id constancy. Added a getter for ItemColors.
 - v8.99.702  Fixed MultiLayerModel not getting correct submodels; Unified the gui lighting of normal and custom models - diffuse lighting is now done in the pipeline, no need for IColoredBakedQuad anymore.
 - v8.99.701  BlockColors and ItemColors no longer assume non-Vanilla id constancy. Added a getter for ItemColors.
 - v8.99.700  Fixed NPE when sneak using a item.
 - v8.99.699  Fixed Sand not falling.
 - v8.99.698  Fixed onUseStop being called twice {Bows firing twice}
 - v8.99.697  Fix vanilla bug where bows consumed tipped arrows in creative.
 - v8.99.696  Remove our entity position fixer. Vanilla fixed the bug in 1.9.
 - v8.99.695  Javadocs, small cleanup.
 - v8.99.694  Fixed progress reporting for model loading.
 - v8.99.693  Removed imports in patches.
 - v8.99.692  Fixed EffectRenderer patch, closes #2547.
 - v8.99.691  Fixed incorrect culling of mod TESRs.
 - v8.99.690  Fixed incorrect rotations for items in the left hand. Closes #2548.
 - v8.99.689  Fixed model error reporting, fixed model errors in test mods that shouldn't happen, fixed custom texture loading, made more things private/final.
 - v8.99.688  Merge pull request #2544 from Vazkii/patch-1
              1.9: Fixed registering armor materials through EnumHelper exploding
 - v8.99.687  1.9: Fixed registering armor materials through EnumHelper exploding
              1.9 ArmorMaterial now requires a SoundEvent for the equip sound.
 - v8.99.686  Fixed breaking of tall grass. It now uses fortune. Expanded grass seed hooks to allow Fortune. Potentially removing in future in favor of LootTables.
 - v8.99.685  Fix digging blocks in survival.
 - v8.99.684  PlayerManager updated.
 - v8.99.683  Delete mcp patches.
 - v8.99.682  We are based on 1.9 not 1.8.9 :D
 - v8.99.681  Update patches for fixed inner class suffeling in srg files.
 - v8.99.680  Big model loader refactoring: simplified a lot of things, broke some error reporting. Still generally works.
 - v8.99.679  First version of updated of ModelLoader, mostly works.
 - v8.99.678  Fixed some errors in forge.exc
 - v8.99.677  Updated to latest mappings. Exc is broken, some anonymous classes didn't map to srg names.
 - v8.99.676  Merge pull request #2539 from bonii-xx/bugfix
              Fix CombinedInvWrapper accessing incorrect slots
 - v8.99.675  Fix CombinedInvWrapper accessing incorrect slots
              Closes #2533
 - v8.99.674  Switch to srg patches
 - v8.99.673  Fixed armor rendering
 - v8.99.672  Fixed incorrect rendering state caused by transparent rendering pass for entities.
 - v8.99.671  Fixed emply hand not rendering in first person.
 - v8.99.670  Capture Biome Registry within FML
 - v8.99.669  Fixed (hopefully) perspective transformations for custom models too.
 - v8.99.668  Fix items rendering too low in first person.
 - v8.99.667  Move the patch into the fml override handler, for less patch
 - v8.99.666  Fix race condition between server ticks and the netlogin code handshaking for FML
 - v8.99.665  Fix perspective transformations for left-handed items, disable ModelAnimationDebug until model loading is fixed.
 - v8.99.664  Fixed position being shifted before being sent to shouldSideBeRendered.
 - v8.99.663  Bump version info. Rather important.
 - v8.99.662  Added bypass functions to Defaulted registry, DO NOT USE THIS MODDERS FORGE INTERNAL ONLY.
              And some other fixups for running.
 - v8.99.661  Interaction hooks need to be re-added but compiles {Doesn't run}
 - v8.99.660  Fix up PlayerSP for the AT
 - v8.99.659  Another AT, for the player
 - v8.99.658  Finish world, chunkloading should work again?
 - v8.99.657  Potion cleanup. Moar fixes!
 - v8.99.656  Remove more chestgenhooks stuff. Clean up some more ATs
 - v8.99.655  More fixups, removing chestgenstuff aggressively. Use loot tables. Any missing ones WILL be added by Mojang.
 - v8.99.654  Another compilation fix
              More patch tweaks for compilation errors. onItemUseTick takes an entity now, cos skellies use stuff too
 - v8.99.653  Some more forge code fixes
 - v8.99.652  Most of ItemInWorldManager reject, various small error fixes.
 - v8.99.651  World
 - v8.99.650  10 more rejects down.
              98 errors 6 rejects left.
 - v8.99.649  More patch work, client patches.
 - v8.99.648  Allow finite fluids to be drained correctly
 - v8.99.647  Few more compile fixups
 - v8.99.646  Command fixups
 - v8.99.645  Remove two patches that aren't needed anymore
 - v8.99.644  Some client handler cleanup
 - v8.99.643  Fix up import in Potion
 - v8.99.642  Some more FML related fixups
 - v8.99.641  Some fixups for FML, and use the FML registry for potions
 - v8.99.640  NetworkDispatcher/FMLProxyPacket 41 more errors cleaned.
 - v8.99.639  Temporary hack to fix MCP mappings for param names we are using that is causing compile errors.
 - v8.99.638  Fishing is now a loot table no more need for FishingHooks. {LootTables still need to be evaludated if they need extra hooks, but thats later} Goodbye 44 compile errors!
 - v8.99.637  Fixed errrors in Fluids package. TODO: Make BlockLiquid implement IFluidBlock and REMOVE FluidContainerRegsitry. Everything *should* be able to use IFluidContainer directly.
 - v8.99.636  Made OBJModel.java compile.
 - v8.99.635  Model UV lock handling from the state to the model, fixed most compile errors in ModelLoader, disabled it (and ModelBakeEvent) until it's functional, fixed some errors in ForgeHooksClient.
 - v8.99.634  Removed generics from IModel subinterfaces, add ed ModelProcessingHelper instead.
 - v8.99.633  WorldServer: NOTE - ChestGenHooks has NOT been updated in accordance with plans for removing it
              GuiStats
              Fixup deletion of egg handling in entity registry?
 - v8.99.632  ServerPinger
              PlayerList
 - v8.99.631  ModelBox, PositionTextureVertex, TexturedQuad. Does anyone really use those on the server?
 - v8.99.630  LanguageManager
              NetHandlerPlayClient
 - v8.99.629  Fixed B3D loader, fixed some obvious errors in ModelLoader.
 - v8.99.628  Fix various errors in text mods.
 - v8.99.627  World Patches work.
 - v8.99.626  More work on misc things.
 - v8.99.625  Delete reject files i missed
 - v8.99.624  Merge pull request #2521 from Adubbz/master
              Updated BiomeManager to 1.9
 - v8.99.623  Updated BiomeManager to 1.9
 - v8.99.622  Merge pull request #2520 from Adubbz/master
              Updated the biome dictionary to support 1.9
 - v8.99.621  Enchantments, some world, Biomes, bucks, world/gen/features.
 - v8.99.620  Updated the biome dictionary
              Squashed commits:
              [4064de6] Updated the biome dictionary
 - v8.99.619  DedicatedServer
              IntegratedServer
 - v8.99.618  Chunk
 - v8.99.617  Updated raw types in ExtendedBlockState, fixed some ATs, updated some things that needed updating in model classes.
 - v8.99.616  removed Item.getModel, functionality is now achieveable via ItemOverrides.
 - v8.99.615  GuiOverlayDebug, ItemModelMesher, RenderManager, Stitcher fixed + minor fixes in forge gui classes.
 - v8.99.614  GuiCreateWorld, GuiSlot, GuiUtilRenderComponents, GuiContainerCreative
 - v8.99.613  Small renames before bed.
 - v8.99.612  Merge pull request #2514 from CovertJaguar/1.9
              Fix broken patches for EntityMinecart
 - v8.99.611  Items done, <1000 errors whoot!
 - v8.99.610  Fix broken patches for EntityMinecart
 - v8.99.609  Some entity patches.
 - v8.99.608  Fixed most errors in the model stuff, except for ModelLoader and b3d and obj getQuads/handleBlockState methods.
 - v8.99.607  FontRenderer
 - v8.99.606  tabs -> spaces.
 - v8.99.605  EntityRenderer, most of RenderGlobal, minor fix to LayerBipedArmor.
 - v8.99.604  RendererLivingEntity, RenderEntityItem, RenderItem, RenderManager, LayerArmorBase; Item.getModel + ISmartItemModel are now inside ItemOverrideList; fix class rename in TESR patch.
 - v8.99.603  A bunch of rendering rejects updated.
 - v8.99.602  Updated various block model patches.
 - v8.99.601  Some import renames and compile error fixes, killed ~800.
 - v8.99.600  util, tileentity, stats, realms. Potions got an overhaul and out registry will need to be adapted.
 - v8.99.599  net.minecraft.block.* patches
 - v8.99.598  First few patches applied
 - v8.99.597  Add rejects with mcp names for application to main codebase. Let's roll?
 - v8.99.596  Add in mcp named patches and use them. Initial 1.9 setup.
 - v8.99.595  Don't ignore rejects
 - v8.99.594  Merge pull request #2476 from Abastro/fovfixes
              Added Event: EntityViewRenderEvent#FOVModifier
 - v8.99.593  Merge pull request #2500 from me4502/master
              Added local click position to PlayerInteractEvent. Fixes #2482
 - v8.99.592  Added local click position to PlayerInteractEvent.
 - v8.99.591  Added EntityViewRenderEvent#FOVModifier
              Enables mods to modify raw FOV directly.
              Avoids modifier limit from FOVUpdateEvent.
              Aware of blocks which are needed for fov change related with materials.
 - v8.99.590  Fixed dummy blocks not being removed from registry on dedicated server correctly. Closes #2487
              Also added some more debug logs!
 - v8.99.589  Merge pull request #2497 from bonii-xx/universal_bucket
              Fix WordServer.canCreatureTypeSpawnHere not using Forge Events.
 - v8.99.588  Fix WordServer.canCreatureTypeSpawnHere not using Forge Events.
              Followup of #2496
 - v8.99.587  Merge pull request #2495 from elix-x/master
              Increased actual maximum fuel burn time
 - v8.99.586  Merge pull request #2496 from bonii-xx/universal_bucket
              Fix WorldEvent.PotentialSpawns Event passing the list instance of the…
 - v8.99.585  Fix WorldEvent.PotentialSpawns Event passing the list instance of the ChunkProvider to users
 - v8.99.584  Increased actual maximum fuel burn time
              Increased actual maximum fuel burn time from 32767 to 2147483647.
              Backwards compatible.
 - v8.99.583  ModelLoader: added verbose error logging showing items/blockstates associated with model locations; removed redundant cast leftover from ungenerified code; fixed up a couple of warnings.
 - v8.99.582  Fix race condition when using indexed codec in a LAN server. Fixes spurious crash when LAN server is running.
 - v8.99.581  Log when it's likely the indexedcodec is gonna fail, because of LAN server derps likely. Try and give some context for debuggers.
 - v8.99.580  Merge pull request #2488 from bonii-xx/universal_bucket
              Fix universal bucket logging an exception
 - v8.99.579  Fix universal bucket logging an exception
 - v8.99.578  Merge pull request #2485 from AlgorithmX2/world_getLightOpacity
              Test getLightOpacity(world,pos) in World as well as the chunk.
 - v8.99.577  Test getLightOpacity(world,pos) in World as well as the chunk.
 - v8.99.576  Merge pull request #2443 from AlgorithmX2/cap_pickup_entityitem
              Preserve ItemStack Caps when picking Items up.
 - v8.99.575  Preserve ItemStack Caps when picking Items up.
